/********************/
/* 時間割作成の実行 */
/********************/
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;

public class Execute extends Panel implements ActionListener
{
	Data_set DS;
	TextArea ta;
	Button bt1, bt2, bt3, bt4;
	int max_tri;   // 最大試行回数
	boolean go_ok = true;   // 実行できるか否かを示す
	Random rn;   // 乱数
	int count;   // 試行回数
	int count_a = 0;   // 評価値が同じ場合の試行回数
	String g_r_name[];   // 講義室の総称名（配列, Initialize）
	int g_to_r[];   // 総称名が示す個別講義室の範囲（講義室番号で指定）（配列, Initialize）
	String r_name[];   // 全個別講義室の名称（配列, Initialize）
	int s_nen[];   // 学年（配列, Initialize）
	String s_name[];   // 学科（配列, Initialize）
	int s_pos[];   // 各学年・学科の時間割表上の位置（配列, Initialize）
	               // 各時間割は，day * week コマからなる
	Input_Check in_check;
	Initialize init;
	Individual ind;
	ArrayList <Room> room;   // 講義室データ
	ArrayList <Teacher> teacher;   // 教員データ
	ArrayList <Lecture> lecture;   // 科目データ
	ArrayList <Gakka> gakka;   // 各学年の学科名
	ArrayList <R_Lecture> r_lecture;   // 科目データ（同時開講を考慮したもの）

	/******************/
	/* コンストラクタ */
	/******************/
	Execute(Data_set DS_i)
	{
		DS = DS_i;
					// レイアウト
		setLayout(new BorderLayout(5, 10));
					// データの設定と実行
		Panel p1 = new Panel();
		add(p1, BorderLayout.NORTH);
		p1.setLayout(new FlowLayout(FlowLayout.CENTER));
		p1.add(new Label("上に示したデータを設定（修正）し，右の実行ボタンをクリックしてください："));
		bt1 = new Button("実行");
		bt1.setBackground(Color.pink);
		bt1.addActionListener(this);
		p1.add(bt1);
					// 出力エリアの設定
		ta = new TextArea(10, 80);
		add(ta, BorderLayout.CENTER);
					// 実行制御ボタン
		Panel p2 = new Panel();
		add(p2, BorderLayout.SOUTH);
		p2.setLayout(new FlowLayout(FlowLayout.CENTER));
		bt2 = new Button("継続");
		bt2.setBackground(Color.cyan);
		bt2.addActionListener(this);
		bt2.setEnabled(false);
		p2.add(bt2);

		p2.add(new Label("　"));
		bt3 = new Button("再実行");
		bt3.setBackground(Color.cyan);
		bt3.addActionListener(this);
		bt3.setEnabled(false);
		p2.add(bt3);

		p2.add(new Label("　"));
		bt4 = new Button("出力");
		bt4.setBackground(Color.cyan);
		bt4.addActionListener(this);
		bt4.setEnabled(false);
		p2.add(bt4);
	}

	/******************************/
	/* ボタンが押されたときの処理 */
	/******************************/
	public void actionPerformed(ActionEvent e)
	{
		if (e.getSource() == bt1) {
			bt1.setEnabled(false);
			in_check = new Input_Check(this, DS);   // Input_Check オブジェクトの生成
			init     = new Initialize(this, DS);   // Initialize オブジェクトの生成
			ind      = new Individual(this, DS);   // Individual オブジェクトの生成
			max_tri  = DS.max_tri;
			control(0);
		}
		else if (e.getSource() == bt2) {
			bt2.setEnabled(false);
			bt3.setEnabled(false);
			bt4.setEnabled(false);
			max_tri += DS.max_tri;
			control(1);
		}
		else if (e.getSource() == bt3) {
			bt2.setEnabled(false);
			bt3.setEnabled(false);
			bt4.setEnabled(false);
			max_tri = DS.max_tri;
			control(0);
		}
		else if (e.getSource() == bt4) {
			bt2.setEnabled(true);
			bt3.setEnabled(true);
			bt4.setEnabled(false);
			ta.setText("");
			Output.result(this, DS, ind);
		}
	}

	/*******************************/
	/* 実行の制御                  */
	/*      sw : =0 : 最初から実行 */
	/*           =1 : 実行を継続   */
	/*******************************/
	void control(int sw)
	{
					// 講義室，教員，及び，科目データの入力と初期設定
		if (sw == 0) {
			in_check.input();    // データの入力
			go_ok = in_check.check();   // データのチェック
			if (go_ok) {
				init.initial_value();
				ArrayList <ArrayList <String>> temp = new ArrayList <ArrayList <String>> ();
				for (int i1 = 0; i1 < teacher.size(); i1++) {
					Teacher tc = (Teacher)teacher.get(i1);
					if (tc.no_yes)
						temp.add((ArrayList <String>)(tc.h_list));
				}
							// 初期配置（自動的に，5回試みる）
				int s = 0;
				for (int i1 = 0; i1 < 5 && s == 0; i1++) {
					go_ok = true;
					ind.initial_value();   // 値の初期設定
					s = ind.initial_arrange();   // 講義の初期配置
					if (s == 0 && i1 < 4) {
						ta.append("     --> 再度，試みてみます\n");
						int k = 0;
						for (int i2 = 0; i2 < teacher.size(); i2++) {
							Teacher tc = (Teacher)teacher.get(i2);
							if (tc.no_yes) {
								tc.h_list = new ArrayList <String> ((ArrayList <String>)temp.get(k));
								k++;
							}
						}
					}
				}

				ind.pi = ind.evaluation();   // 評価値の計算
				if (DS.o_lvl < 0)
					Output.debug(this, DS, 0, ind.sch.length, ind);
				if (go_ok)
					Output.mid_res(this, DS, count, ind);
				else
					bt3.setEnabled(true);
			}
			else
				bt3.setEnabled(true);
		}
					// 実行
		if (go_ok) {
			boolean ok = true;
			while (count < max_tri && ok) {
				ok = ind.neighbor_search();
				count++;
				if (DS.o_lvl > 0 && count%DS.o_lvl == 0 && count != max_tri && ok)
					Output.mid_res(this, DS, count, ind);
			}
			Output.mid_res(this, DS, count, ind);
			if (ok) {
				bt2.setEnabled(true);
				ta.append("***予定の実行回数を終了しました***\n");
			}
			else
				ta.append("***これ以上の改善は不可能です***\n");
			bt3.setEnabled(true);
			bt4.setEnabled(true);
		}
	}
}
