/**********/
/* 時間割 */
/**********/
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class Individual
{
	boolean r_use[][];   // 講義室の使用状況
	boolean r_use1[][];   // 講義室の使用状況
	int r_rat[];   // 講義室の使用回数
	int r_rat1[];   // 講義室の使用回数
	int sch[];   // 時間割
	int sch1[];   // 時間割
	int move[];   // 1:移動可能，0:曜日だけ変更可能，-1:移動不可能
	int move1[];   // 1:移動可能，0:曜日だけ変更可能，-1:移動不可能
	int cond[];   // 各制約条件に対する評価値
	int cond1[];   // 各制約条件に対する評価値
	int pi;   // 評価値
	int pi1;   // 評価値（旧）
	ArrayList <ArrayList <String>> room = new ArrayList <ArrayList <String>> ();
	Execute EX;
	Data_set DS;

	/******************/
	/* コンストラクタ */
	/******************/
	Individual(Execute EX_i, Data_set DS_i)
	{
		EX = EX_i;
		DS = DS_i;
	}

	/****************/
	/* 値の初期設定 */
	/****************/
	void initial_value()
	{
		int m = DS.day * DS.week;
					// 制約条件
		cond  = new int [DS.MAX_C];
		cond1 = new int [DS.MAX_C];
		for (int i1 = 0; i1 < DS.MAX_C; i1++)
			cond[i1] = 0;
					// 講義室の使用状況
		int n  = EX.r_name.length;
		r_use  = new boolean [m][n];
		r_use1 = new boolean [m][n];
		r_rat  = new int [n];
		r_rat1 = new int [n];
		for (int i1 = 0; i1 < n; i1++)
			r_rat[i1] = 0;
		for (int i1 = 0; i1 < m; i1++) {
			for (int i2 = 0; i2 < n; i2++)
				r_use[i1][i2] = false;
		}
					// 時間割表
		n     = m * EX.s_nen.length;
		sch   = new int [n];
		sch1  = new int [n];
		move  = new int [n];
		move1 = new int [n];
		for (int i1 = 0; i1 < n; i1++) {
			sch[i1]  = -1;
			move[i1] = 1;
		}
	}

	/***********************************/
	/* 講義の初期配置                  */
	/*      return : =-1 : エラー      */
	/*               =0 : 配置不可能   */
	/*               =1 : 初期配置成功 */
	/***********************************/
	int initial_arrange()
	{
		boolean st[] = new boolean[EX.r_lecture.size()];
		boolean ok   = true;
		int s        = 1;
					// 開講日時が指定されている講義の配置
		for (int i1 = 0; i1 < EX.r_lecture.size(); i1++) {
			st[i1] = false;
						// 指定されているか否かの判定
			R_Lecture rl = (R_Lecture)(EX.r_lecture.get(i1));
			int sw       = 0;
			Teacher tc   = null;
			Lecture lc   = null;
			for (int i2 = 0; i2 < rl.no.size() && sw == 0; i2++) {
				int k = Integer.parseInt((String)rl.no.get(i2));
				lc    = (Lecture)(EX.lecture.get(k));
				sw    = 0;
				for (int i3 = 0; i3 < lc.t_name.size() && sw == 0; i3++) {
					String str = (String)lc.t_name.get(i3);
					for (int i4 = 0; i4 < EX.teacher.size() && sw == 0; i4++) {
						tc = (Teacher)(EX.teacher.get(i4));
						if (str.equals(tc.name))
							sw = 1;
					}
					sw = 0;
					if (tc.no_yes)
						sw = 1;
				}
			}
						// 設定
			if (sw > 0) {
				if (tc.h_list.size() > 0) {
					int jigen = Integer.parseInt((String)tc.h_list.get(0)) - lc.y;
					if (rl.start > 0 && jigen%DS.day != rl.start-1)
						jigen = jigen / DS.day * DS.day + rl.start - 1;
					st[i1] = true;
					ok     = fix(i1, jigen);   // 指定された日時に講義を設定
					if (!ok) {
						EX.go_ok = false;
						s        = -1;
					}
				}
				else {
					EX.ta.append("教員（" + tc.name + "）の講義可能日数が少なすぎます\n");
					EX.go_ok = false;
					s        = -1;
				}
			}
		}
					// 開講時限が指定されている講義の配置
		if (EX.go_ok) {
			for (int i1 = 0; i1 < EX.r_lecture.size(); i1++) {
				if (!st[i1]) {
					R_Lecture rl = (R_Lecture)(EX.r_lecture.get(i1));
					if (rl.start > 0) {
						st[i1] = true;
						ok     = s_fix(i1);   // 指定された時限に講義を設定
						if (!ok) {
							EX.go_ok = false;
							s        = 0;
						}
					}
				}
			}
		}
					// その他の講義の配置
		if (EX.go_ok) {
			int max = 0;
			for (int i1 = 0; i1 < EX.gakka.size(); i1++) {
				Gakka gk = (Gakka)EX.gakka.get(i1);
				if (gk.name.size() > max)
					max = gk.name.size();
			}
			max *= DS.day;
			for (int i1 = max; i1 >= 1 && ok; i1--) {
				ok = free(st, i1);   // ランダムに講義を設定
				if (!ok) {
					s        = 0;
					EX.go_ok = false;
					EX.ta.append("***講義の初期配置に失敗しました***\n");
				}
			}

			if (ok)
				EX.ta.append("+++講義の初期配置に成功しました+++\n");
		}

		return s;
	}

	/********************************/
	/* 指定された日時に講義を設定   */
	/*      k : 講義番号            */
	/*      jigen : 時限            */
	/*      return : 配置可能か否か */
	/********************************/
	boolean fix(int k, int jigen)
	{
					// 位置の決定
		boolean ok   = true;
		int n        = 0;
		int p[]      = new int [EX.s_nen.length];
		R_Lecture rl = (R_Lecture)(EX.r_lecture.get(k));
		int k1       = Integer.parseInt((String)rl.no.get(0));
		Lecture lc   = (Lecture)(EX.lecture.get(k1));

		for (int i1 = 0; i1 < rl.no.size(); i1++) {
			k1 = Integer.parseInt((String)rl.no.get(i1));
			Lecture lc1 = (Lecture)(EX.lecture.get(k1));
			for (int i2 = 0; i2 < lc1.gakka.size(); i2++) {
				String str = (String)lc1.gakka.get(i2);
				int sw     = 0;
				for (int i3 = 0; i3 < EX.s_nen.length && sw == 0; i3++) {
					if (lc1.nen == EX.s_nen[i3] && str.equals(EX.s_name[i3])) {
						for (int i4 = 0; i4 < n && sw == 0; i4++) {
							if (p[i4] == EX.s_pos[i3])
								sw = 1;
						}
						if (sw == 0) {
							p[n] = EX.s_pos[i3];
							sw   = 1;
							n++;
						}
					}
				}
			}
		}
					// 設定
		ok = teacher_same(rl, jigen);   // 同じ科目担当教員の都合
		if (!ok)
			EX.go_ok = false;
		else {
			for (int i1 = 0; i1 < n; i1++) {
				int k2 = p[i1] + jigen;
				for (int i2 = 0; i2 < rl.koma; i2++) {
					if (sch[k2+i2] < 0) {
						Lecture lc1 = teacher_ck(k, k2, k2+i2);   // 教員の重なりをチェック
						if (lc1 == null) {
							sch[k2+i2]  = k;
							move[k2+i2] = -1;
						}
						else {
							ok = false;
							EX.ta.append("科目（" + lc1.k_name + "）と担当教員が重なっているため，科目（" + lc.k_name + "）を配置できません\n");
						}
					}
					else {
						ok            = false;
						R_Lecture rl1 = (R_Lecture)(EX.r_lecture.get(sch[k2+i2]));
						int k3        = Integer.parseInt((String)rl1.no.get(0));
						Lecture lc1   = (Lecture)(EX.lecture.get(k3));
						EX.ta.append("科目（" + lc1.k_name + "）がすでに配置されているため，科目（" + lc.k_name + "）を配置できません\n");
					}
				}
			}
		}
					// 講義室の設定
		if (ok) {
			ok = room_set(k, jigen);   // 講義室の設定
			if (!ok)
				EX.ta.append("科目（" + lc.k_name + "）の講義室が確保できません\n");
		}

		return ok;
	}

	/**************************/
	/* 同じ科目担当教員の都合 */
	/*      rl : 講義         */
	/*      jigen : 時限      */
	/*      return : OKか否か */
	/**************************/
	boolean teacher_same(R_Lecture rl, int jigen)
	{
		boolean ok = true;

		for (int i1 = 0; i1 < rl.no.size(); i1++) {
			int k1     = Integer.parseInt((String)rl.no.get(i1));
			Lecture lc = (Lecture)(EX.lecture.get(k1));
			for (int i2 = 0; i2 < lc.t_name.size(); i2++) {
				String str = (String)lc.t_name.get(i2);
				int sw     = 0;
				for (int i3 = 0; i3 < EX.teacher.size() && sw == 0; i3++) {
					Teacher tc = (Teacher)(EX.teacher.get(i3));
					if (str.equals(tc.name)) {
						sw = 1;
						if (tc.no_yes) {
							if (tc.h_list.size() > 0) {
								for (int i4 = 0; i4 < tc.h_list.size() && sw == 1; i4++) {
									k1 = Integer.parseInt((String)tc.h_list.get(i4));
									if (k1 == jigen+lc.y) {
										sw = 2;
										tc.h_list.remove(i4);
									}
								}
								if (sw == 1) {
									EX.ta.append("教員（" + tc.name + "）の都合がつきません\n");
									ok = false;
								}
							}
							else {
								EX.ta.append("教員（" + tc.name + "）の講義可能日数が少なすぎます\n");
								ok = false;
							}
						}
					}
				}
			}
		}

		return ok;
	}

	/******************************/
	/* 指定された時限に講義を設定 */
	/*      k : 講義番号          */
	/******************************/
	boolean s_fix(int k)
	{
					// 位置の決定
		boolean ok   = true;
		int m        = DS.day * DS.week;
		int n        = 0;
		int p[]      = new int [EX.s_nen.length];
		R_Lecture rl = (R_Lecture)(EX.r_lecture.get(k));
		int k1       = Integer.parseInt((String)rl.no.get(0));
		Lecture lc   = (Lecture)(EX.lecture.get(k1));

		for (int i1 = 0; i1 < rl.no.size(); i1++) {
			k1          = Integer.parseInt((String)rl.no.get(i1));
			Lecture lc1 = (Lecture)(EX.lecture.get(k1));
			for (int i2 = 0; i2 < lc1.gakka.size(); i2++) {
				String str = (String)lc1.gakka.get(i2);
				int sw     = 0;
				for (int i3 = 0; i3 < EX.s_nen.length && sw == 0; i3++) {
					if (lc1.nen == EX.s_nen[i3] && str.equals(EX.s_name[i3])) {
						for (int i4 = 0; i4 < n && sw == 0; i4++) {
							if (p[i4] == EX.s_pos[i3])
								sw = 1;
						}
						if (sw == 0) {
							p[n] = EX.s_pos[i3];
							sw   = 1;
							n++;
						}
					}
				}
			}
		}
					// 日時の設定
		int sw = 0;
		k1     = (int)(DS.week * EX.rn.nextDouble());
		if (k1 >= DS.week)
			k1 = DS.week - 1;
		k1 = k1 * DS.day + rl.start - 1;
		for (int i0 = 0; i0 < DS.week && sw == 0; i0++) {
			ok = true;
			for (int i1 = 0; i1 < n && ok; i1++) {
				int k2 = p[i1] + k1;
				for (int i2 = 0; i2 < rl.koma && ok; i2++) {
					if (sch[k2+i2] < 0) {
						Lecture lc1 = teacher_ck(k, k2, k2+i2);   // 教員の重なりをチェック
						if (lc1 != null)
							ok = false;
						else {
							for (int i3 = 0; i3 < rl.no.size() && ok; i3++) {
								int k3  = Integer.parseInt((String)rl.no.get(i3));
								lc1     = (Lecture)(EX.lecture.get(k3));
								for (int i4 = 0; i4 < lc1.t_name.size() && ok; i4++) {
									String str = (String)lc1.t_name.get(i4);
									Teacher tc  = null;
									for (int i5 = 0; i5 < EX.teacher.size() && sw == 0; i5++) {
										tc = (Teacher)(EX.teacher.get(i5));
										if (str.equals(tc.name))
											sw = 1;
									}
									sw = 0;
									for (int i5 = 0; i5 < tc.h_list.size() && ok; i5++) {
										k3 = Integer.parseInt((String)tc.h_list.get(i5));
										if (k3 == (k2+i2)%m)
											ok = false;
									}
								}
							}
						}
					}
					else
						ok = false;
				}
			}
					// 講義室の設定
			if (ok) {
				ok = room_set(k, k1);   // 講義室の設定
				if (ok)
					sw = 1;
				else {
					if (rl.room.size() > 0)
						room_reset(k);   // 講義室の解放
				}
			}

			if (sw == 0) {
				k1 += DS.day;
				if (k1 >= m)
					k1 = rl.start - 1;
			}
		}

		if (sw > 0) {
			ok = true;
			for (int i1 = 0; i1 < n; i1++) {
				int k2 = p[i1] + k1;
				for (int i2 = 0; i2 < rl.koma; i2++) {
					sch[k2+i2]  = k;
					move[k2+i2] = rl.fix ? -1 : 0;
				}
			}
		}
		else {
			EX.ta.append("科目（" + lc.k_name + "）を配置できませんでした\n");
			ok = false;
		}

		return ok;
	}

	/**************************************/
	/* ランダムに講義を設定               */
	/*      st : 配置済みか否か           */
	/*      no : 対象学科数×コマ数の下限 */
	/**************************************/
	boolean free(boolean st[], int no)
	{
					// 初期設定
		int p[]       = new int [EX.s_nen.length];
		int tm[]      = new int [st.length];
		int m         = DS.day * DS.week;
		boolean ok    = true;
		boolean st1[] = new boolean [st.length];
		for (int i1 = 0; i1 < st.length; i1++)
			st1[i1] = st[i1];
		int sch1[] = new int [sch.length];
		for (int i1 = 0; i1 < sch.length; i1++)
			sch1[i1] = sch[i1];
					// 配置
		for (int i1 = 0; i1 < EX.r_lecture.size(); i1++) {
			if (!st[i1]) {
						// 位置の決定
				int n        = 0;
				R_Lecture rl = (R_Lecture)(EX.r_lecture.get(i1));
				int k1       = Integer.parseInt((String)rl.no.get(0));
				Lecture lc   = (Lecture)(EX.lecture.get(k1));
				for (int i2 = 0; i2 < rl.no.size(); i2++) {
					k1          = Integer.parseInt((String)rl.no.get(i2));
					Lecture lc1 = (Lecture)(EX.lecture.get(k1));
					for (int i3 = 0; i3 < lc1.gakka.size(); i3++) {
						String str = (String)lc1.gakka.get(i3);
						int sw     = 0;
						for (int i4 = 0; i4 < EX.s_nen.length && sw == 0; i4++) {
							if (lc1.nen == EX.s_nen[i4] && str.equals(EX.s_name[i4])) {
								for (int i5 = 0; i5 < n && sw == 0; i5++) {
									if (p[i5] == EX.s_pos[i4])
										sw = 1;
								}
								if (sw == 0) {
									p[n] = EX.s_pos[i4];
									sw   = 1;
									n++;
								}
							}
						}
					}
				}
						// 配置
				if (n*rl.koma >= no) {
					int sw = 0;
					k1     = (int)(m * EX.rn.nextDouble());
					if (k1 >= m)
						k1 = m - 1;
					for (int i2 = 0; i2 < m && sw == 0; i2++) {
						sw = 1;
						for (int i3 = 0; i3 < n && sw > 0; i3++) {
							int k2 = p[i3] + k1;
							for (int i4 = 0; i4 < rl.koma && sw > 0; i4++) {
								if ((k1%DS.day)+i4 >= DS.day || k2+i4 >= sch1.length || sch1[k2+i4] >= 0)
									sw = 0;
							}
						}
						if (sw > 0) {
							st1[i1] = true;
							tm[i1]  = k1;
							for (int i3 = 0; i3 < n; i3++) {
								int k2 = p[i3] + k1;
								for (int i4 = 0; i4 < rl.koma; i4++)
									sch1[k2+i4] = i1;
							}
						}
						else {
							k1++;
							if (k1 >= m)
								k1 = 0;
						}
					}

					if (sw == 0) {
						EX.ta.append("    free 科目（" + lc.k_name + "）を配置できませんでした！\n");
						ok = false;
					}
				}
			}
		}
					// 実際の配置
		if (ok) {
			for (int i1 = 0; i1 < st.length; i1++) {
				if (st1[i1] && !st[i1]) {
					R_Lecture rl = (R_Lecture)(EX.r_lecture.get(i1));
					if (rl.room.size() == 0)
						room_set(i1, tm[i1]);   // 講義室の設定
					st[i1] = true;
				}
			}
			for (int i1 = 0; i1 < sch.length; i1++)
				sch[i1]  = sch1[i1];
		}

		return ok;
	}

	/*********************/
	/* 講義室の解放      */
	/*      k : 講義番号 */
	/*********************/
	void room_reset(int k)
	{
		R_Lecture rl = (R_Lecture)(EX.r_lecture.get(k));
		for (int i1 = 0; i1 < rl.room.size(); i1 += 2) {
			int k1 = Integer.parseInt((String)rl.room.get(i1+1));
			if (k1 >= 0) {
				int kk        = Integer.parseInt((String)rl.room.get(i1));
				r_use[kk][k1] = false;
				r_rat[k1]--;
			}
		}
		rl.room.clear();
	}

	/********************************/
	/* 講義室の設定                 */
	/*      k : 講義番号            */
	/*      p : 位置                */
	/*      return : 設定可能か否か */
	/********************************/
	boolean room_set(int k, int p)
	{
		boolean ok   = true;
		R_Lecture rl = (R_Lecture)(EX.r_lecture.get(k));
					// 講義室の設定
		for (int i1 = 0; i1 < rl.no.size(); i1++) {
			int k1     = Integer.parseInt((String)rl.no.get(i1));
			Lecture lc = (Lecture)(EX.lecture.get(k1));
			for (int i2 = 0; i2 < lc.room.size(); i2++) {
						// 講義室を指定する
				int sw     = 0;
				String str = (String)lc.room.get(i2);
				for (int i3 = 0; i3 < EX.r_name.length && sw == 0; i3++) {
					if (str.equals(EX.r_name[i3])) {
						sw = 1;
						for (int i4 = 0; i4 < lc.koma; i4++) {
							rl.room.add(Integer.toString(p+i4+lc.y));
							if (r_use[p+i4+lc.y][i3]) {
								rl.room.add("-1");
								ok = false;
							}
							else {
								r_use[p+i4+lc.y][i3] = true;
								r_rat[i3]++;
								rl.room.add(Integer.toString(i3));
							}
						}
					}
				}
						// 講義室を指定しない
				if (sw == 0) {
							// 目標講義室
					int k2 = -1;
					for (int i3 = 0; i3 < EX.g_r_name.length && k2 < 0; i3++) {
						if (str.equals(EX.g_r_name[i3]))
							k2 = i3;
					}
					for (int i3 = EX.g_to_r[2*k2]; i3 <= EX.g_to_r[2*k2+1] && sw == 0; i3++) {
						sw = 1;
						for (int i4 = 0; i4 < lc.koma && sw > 0; i4++) {
							if (r_use[p+i4+lc.y][i3])
								sw = 0;
						}
						if (sw > 0) {
							for (int i4 = 0; i4 < lc.koma; i4++) {
								r_use[p+i4+lc.y][i3] = true;
								r_rat[i3]++;
								rl.room.add(Integer.toString(p+i4+lc.y));
								rl.room.add(Integer.toString(i3));
							}
						}
					}
							// 代替講義室
					if (sw == 0) {
						for (int i3 = 0; i3 < lc.r_room.size() && sw == 0; i3++) {
							String str1 = (String)lc.r_room.get(i3);
							k2          = -1;
							for (int i4 = 0; i4 < EX.g_r_name.length && k2 < 0; i4++) {
								if (str1.equals(EX.g_r_name[i4]))
									k2 = i4;
							}
							for (int i4 = EX.g_to_r[2*k2]; i4 <= EX.g_to_r[2*k2+1] && sw == 0; i4++) {
								sw = 1;
								for (int i5 = 0; i5 < lc.koma && sw > 0; i5++) {
									if (r_use[p+i5+lc.y][i4])
										sw = 0;
								}
								if (sw > 0) {
									for (int i5 = 0; i5 < lc.koma; i5++) {
										r_use[p+i5+lc.y][i4] = true;
										r_rat[i4]++;
										rl.room.add(Integer.toString(p+i5+lc.y));
										rl.room.add(Integer.toString(i4));
									}
								}
							}
						}
					}
							// 講義室がない
					if (sw == 0) {
						ok = false;
						for (int i3 = 0; i3 < lc.koma; i3++) {
							rl.room.add(Integer.toString(p+i3+lc.y));
							rl.room.add("-1");
						}
					}
				}
			}
		}

		return ok;
	}

	/********************************************/
	/* 教員の重なりをチェック                   */
	/*      k : 講義番号                        */
	/*      pb : 基準位置                       */
	/*      p : 位置                            */
	/*      return : 重なっている講義           */
	/*               （nullの場合は重なりなし） */
	/********************************************/
	Lecture teacher_ck(int k, int pb, int p)
	{
		Lecture lc2  = null;
		R_Lecture rl = (R_Lecture)(EX.r_lecture.get(k));
		int m        = DS.day * DS.week;

		for (int i1 = 0; i1 < rl.no.size() && lc2 == null; i1++) {
			int k1     = Integer.parseInt((String)rl.no.get(i1));
			Lecture lc = (Lecture)(EX.lecture.get(k1));
			if (p%m >= (pb+lc.y)%m && p%m < (pb+lc.y)%m+lc.koma) {
				for (int i2 = 0; i2 < lc.t_name.size() && lc2 == null; i2++) {
					String name = (String)lc.t_name.get(i2);
					for (int i3 = p%m; i3 < sch.length && lc2 == null; i3 += m) {
						if (sch[i3] >= 0 && sch[i3] != k) {
							R_Lecture rl1 = (R_Lecture)(EX.r_lecture.get(sch[i3]));
							for (int i4 = 0; i4 < rl1.no.size() && lc2 == null; i4++) {
								k1          = Integer.parseInt((String)rl1.no.get(i4));
								Lecture lc1 = (Lecture)(EX.lecture.get(k1));
								int k2      = -1;
								for (int i5 = i3-1; i5 >= 0 && k2 < 0; i5--) {
									if (sch[i5] != sch[i3])
										k2 = i5 + 1;
								}
								if (k2 < 0)
									k2 = 0;
								if (p%m >= (k2+lc1.y)%m && p%m < (k2+lc1.y)%m+lc1.koma) {
									for (int i5 = 0; i5 < lc1.t_name.size() && lc2 == null; i5++) {
										String name1 = (String)lc1.t_name.get(i5);
										if (name1.equals(name))
											lc2 = lc1;
									}
								}
							}
						}
					}
				}
			}
		}

		return lc2;
	}

	/******************************************/
	/* 教員の重なりに対する評価               */
	/*      p : 位置                          */
	/*      return : 教員が重複している講義数 */
	/******************************************/
	int teacher_ck(int p)
	{
		int s        = 0;
		int k        = sch[p];
		R_Lecture rl = (R_Lecture)(EX.r_lecture.get(k));
		int m        = DS.day * DS.week;

		for (int i1 = 0; i1 < rl.no.size(); i1++) {
			int k1     = Integer.parseInt((String)rl.no.get(i1));
			Lecture lc = (Lecture)(EX.lecture.get(k1));
			k1         = -1;
			for (int i2 = p-1; i2 >= 0 && k1 < 0; i2--) {
				if (sch[i2] != sch[p])
					k1 = i2 + 1;
			}
			if (k1 < 0)
				k1 = 0;
			if (p%m >= (k1+lc.y)%m && p%m < (k1+lc.y)%m+lc.koma) {
				for (int i2 = 0; i2 < lc.t_name.size(); i2++) {
					String name   = (String)lc.t_name.get(i2);
					String k_name = null;
					for (int i3 = p+m; i3 < sch.length; i3 += m) {
						if (sch[i3] >= 0 && sch[i3] != k) {
							R_Lecture rl1 = (R_Lecture)(EX.r_lecture.get(sch[i3]));
							for (int i4 = 0; i4 < rl1.no.size(); i4++) {
								k1          = Integer.parseInt((String)rl1.no.get(i4));
								Lecture lc1 = (Lecture)(EX.lecture.get(k1));
								if (k_name == null || !lc1.k_name.equals(k_name)) {
									int k2  = -1;
									for (int i5 = i3-1; i5 >= 0 && k2 < 0; i5--) {
										if (sch[i5] != sch[i3])
											k2 = i5 + 1;
									}
									if (k2 < 0)
										k2 = 0;
									if (p%m >= (k2+lc1.y)%m && p%m < (k2+lc1.y)%m+lc1.koma) {
										for (int i5 = 0; i5 < lc1.t_name.size(); i5++) {
											String name1 = (String)lc1.t_name.get(i5);
											if (name1.equals(name)) {
												s++;
												k_name = lc1.k_name;
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}

		return s;
	}

	/****************/
	/* 評価値の計算 */
	/****************/
	int evaluation()
	{
		int s    = 0;
		int m    = DS.day * DS.week;
		int kd[] = new int [DS.day];
		for (int i1 = 0; i1 < cond.length; i1++)
			cond[i1] = 0;
					// 講義室不足
		for (int i1 = 0; i1 < EX.r_lecture.size(); i1++) {
			R_Lecture rl = (R_Lecture)EX.r_lecture.get(i1);
			for (int i2 = 0; i2 < rl.room.size(); i2 += 2) {
				int k1 = Integer.parseInt((String)rl.room.get(i2+1));
				if (k1 < 0)
					cond[1] += DS.weight[1];
			}
		}
					// 教員の重なり
		for (int i1 = 0; i1 < m; i1++) {
			for (int i2 = i1; i2 < sch.length-m; i2 += m) {
				if (sch[i2] >= 0)
					cond[2] += DS.weight[2] * teacher_ck(i2);
			}
		}
					// 複数コマ講義の中断，教員の都合，実験科目
		for (int i1 = 0; i1 < sch.length; i1++) {
			if (sch[i1] >= 0) {
				R_Lecture rl = (R_Lecture)EX.r_lecture.get(sch[i1]);
				int now      = i1 % m;
				int sw       = 0;
				int jigen    = 0;
				for (int i2 = i1-1; i2 >= 0 && sw == 0; i2--) {
					if (sch[i2] != sch[i1]) {
						jigen = i2 + 1;
						sw    = 1;
					}
				}
				jigen %= m;
						// 教員の都合
				boolean jikken = false;
				boolean hisshu = false;
				sw             = 0;
				Lecture lc     = null;
				for (int i2 = 0; i2 < rl.no.size() && sw == 0; i2++) {
					int k1 = Integer.parseInt((String)rl.no.get(i2));
					lc     = (Lecture)(EX.lecture.get(k1));
					if (lc.kind > 0)
						hisshu = true;
					if (lc.k_name.lastIndexOf("実験") >= 0)
						jikken = true;
					if (move[i1] >= 0 && now >= jigen+lc.y && now < jigen+lc.y+lc.koma) {
						Teacher tc = null;
						for (int i3 = 0; i3 < lc.t_name.size() && sw == 0; i3++) {
							String str = (String)lc.t_name.get(i3);
							for (int i4 = 0; i4 < EX.teacher.size() && sw == 0; i4++) {
								tc = (Teacher)(EX.teacher.get(i4));
								if (str.equals(tc.name))
									sw = 1;
							}
						}
						sw = 0;
						for (int i3 = 0; i3 < tc.h_list.size() && sw == 0; i3++) {
							k1 = Integer.parseInt((String)tc.h_list.get(i3));
							if (k1 == now)
								sw = 1;
						}
					}
				}
				if (sw > 0)
					cond[3] += DS.weight[3];
						// 複数コマ講義の中断
				if (rl.koma > 1 && jigen == now) {
					int k1 = jigen % DS.day + 1;
					int k2 = jigen % DS.day + rl.koma;
					if (k1 <= DS.mor && k2 > DS.mor || k2 > DS.day)
						cond[4] += DS.weight[4];
				}
						// 実験科目
				if (jikken && move[i1] >= 0 && jigen == now) {
					int k1 = jigen % DS.day + 1;
					int k2 = jigen % DS.day + rl.koma;
							// 実験の位置（午前中）
					if (k1 <= DS.mor && k2 <= DS.mor)
						cond[6] += DS.weight[6];
							// 実験の位置（中間）
					else if (k1 > DS.mor && k2 < DS.day)
						cond[5] += DS.weight[5];
				}
			}
		}
					// 配置（科目間）(大学用)
		if (DS.univ == 0) {
			for (int i1 = 0; i1 < sch.length; i1 += DS.day) {
						// 科目の配置を調べる
				int k = 0;
				for (int i2 = i1; i2 < i1+DS.day; i2++) {
					if (sch[i2] < 0)
						kd[k] = -1;
					else {
						R_Lecture rl = (R_Lecture)EX.r_lecture.get(sch[i2]);
						int sw       = 0;
						for (int i3 = 0; i3 < rl.no.size() && sw == 0; i3++) {
							int k1     = Integer.parseInt((String)rl.no.get(i3));
							Lecture lc = (Lecture)(EX.lecture.get(k1));
							if (lc.kind > 0)
								sw = 1;
						}
						kd[k] = sw;
					}
					k++;
				}
						// 講義間に空き時間
						// 必修科目間に空き時間または選択科目
				int k1 = -1;
				int k2 = -1;
				for (int i2 = 0; i2 < DS.day; i2++) {
					if (kd[i2] >= 0) {
						if (k1 >= 0)
							cond[7] += (i2 - k1 - 1) * DS.weight[7];
						k1 = i2;
						if (kd[i2] > 0) {
							if (k2 >= 0)
								cond[8] += (i2 - k2 - 1) * DS.weight[8];
							k2 = i2;
						}
					}
				}
			}
		}
					// 配置（科目間）(高校用)
		else {
			for (int i1 = 0; i1 < sch.length; i1 += DS.day) {
				for (int i2 = i1; i2 < i1+DS.day-1; i2++) {
					if (sch[i2] >= 0) {
						R_Lecture rl1 = (R_Lecture)EX.r_lecture.get(sch[i2]);
						int k1        = Integer.parseInt((String)rl1.no.get(0));
						Lecture lc1   = (Lecture)(EX.lecture.get(k1));
						for (int i3 = i2+rl1.koma; i3 < i1+DS.day; i3++) {
							if (sch[i3] >= 0) {
								R_Lecture rl2 = (R_Lecture)EX.r_lecture.get(sch[i3]);
								k1            = Integer.parseInt((String)rl2.no.get(0));
								Lecture lc2   = (Lecture)(EX.lecture.get(k1));
								if (lc1.k_name.equals(lc2.k_name))
									cond[7] += DS.weight[7];
								i3 += (rl2.koma - 1);
							}
						}
					}
				}
			}
		}

		int sw = 0;
		for (int i1 = 0; i1 < cond.length; i1++) {
			s += cond[i1];
			if (i1 < 4 && cond[i1] > 0)
				sw = 1;
		}
		if (sw > 0)
			s = -s;

		return s;
	}

	/****************************/
	/* 近傍探索                 */
	/*      return : 成功か否か */
	/****************************/
	boolean neighbor_search()
	{
		int koma_s = -1, m2_s = -1, m3_s = -1, ok = -1;
		int ob[] = new int [EX.s_nen.length+1];
		int ob_s[] = new int [EX.s_nen.length+1];
		boolean res = true, same = false;
					// 現在状態の保存
		int m = DS.day * DS.week;
		pi1   = pi;
		for (int i1 = 0; i1 < cond.length; i1++)
			cond1[i1] = cond[i1];
		for (int i1 = 0; i1 < EX.r_name.length; i1++)
			r_rat1[i1] = r_rat[i1];
		for (int i1 = 0; i1 < m; i1++) {
			for (int i2 = 0; i2 < EX.r_name.length; i2++)
				r_use1[i1][i2] = r_use[i1][i2];
		}
		for (int i1 = 0; i1 < EX.r_lecture.size(); i1++) {
			R_Lecture rl = (R_Lecture)(EX.r_lecture.get(i1));
			room.add(new ArrayList <String> (rl.room));
		}
		for (int i1 = 0; i1 < sch.length; i1++) {
			sch1[i1]  = sch[i1];
			move1[i1] = move[i1];
		}
					// 学科，学年の選択
		int m1 = (int)(EX.s_nen.length * EX.rn.nextDouble());
		if (m1 >= EX.s_nen.length)
			m1 = EX.s_nen.length - 1;
		m1 *= m;

		for (int i1 = 0; i1 < EX.s_nen.length && ok <= 0; i1++) {
					// 科目の選択（その1）
			int m2 = (int)(m * EX.rn.nextDouble());
			if (m2 >= m)
				m2 = m - 1;
			int sw = 0;
			while (sw == 0) {
				if (m2 == 0)
					sw = 1;
				else {
					if (sch[m1+m2-1] < 0 || sch[m1+m2-1] != sch[m1+m2])
						sw = 1;
					else
						m2--;
				}
			}

			for (int i2 = 0; i2 < m && ok <= 0; i2++) {
					// 科目の選択（その2）
				int k1;
				if (sch[m1+m2] >= 0) {
					R_Lecture rl = (R_Lecture)EX.r_lecture.get(sch[m1+m2]);
					k1           = m2 + rl.koma;
				}
				else
					k1 = m2 + 1;

				for (int i3 = k1; i3 < m && ok <= 0; i3++) {
					int m3   = i3;
					int koma = change_check(m1+m2, m1+m3, ob);   // 交換可能か
					if (koma > 0) {
						ok = change((m1+m2)%m, (m1+m3)%m, ob, koma, false);   // 交換
						if (ok == 0 && !same) {
							same   = true;
							m2_s   = (m1 + m2) % m;
							m3_s   = (m1 + m3) % m;
							koma_s = koma;
							for (int i4 = 0; i4 < ob_s.length; i4++)
								ob_s[i4] = ob[i4];
						}
					}
					if (ok <= 0) {
						if (sch[m1+m3] >= 0) {
							R_Lecture rl = (R_Lecture)EX.r_lecture.get(sch[m1+m3]);
							if (rl.koma > 1) {
								m3 += (rl.koma - 1);
								i3 += (rl.koma - 1);
							}
						}
						m3++;
					}
				}

				if (ok <= 0) {
					if (sch[m1+m2] >= 0) {
						R_Lecture rl = (R_Lecture)EX.r_lecture.get(sch[m1+m2]);
						if (rl.koma > 1) {
							m2 += (rl.koma - 1);
							i2 += (rl.koma - 1);
						}
					}
					m2++;
					if (m2 >= m)
						m2 = 0;
				}
			}

			if (ok <= 0) {
				m1 += m;
				if (m1 >= m * EX.s_nen.length)
					m1 = 0;
			}
		}

		if (ok > 0)
			EX.count_a = 0;
		else {
			res = false;
			if (same && pi != 0) {
				EX.count_a++;
				if (EX.count_a < DS.max_tri) {
					ok  = change(m2_s, m3_s, ob_s, koma_s, true);
					res = true;
				}
			}
		}

		room.clear();

		return res;
	}

	/************************************/
	/* 位置の交換が可能か否かのチェック */
	/*      m1, m2 : 2つの位置          */
	/*      ob : 交換対象位置           */
	/*      return : コマ数             */
	/************************************/
	int change_check(int m1, int m2, int ob[])
	{

		int koma = 0;
		int m    = DS.day * DS.week;
		int k1   = m1 % m;
		int k2   = m2 % m;
		ob[0]    = 1;
		ob[1]    = m1 / m;
		ArrayList <String> temp = new ArrayList <String> ();
					// コマ数のチェック（自学科）
		if (sch[m1] >= 0) {
			R_Lecture rl1  = (R_Lecture)EX.r_lecture.get(sch[m1]);
			koma           = rl1.koma;
			temp.add(Integer.toString(sch[m1]));
			if (sch[m2] >= 0) {
				R_Lecture rl2 = (R_Lecture)EX.r_lecture.get(sch[m2]);
				temp.add(Integer.toString(sch[m2]));
				if (rl2.koma != koma) {
					int k;
					if (rl2.koma > koma) {
						k    = m1;
						koma = rl2.koma;
					}
					else
						k = m2;
					int kk = 0;
					while (kk < koma) {
						if (k >= sch.length)
							kk = koma + 1;
						else {
							if (sch[k] < 0) {
								kk++;
								k++;
							}
							else {
								if (kk > 0)
									temp.add(Integer.toString(sch[k]));
								R_Lecture rl = (R_Lecture)EX.r_lecture.get(sch[k]);
								kk += rl.koma;
								k  += rl.koma;
							}
						}
					}
					if (kk > koma || k1+kk > m || k2+kk > m)
						koma = 0;
				}
			}
			else {
				int kk = 1;
				int k  = m2 + 1;
				while (kk < koma) {
					if (k >= sch.length)
						kk = koma + 1;
					else {
						if (sch[k] < 0) {
							kk++;
							k++;
						}
						else {
							temp.add(Integer.toString(sch[k]));
							R_Lecture rl = (R_Lecture)EX.r_lecture.get(sch[k]);
							kk += rl.koma;
							k  += rl.koma;
						}
					}
				}
				if (kk > koma || k1+kk > m || k2+kk > m)
					koma = 0;
			}
		}
		else {
			if (sch[m2] >= 0) {
				temp.add(Integer.toString(sch[m2]));
				R_Lecture rl2  = (R_Lecture)EX.r_lecture.get(sch[m2]);
				koma           = rl2.koma;
				int kk         = 1;
				int k          = m1 + 1;
				while (kk < koma) {
					if (k >= sch.length)
						kk = koma + 1;
					else {
						if (sch[k] < 0) {
							kk++;
							k++;
						}
						else {
							temp.add(Integer.toString(sch[k]));
							R_Lecture rl = (R_Lecture)EX.r_lecture.get(sch[k]);
							kk += rl.koma;
							k  += rl.koma;
						}
					}
				}
				if (kk > koma || k1+kk > m || k2+kk > m)
					koma = 0;
			}
			else
				koma = 0;
		}
					// コマ数のチェック（他学科）
		if (koma > 0 && (m2 >= m1+koma || m1 >= m2+koma)) {
			int sw0 = 1;
			while (sw0 > 0) {
				sw0 = 0;
				for (int i1 = 0; i1 < sch.length && koma > 0; i1 += m) {
					int sw = 0;
					for (int i2 = 1; i2 <= ob[0] && sw == 0; i2++) {
						if (i1/m == ob[i2])
							sw = 1;
					}
					if (sw == 0) {
						for (int i2 = 0; i2 < koma; i2++) {
							if (i1+k1+i2 < sch.length && sch[i1+k1+i2] >= 0 && temp.contains(Integer.toString(sch[i1+k1+i2])))
								sw = 1;
							if (i1+k2+i2 < sch.length && sch[i1+k2+i2] >= 0 && temp.contains(Integer.toString(sch[i1+k2+i2])))
								sw = 1;
						}
						if (sw > 0) {
							if (k1 > 0 && sch[i1+k1-1] >= 0 && sch[i1+k1-1] == sch[i1+k1])
								koma = 0;
							else if (k2 > 0 && sch[i1+k2-1] >= 0 && sch[i1+k2-1] == sch[i1+k2])
								koma = 0;
							if (koma > 0) {
								int kk = 0;
								int k  = i1 + k1;
								while (kk < koma) {
									if (k >= sch.length)
										kk = koma + 1;
									else {
										if (sch[k] < 0) {
											kk++;
											k++;
										}
										else {
											if (!temp.contains(Integer.toString(sch[k]))) {
												temp.add(Integer.toString(sch[k]));
												sw0 = 1;
											}
											R_Lecture rl = (R_Lecture)EX.r_lecture.get(sch[k]);
											kk += rl.koma;
											k  += rl.koma;
										}
									}
								}
								if (kk > koma || k1+kk > m || k2+kk > m)
									koma = 0;
								else {
									kk = 0;
									k  = i1 + k2;
									while (kk < koma) {
										if (k >= sch.length)
											kk = koma + 1;
										else {
											if (sch[k] < 0) {
												kk++;
												k++;
											}
											else {
												if (!temp.contains(Integer.toString(sch[k]))) {
													temp.add(Integer.toString(sch[k]));
													sw0 = 1;
												}
												R_Lecture rl = (R_Lecture)EX.r_lecture.get(sch[k]);
												kk += rl.koma;
												k  += rl.koma;
											}
										}
									}
									if (kk > koma || k1+kk > m || k2+kk > m)
										koma = 0;
									else {
										ob[0]++;
										ob[ob[0]] = i1 / m;
									}
								}
							}
						}
					}
				}
			}
		}
					// 開始時限の指定がある場合
		if (koma > 0) {
			for (int i1 = 1; i1 <= ob[0] && koma > 0; i1++) {
				int sw = 0;
				int kk = m * ob[i1];
				int k  = 0;
				while (k < koma && sw == 0) {
					if (sch[kk+k1+k] >= 0) {
						if (move[kk+k1+k] == 0)
							sw = 1;
						else {
							R_Lecture rl = (R_Lecture)EX.r_lecture.get(sch[kk+k1+k]);
							k += rl.koma;
						}
					}
					else
						k++;
				}
				if (sw == 0) {
					k = 0;
					while (k < koma && sw == 0) {
						if (sch[kk+k2+k] >= 0) {
							if (move[kk+k2+k] == 0)
								sw = 1;
							else {
								R_Lecture rl = (R_Lecture)EX.r_lecture.get(sch[kk+k2+k]);
								k += rl.koma;
							}
						}
						else
							k++;
					}
				}
				if (sw > 0) {
					if ((kk+k1)%DS.day != (kk+k2)%DS.day)
						koma = 0;
				}
			}
		}
					// 開講日時指定科目
		if (koma > 0) {
			for (int i1 = 1; i1 <= ob[0] && koma > 0; i1++) {
				int kk = m * ob[i1];
				int k  = 0;
				while (k < koma && koma > 0) {
					if (sch[kk+k1+k] >= 0) {
						if (move[kk+k1+k] < 0)
							koma = 0;
						else {
							R_Lecture rl = (R_Lecture)EX.r_lecture.get(sch[kk+k1+k]);
							k += rl.koma;
						}
					}
					else
						k++;
				}
				if (koma > 0) {
					k = 0;
					while (k < koma && koma > 0) {
						if (sch[kk+k2+k] >= 0) {
							if (move[kk+k2+k] < 0)
								koma = 0;
							else {
								R_Lecture rl = (R_Lecture)EX.r_lecture.get(sch[kk+k2+k]);
								k += rl.koma;
							}
						}
						else
							k++;
					}
				}
			}
		}

		return koma;
	}

	/*******************************************/
	/* 位置の交換                              */
	/*      m1, m2 : 2つの位置                 */
	/*      ob : 交換対象位置                  */
	/*      koma : コマ数                      */
	/*      same : 同じ場合に変換するか否か    */
	/*      return : =1:改善，=0:同じ，-1:改悪 */
	/*******************************************/
	int change(int m1, int m2, int ob[], int koma, boolean same)
	{
		int ok = 1;
		int m  = DS.day * DS.week;
		boolean sch2[] = new boolean [sch.length];
					// 交換の実施
						// 使用している講義室を開放
		for (int i1 = 1; i1 <= ob[0]; i1++) {
			int kb = m * ob[i1];
			for (int i2 = 0; i2 < 2; i2++) {
				int k  = 0;
				int kk = (i2 == 0) ? kb + m1 : kb + m2;
				while (k < koma) {
					int k1 = kk + k;
					if (sch[k1] >= 0) {
						R_Lecture rl = (R_Lecture)(EX.r_lecture.get(sch[k1]));
						if (rl.room.size() > 0)
							room_reset(sch[k1]);
						for (int i3 = 0; i3 < rl.koma; i3++)
							sch[k1+i3] = -1;
						k += rl.koma;
					}
					else
						k++;
				}
			}
		}
						// 位置を交換
		for (int i1 = 0; i1 < sch2.length; i1++)
			sch2[i1] = true;
		for (int i1 = 1; i1 <= ob[0]; i1++) {
			int kb = m * ob[i1];
			for (int i2 = 0; i2 < 2; i2++) {
				int k1, k2, k3;
				if (i2 == 0) {
					k1 = kb + m1;
					k2 = kb + m2;
					k3 = m1;
				}
				else {
					k1 = kb + m2;
					k2 = kb + m1;
					k3 = m2;
				}
				int k = 0;
				while (k < koma) {
					if (sch1[k2+k] >= 0) {
						R_Lecture rl = (R_Lecture)(EX.r_lecture.get(sch1[k2+k]));
						for (int i3 = 0; i3 < rl.koma; i3++) {
							sch[k1+k+i3]  = sch1[k2+k+i3];
							sch2[k1+k+i3] = false;
							move[k1+k+i3] = move1[k2+k+i3];
						}
						if (rl.room.size() == 0)
							room_set(sch[k1+k], k3);
						k  += rl.koma;
						k3 += rl.koma;
					}
					else {
						sch[k1+k]  = -1;
						move[k1+k] = 1;
						k++;
					}
				}
			}
		}
						// 交換による講義室確保状況の変更
		for (int i1 = 0; i1 < sch2.length; i1++) {
			if (sch[i1] >= 0) {
				R_Lecture rl = (R_Lecture)(EX.r_lecture.get(sch[i1]));
				if (sch2[i1]) {
					int k1 = i1 % m;
					int k2 = k1 + rl.koma - 1;
					if (k1 >= m1 && k1 < m1+koma || k1 >= m2 && k1 < m2+koma || k2 >= m1 && k2 < m1+koma || k2 >= m2 && k2 < m2+koma) {
						int sw = 0;
						for (int i2 = 0; i2 < rl.room.size() && sw == 0; i2 += 2) {
							k2 = Integer.parseInt((String)rl.room.get(i2+1));
							if (k2 < 0)
								sw = 1;
						}
						if (sw > 0) {
							room_reset(sch[i1]);
							room_set(sch[i1], k1);
						}
					}
				}
				i1 += (rl.koma - 1);
			}
		}
						// 評価値の計算
		pi = evaluation();
					// 元の状態に戻す
		if (Math.abs(pi) >= Math.abs(pi1)) {
			if (Math.abs(pi) == Math.abs(pi1))
				ok = 0;
			else
				ok = -1;
			if (ok < 0 || !same) {
				pi = pi1;
				for (int i1 = 0; i1 < cond.length; i1++)
					cond[i1] = cond1[i1];
				for (int i1 = 0; i1 < EX.r_name.length; i1++)
					r_rat[i1] = r_rat1[i1];
				for (int i1 = 0; i1 < m; i1++) {
					for (int i2 = 0; i2 < EX.r_name.length; i2++)
						r_use[i1][i2] = r_use1[i1][i2];
				}
				for (int i1 = 0; i1 < EX.r_lecture.size(); i1++) {
					R_Lecture rl = (R_Lecture)(EX.r_lecture.get(i1));
					rl.room      = new ArrayList <String> ((ArrayList <String>)room.get(i1));
				}
				for (int i1 = 0; i1 < sch.length; i1++) {
					sch[i1]  = sch1[i1];
					move[i1] = move1[i1];
				}
			}
		}

		return ok;
	}
}
