/************/
/* 初期設定 */
/************/
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class Initialize
{
	Execute EX;
	Data_set DS;

	/******************/
	/* コンストラクタ */
	/******************/
	Initialize(Execute EX_i, Data_set DS_i)
	{
		EX = EX_i;
		DS = DS_i;
	}

	/*******************************************************************/
	/* 初期設定                                                        */
	/*   全個別講義室を並べ，講義室の総称名との対応                    */
	/*   day * week コマからなる時間割の学年，学科，配列上の位置の決定 */
	/*******************************************************************/
	void initial_value()
	{
		int m    = DS.day * DS.week;
					// 乱数
		EX.rn    = new Random(DS.seed);
					// 試行回数
		EX.count = 0;
					// 講義室の対応関係
		int n       = 0;
		int k1      = 0;
		EX.g_r_name = new String [EX.room.size()];   // 講義室の総称名
		EX.g_to_r   = new int [2 * EX.room.size()];   // 総称名が示す講義室の範囲
		for (int i1 = 0; i1 < EX.room.size(); i1++) {
			Room rm            = (Room)EX.room.get(i1);
			EX.g_r_name[i1]    = rm.name;
			EX.g_to_r[2*i1]    = k1;
			EX.g_to_r[2*i1+1]  = k1 + rm.each.size() - 1;
			k1                 = EX.g_to_r[2*i1+1] + 1;
			n                 += rm.each.size();
		}

		EX.r_name = new String [n];   // 全個別講義室の名称
		n         = 0;
		for (int i1 = 0; i1 < EX.room.size(); i1++) {
			Room rm = (Room)EX.room.get(i1);
			for (int i2 = 0; i2 < rm.each.size(); i2++) {
				EX.r_name[n] = (String)rm.each.get(i2);
				n++;
			}
		}
					// 時間割表
		n       = 0;
		int max = 0;
		int min = 10;
		for (int i1 = 0; i1 < EX.gakka.size(); i1++) {
			Gakka gk  = (Gakka)(EX.gakka.get(i1));
			n        += gk.name.size();
			if (gk.nen > max)
				max = gk.nen;
			if (gk.nen < min)
				min = gk.nen;
		}
		EX.s_nen  = new int [n];   // 学年
		EX.s_name = new String [n];   // 学科
		EX.s_pos  = new int [n];   // 各学年・学科の時間割表上の位置
		                           // 各時間割は，day * week コマからなる
		k1     = 0;
		int k2 = 0;
		for (int i1 = min; i1 <= max; i1++) {
			int sw = 0;
			for (int i2 = 0; i2 < EX.gakka.size() && sw == 0; i2++) {
				Gakka gk = (Gakka)(EX.gakka.get(i2));
				if (i1 == gk.nen) {
					sw = 1;
					for (int i3 = 0; i3 < gk.name.size(); i3++) {
						EX.s_nen[k1]  = i1;
						EX.s_name[k1] = (String)gk.name.get(i3);
						EX.s_pos[k1]  = k2;
						k1++;
						k2 += m;
					}
				}
			}
		}
	}
}
