/****************************************************************/
/* 講義室，教員，及び，科目データの入力，及び，その値のチェック */
/****************************************************************/
import java.io.*;
import java.util.*;

public class Input_Check
{
	Execute EX;
	Data_set DS;

	/******************/
	/* コンストラクタ */
	/******************/
	Input_Check(Execute EX_i, Data_set DS_i)
	{
		EX = EX_i;
		DS = DS_i;
	}

	/****************/
	/* データの入力 */
	/****************/
	void input()
	{
					// 講義室データ
		StringTokenizer str = new StringTokenizer(DS.room_data.getText(), "\n");
		EX.room = new ArrayList <Room> ();
		while (str.hasMoreTokens()) {
			String line = str.nextToken();
			EX.room.add(new Room(line));
		}
					// 教員データ
		str = new StringTokenizer(DS.teacher_data.getText(), "\n");
		EX.teacher = new ArrayList <Teacher> ();
		while (str.hasMoreTokens()) {
			String line1 = str.nextToken();
			String line2 = str.nextToken();
			String line3 = str.nextToken();
			EX.teacher.add(new Teacher(line1, line2, line3));
		}
					// 科目データ
		str = new StringTokenizer(DS.lecture_data.getText(), "\n");
		EX.lecture = new ArrayList <Lecture> ();
		while (str.hasMoreTokens()) {
			String line1 = str.nextToken();
			String line2 = str.nextToken();
			String line3 = str.nextToken();
			String line4 = str.nextToken();
			String line5 = str.nextToken();
			String line6 = str.nextToken();
			String line7 = str.nextToken();
			EX.lecture.add(new Lecture(line1, line2, line3, line4, line5, line6, line7));
		}
					// 学年と学科名データの作成
		int min = 100, max = 0;
		for (int i1 = 0; i1 < EX.lecture.size(); i1++) {
			int k = ((Lecture)(EX.lecture.get(i1))).nen;   // 学年
			if (k < min)
				min = k;
			if (k > max)
				max = k;
		}
		int nen  = max - min + 1;
		EX.gakka = new ArrayList <Gakka> ();
		for (int i1 = 0; i1 < nen; i1++) {
			EX.gakka.add(new Gakka(min, EX));
			min++;
		}

		EX.ta.setText("以下の学科名で実行します\n");
		for (int i1 = 0; i1 < EX.gakka.size(); i1++) {
			Gakka gk = (Gakka)EX.gakka.get(i1);
			EX.ta.append("　" + gk.nen + "年 ");
			for (int i2 = 0; i2 < gk.name.size(); i2++)
				EX.ta.append(gk.name.get(i2) + " ");
			EX.ta.append("\n");
		}
	}

	/************************/
	/* 入力データのチェック */
	/************************/
	boolean check()
	{
		boolean ok = true;
						// 科目データ
		String ki  = null;
		for (int i1 = 0; i1 < EX.lecture.size(); i1++) {
			Lecture lc = (Lecture)(EX.lecture.get(i1));
			if (i1 == 0)
				ki = lc.ki;   // 開講学期
			else {
				if (!lc.ki.equals(ki)) {
					ok = false;
					EX.ta.append("科目（" + lc.k_name + "）の開講時期が異なっています\n");
				}
			}
							// 教員名
			for (int i2 = 0; i2 < lc.t_name.size(); i2++) {
				String str = (String)lc.t_name.get(i2);
				int sw     = 0;
				for (int i3 = 0; i3 < EX.teacher.size() && sw == 0; i3++) {
					Teacher tc = (Teacher)(EX.teacher.get(i3));
					if (str.equals(tc.name))
						sw = 1;
				}
				if (sw == 0) {
					ok = false;
					EX.ta.append("教員（" + str + "）が未定義\n");
				}
			}
							// 講義室
			for (int i2 = 0; i2 < lc.room.size(); i2++) {
				String str = (String)lc.room.get(i2);
				int sw     = 0;
				for (int i3 = 0; i3 < EX.room.size() && sw == 0; i3++) {
					Room rm = (Room)(EX.room.get(i3));
					if (str.equals(rm.name))
						sw = 1;
					else {
						for (int i4 = 0; i4 < rm.each.size() && sw == 0; i4++) {
							String str1 = (String)rm.each.get(i4);
							if (str.equals(str1))
								sw = 1;
						}
					}
				}
				if (sw == 0) {
					ok = false;
					EX.ta.append("講義室（" + str + "）が未定義\n");
				}
			}
							// 代替講義室
			for (int i2 = 0; i2 < lc.r_room.size(); i2++) {
				String str = (String)lc.r_room.get(i2);
				int sw     = 0;
				for (int i3 = 0; i3 < EX.room.size() && sw == 0; i3++) {
					Room rm = (Room)(EX.room.get(i3));
					if (str.equals(rm.name))
						sw = 1;
				}
				if (sw == 0) {
					ok = false;
					EX.ta.append("講義室（" + str + "）が未定義\n");
				}
			}
							// 開始時限
			if (lc.start > 0) {
				if (lc.start+lc.koma-1 > DS.day) {
					ok = false;
					EX.ta.append("講義（" + lc.k_name + "）の開始時限が不適当\n");
				}
			}
		}
						// 教員の都合
		for (int i1 = 0; i1 < EX.teacher.size(); i1++) {
			Teacher tc = (Teacher)(EX.teacher.get(i1));
			if (tc.h_list.size() > 0) {
				ArrayList <String> temp = new ArrayList <String> ();
				for (int i2 = 0; i2 < tc.h_list.size(); i2 += 2) {
					String str = (String)tc.h_list.get(i2);   // 曜日
					int k      = Integer.parseInt((String)tc.h_list.get(i2+1));   // 時限
					if (!(str.equals("月") || str.equals("火") || str.equals("水") || str.equals("木") || str.equals("金") || str.equals("土") || str.equals("日"))) {
						ok = false;
						EX.ta.append("教員（" + tc.name + "）の曜日設定が不適当\n");
					}
					else {
						if (str.equals("金") && DS.week < 5 || str.equals("土") && DS.week < 6 || str.equals("日") && DS.week < 7) {
							ok = false;
							EX.ta.append("１週当たりの講義日数が不適当\n");
						}
					}
					if (k < 1 || k > DS.day) {
						ok = false;
						EX.ta.append("教員（" + tc.name + "）の時限設定が不適当\n");
					}
							// 曜日と時限を月曜からの通算時限に変換
					if (ok) {
						int k1;
						if (str.equals("月"))
							k1 = k - 1;
						else if (str.equals("火"))
							k1 = DS.day + k - 1;
						else if (str.equals("水"))
							k1 = 2 * DS.day + k - 1;
						else if (str.equals("木"))
							k1 = 3 * DS.day + k - 1;
						else if (str.equals("金"))
							k1 = 4 * DS.day + k - 1;
						else if (str.equals("土"))
							k1 = 5 * DS.day + k - 1;
						else
							k1 = 6 * DS.day + k - 1;
						temp.add(Integer.toString(k1));
					}
				}
				tc.h_list.clear();
				for (int i2 = 0; i2 < temp.size(); i2++)
					tc.h_list.add((String)temp.get(i2));
				temp.clear();
			}
		}
						// 同時開講を考慮した科目データの作成
						//   化学（2コマ科目）に対して，　　理科  0  0   （x, y）
						//   物理（1コマ科目）に対して，　　理科  1  1   （x, y）
						//   　　と入力された場合，物理が化学の 2 コマ目と同時に開講
		boolean ck[] = new boolean [EX.lecture.size()];
		for (int i1 = 0; i1 < EX.lecture.size(); i1++)
			ck[i1] = false;   // 科目i1をチェックしたか否かを示す

		EX.r_lecture = new ArrayList <R_Lecture> ();
		for (int i1 = 0; i1 < EX.lecture.size(); i1++) {
			if (!ck[i1]) {
				ck[i1]       = true;
				Lecture lc   = (Lecture)(EX.lecture.get(i1));
				R_Lecture rl = new R_Lecture();
				rl.start     = lc.start;
				rl.koma      = lc.koma;
				rl.fix       = lc.fix;
				rl.no        = new ArrayList <String> ();
				rl.room      = new ArrayList <String> ();
				rl.no.add(Integer.toString(i1));
				if (lc.same != null) {
					String str = lc.same;   // 同時開講科目の指標
							// 同じ指標科目を探す
					for (int i2 = i1+1; i2 < EX.lecture.size(); i2++) {
						Lecture lc1 = (Lecture)(EX.lecture.get(i2));
						if (!ck[i2]) {
							if (str.equals(lc1.same)) {   // 同時開講科目か？
								if (lc.nen == lc1.nen) {   // 同じ学年の科目か？
									ck[i2] = true;
									int sw = 0;
									for (int i3 = 0; i3 < rl.no.size() && sw ==0; i3++) {
										int k = Integer.parseInt((String)(rl.no.get(i3)));
										Lecture lc2 = (Lecture)(EX.lecture.get(k));
										k = 10 * lc1.x + lc1.y - 10 * lc2.x - lc2.y;   // n行10列
										if (k < 0) {   // 配置位置の順に記憶
											sw = 1;
											rl.no.add(i3, Integer.toString(i2));
											if (lc1.fix)
												rl.fix = true;
										}
										else if (k == 0) {    // 同じ位置には設定できない
											ok = false;
											EX.ta.append("同時開講（" + str + "）の配置が不適当\n");
										}
									}
									if (sw == 0)
										rl.no.add(Integer.toString(i2));
								}
								else {
									ok = false;
									EX.ta.append("同時開講科目 " + lc.k_name + " と " + lc1.k_name + " の対象学年が異なっています\n");
								}
							}
						}
					}
				}
				EX.r_lecture.add(rl);
			}
		}
						// 同時開講設定のチェック（開始位置）
		for (int i1 = 0; i1 < EX.r_lecture.size(); i1++) {
			R_Lecture rl = (R_Lecture)(EX.r_lecture.get(i1));
			if (rl.no.size() > 1) {
				int max  = 0;
				int min  = 10;
				rl.start = 0;
				for (int i2 = 0; i2 < rl.no.size(); i2++) {
					int k1      = Integer.parseInt((String)rl.no.get(i2));
					Lecture lc1 = (Lecture)(EX.lecture.get(k1));
					if (lc1.y == 0)
						min = 1;
					if (lc1.y+lc1.koma > max)
						max = lc1.y + lc1.koma;
					if (lc1.start > 0)
						rl.start = lc1.start - lc1.y;
					for (int i3 = i2+1; i3 < rl.no.size(); i3++) {
						int k2      = Integer.parseInt((String)rl.no.get(i3));
						Lecture lc2 = (Lecture)(EX.lecture.get(k2));
						if (lc1.x == lc2.x) {
							int sw = 0;
							if (lc1.y < lc2.y) {
								if (lc1.y+lc1.koma-1 >= lc2.y)
									sw = 1;
							}
							else {
								if (lc2.y+lc2.koma-1 >= lc1.y)
									sw = 1;
							}
							if (sw > 0) {
								ok = false;
								EX.ta.append(lc1.k_name + " と " + lc2.k_name + " の同時開講設定が不適当(重複)\n");
							}
						}
					}
				}
				rl.koma = max;
				if (min > 1) {
					ok          = false;
					int k1      = Integer.parseInt((String)rl.no.get(0));
					Lecture lc1 = (Lecture)(EX.lecture.get(k1));
					EX.ta.append("（" + lc1.k_name + "）の同時開講設定が不適当（開始コマがない）\n");
				}
			}
		}
						// 同時開講設定のチェック（教員）
		for (int i1 = 0; i1 < EX.r_lecture.size(); i1++) {
			R_Lecture rl = (R_Lecture)(EX.r_lecture.get(i1));
			if (rl.no.size() > 1) {
				int k1     = Integer.parseInt((String)rl.no.get(0));
				Lecture lc = (Lecture)(EX.lecture.get(k1));
				for (int i2 = 0; i2 < rl.no.size()-1; i2++) {
					k1          = Integer.parseInt((String)rl.no.get(i2));
					Lecture lc1 = (Lecture)(EX.lecture.get(k1));
					for (int i3 = i2+1; i3 < rl.no.size(); i3++) {
						int k2      = Integer.parseInt((String)rl.no.get(i3));
						Lecture lc2 = (Lecture)(EX.lecture.get(k2));
						if (lc2.y >= lc1.y && lc2.y < lc1.y+lc1.koma) {
							int sw = 0;
							for (int i4 = 0; i4 < lc1.t_name.size() && sw == 0; i4++) {
								String str1 = (String)lc1.t_name.get(i4);
								for (int i5 = 0; i5 < lc2.t_name.size() && sw == 0; i5++) {
									String str2 = (String)lc2.t_name.get(i5);
									if (str1.equals(str2))
										sw = 1;
								}
							}
							if (sw > 0) {
								ok = false;
								EX.ta.append("同時開講科目 " + lc.k_name + " 内で教員が重複\n");
							}
						}
					}
				}
			}
		}

		return ok;
	}
}
