/**************/
/* 結果の出力 */
/**************/
import java.io.*;
import java.awt.*;
import java.util.*;

public class Output
{
	/**************************************************/
	/* デバッグ用出力                                 */
	/*      EX : Execute オブジェクト                 */
	/*      DS : Data_set オブジェクト                */
	/*      start_d : 0                               */
	/*      end_d : 時間割の大きさ（週のコマ数×学年）*/
	/*      ID : Individual オブジェクト              */
	/**************************************************/
	static void debug(Execute EX, Data_set DS, int start_d, int end_d, Individual ID)
	{
		String week[] = {"月曜日", "火曜日", "水曜日", "木曜日", "金曜日"};
					// 講義情報
		int m  = DS.day * DS.week;
		int k  = 0;
		int kk = 0;

		if (DS.o_lvl < -1) {
			for (int i1 = 0; i1 < ID.sch.length; i1++) {

				if (i1 % m == 0) {
					EX.ta.append(EX.s_nen[kk] + "年生（" + EX.s_name[kk] + "）\n");
					k = 0;
					kk++;
				}

				if (ID.sch[i1] >= 0 && i1 >= start_d && i1 < end_d) {

					ArrayList <String> tmp1 = new ArrayList <String> ();
					ArrayList <String> tmp2 = new ArrayList <String> ();
					EX.ta.append("  " + week[k/DS.day] + " " + (k % DS.day + 1) + "時限目 ");
						// 講義名，教員名，学科名
					R_Lecture rl = (R_Lecture)(EX.r_lecture.get(ID.sch[i1]));
					EX.ta.append(rl.koma + "コマ\n");
					for (int i2 = 0; i2 < rl.no.size(); i2++) {
						int k1     = Integer.parseInt((String)rl.no.get(i2));
						Lecture lc = (Lecture)EX.lecture.get(k1);
						EX.ta.append("    " + lc.k_name + "(" + lc.y + "," + lc.koma + ")（");
						for (int i3 = 0; i3 < lc.t_name.size(); i3++)
							EX.ta.append(" " + (String)lc.t_name.get(i3));
						EX.ta.append(" ）\n");
						EX.ta.append("    学科：");
						for (int i3 = 0; i3 < lc.gakka.size(); i3++) {
							String str = (String)lc.gakka.get(i3);
							EX.ta.append(" " + str);
						}
						EX.ta.append("\n");
						for (int i3 = 0; i3 < lc.room.size(); i3++)
							tmp1.add((String)lc.room.get(i3));
						for (int i3 = 0; i3 < lc.r_room.size(); i3++)
							tmp2.add((String)lc.r_room.get(i3));
					}
						// 要求講義室
					EX.ta.append("    要求：");
					for (int i2 = 0; i2 < tmp1.size(); i2++) {
						String str = (String)tmp1.get(i2);
						EX.ta.append(" " + str);
					}
					tmp1.clear();
					EX.ta.append("（");
					for (int i2 = 0; i2 < tmp2.size(); i2++) {
						String str = (String)tmp2.get(i2);
						EX.ta.append(" " + str);
					}
						// 設定講義室
					EX.ta.append(" ）\n    設定：");
					for (int i2 = 0; i2 < rl.room.size(); i2 += 2) {
						int k2 = Integer.parseInt((String)rl.room.get(i2));
						k2     = k2 % DS.day + 1;
						int k1 = Integer.parseInt((String)rl.room.get(i2+1));
						if (k1 >= 0)
							EX.ta.append(" " + EX.r_name[k1] + "（" + k2 + "）");
						else
							EX.ta.append(" 未設定（" + k2 + "）");
					}
					EX.ta.append("\n");
					tmp2.clear();
					i1 += (rl.koma - 1);
					k  += (rl.koma - 1);
				}

				k++;
			}
		}
					// 講義室情報
		EX.ta.append("講義室使用状況\n");
		for (int i1 = 0; i1 < EX.r_name.length; i1++) {
			EX.ta.append("  " + EX.r_name[i1]);
			EX.ta.append("  " + ID.r_rat[i1] + "\n");
		}
					// 空きコマ数
		EX.ta.append("空きコマ数\n");
		kk = 0;
		for (int i1 = 0; i1 < EX.gakka.size(); i1++) {
			Gakka gk = (Gakka)EX.gakka.get(i1);
			for (int i2 = 0; i2 < gk.name.size(); i2++) {
				String str = (String)gk.name.get(i2);
				k          = 0;
				EX.ta.append("  " + gk.nen + "年 " + str + " ");
				for (int i3 = kk; i3 < kk+m; i3++) {
					if (ID.sch[i3] < 0)
						k++;
				}
				EX.ta.append(k + " コマ\n");
				kk += m;
			}
		}
	}

	/*************************************/
	/* 中間結果                          */
	/*      EX : Execute オブジェクト    */
	/*      DS : Data_set オブジェクト   */
	/*      count : 試行回数             */
	/*      ID : Individual オブジェクト */
	/*************************************/
	static void mid_res(Execute EX, Data_set DS, int count, Individual ID)
	{
		int pi;

		EX.ta.append("現在の状況（" + count + "回目，評価値：");
		if (ID.pi >= 0) {
			pi = ID.pi;
			EX.ta.append(pi + "）　実行可能\n");
		}
		else {
			pi = -ID.pi;
			EX.ta.append(pi + "）");
			EX.ta.append("　***実行不可能***\n");
		}
		EX.ta.append("  講義時間の衝突　　　：" + ID.cond[0] + "　");
		EX.ta.append("講義室不足　　　　：" + ID.cond[1] + "　");
		EX.ta.append("教員の衝突　　　　　：" + ID.cond[2] + "\n");
		EX.ta.append("  教員の都合　　　　　：" + ID.cond[3] + "　");
		EX.ta.append("複数コマ講義の中断：" + ID.cond[4] + "　");
		EX.ta.append("実験の位置（中間）　：" + ID.cond[5] + "\n");
		EX.ta.append("  実験の位置（午前中）：" + ID.cond[6] + "　");
		EX.ta.append("空き（同日同講義）：" + ID.cond[7] + "　");
		EX.ta.append("必修科目間に選択科目：" + ID.cond[8] + "\n");
	}

	/*************************************/
	/* 最終結果                          */
	/*      EX : Execute オブジェクト    */
	/*      DS : Data_set オブジェクト   */
	/*      ID : Individual オブジェクト */
	/*************************************/
	static void result(Execute EX, Data_set DS, Individual ID)
	{
		String yobi[] = {"月曜日", "火曜日", "水曜日", "木曜日", "金曜日", "土曜日", "日曜日"};
					// 列のタイトル
		ArrayList <StringBuffer> out = new ArrayList <StringBuffer> ();
		StringBuffer str_b = new StringBuffer("\n学年,学科,曜日");
		for (int i1 = 0; i1 < DS.day; i1++)
			str_b.append("," + Integer.toString(i1+1) + "限目");
		out.add(str_b);
					// 時間割
		int m  = DS.day * DS.week;
		int k  = 0;
		int kk = 0;
		for (int i1 = 0; i1 < ID.sch.length; i1 += DS.day) {
						// 行タイトル
			String str;
			if (i1 % m == 0) {
				str = Integer.toString(EX.s_nen[kk]) + "年生," + EX.s_name[kk] + "," + yobi[k];
				kk++;
			}
			else
				str = ",," + yobi[k];
			str_b = new StringBuffer(str);
						// 科目名
			for (int i2 = i1; i2 < i1+DS.day; i2++) {
				if (ID.sch[i2] < 0) {
					if (i2 < i1+DS.day-1)
						str_b.append(",");
				}
				else {
					R_Lecture rl = (R_Lecture)(EX.r_lecture.get(ID.sch[i2]));
					for (int i3 = 0; i3 < rl.koma; i3++) {
						int sw = 0;
						for (int i4 = 0; i4 < rl.no.size(); i4++) {
							int k1    = Integer.parseInt((String)rl.no.get(i4));
							Lecture lc = (Lecture)EX.lecture.get(k1);
							if (i3 >= lc.y && i3 < lc.y+lc.koma) {
								str = lc.k_name.replace(' ', '-');
								if (sw == 0) {
									str_b.append("," + str);
									sw = 1;
								}
								else
									str_b.append("；" + str);
							}
						}
						str_b.append(":" + ID.sch[i2]);
					}
					i2 += (rl.koma - 1);
				}
			}
			out.add(str_b);
						// 教員名
			str_b = new StringBuffer(",,");
			for (int i2 = i1; i2 < i1+DS.day; i2++) {
				if (ID.sch[i2] < 0) {
					if (i2 < i1+DS.day-1)
						str_b.append(",");
				}
				else {
					R_Lecture rl = (R_Lecture)(EX.r_lecture.get(ID.sch[i2]));
					for (int i3 = 0; i3 < rl.koma; i3++) {
						int sw = 0;
						for (int i4 = 0; i4 < rl.no.size(); i4++) {
							int k1     = Integer.parseInt((String)rl.no.get(i4));
							Lecture lc = (Lecture)EX.lecture.get(k1);
							if (i3 >= lc.y && i3 < lc.y+lc.koma) {
								for (int i5 = 0; i5 < lc.t_name.size(); i5++) {
									str = (String)lc.t_name.get(i5);
									str = str.replace(' ', '-');
									if (sw == 0) {
										str_b.append("," + str);
										sw = 1;
									}
									else
										str_b.append("；" + str);
								}
							}
						}
					}
					i2 += (rl.koma - 1);
				}
			}
			out.add(str_b);
						// 講義室
			str_b = new StringBuffer(",,");
			for (int i2 = i1; i2 < i1+DS.day; i2++) {
				if (ID.sch[i2] < 0) {
					if (i2 < i1+DS.day-1)
						str_b.append(",");
				}
				else {
					R_Lecture rl = (R_Lecture)(EX.r_lecture.get(ID.sch[i2]));
					for (int i3 = 0; i3 < rl.koma; i3++) {
						int sw = 0;
						for (int i4 = 0; i4 < rl.room.size(); i4 += 2) {
							int k2 = Integer.parseInt((String)rl.room.get(i4));
							int k1 = Integer.parseInt((String)rl.room.get(i4+1));
							if (k2 == (i2+i3)%m) {
								if (k1 >= 0) {
									str = EX.r_name[k1].replace(' ', '-');
									if (sw == 0) {
										str_b.append("," + str);
										sw = 1;
									}
									else
										str_b.append("；" + str);
								}
								else {
									if (sw == 0) {
										str_b.append(",未定");
										sw = 1;
									}
									else
										str_b.append("；未定");
								}
							}
						}
						if (sw == 0)
							str_b.append(",");
					}
					i2 += (rl.koma - 1);
				}
			}
			out.add(str_b);
						// 次の日にち
			k++;
			if (k >= DS.week)
				k = 0;
		}
					// 教員名
		str_b = new StringBuffer("\n教員毎のスケジュール");
		out.add(str_b);
		for (int i1 = 0; i1 < EX.teacher.size(); i1++) {
			Teacher tc = (Teacher)EX.teacher.get(i1);
			str_b      = new StringBuffer("," + tc.name);
			out.add(str_b);
		}
					// 講義室名
		str_b = new StringBuffer("\n講義室使用状況");
		out.add(str_b);
		for (int i1 = 0; i1 < EX.room.size(); i1++) {
			Room rm = (Room)EX.room.get(i1);
			for (int i2 = 0; i2 < rm.each.size(); i2++) {
				String str = (String)rm.each.get(i2);
				str_b      = new StringBuffer("," + str);
				out.add(str_b);
			}
		}
					// 講義室の使用率
		EX.ta.append("\n講義室使用率\n");
		int k1 = 0;
		int k2 = 0;
		for (int i1 = 0; i1 < EX.room.size(); i1++) {
			Room rm = (Room)EX.room.get(i1);
			EX.ta.append("  " + rm.name);
			k2 = rm.each.size();
			kk = 0;
			for (int i2 = k1; i2 < k1+k2; i2++)
				kk += ID.r_rat[i2];
			EX.ta.append(" " + ((double)kk/(m*k2)) + "\n");
			k1 += k2;
		}
					// 出力
		for (int i1 = 0; i1 < out.size(); i1++) {
			String str = ((StringBuffer)out.get(i1)).toString();
			EX.ta.append(str + "\n");
		}
	}
}
