			//
			// Individual オブジェクト（プロパティ）
			//
function Individual()
{
	this.r_use;   // 講義室の使用状況
	this.r_use1;   // 講義室の使用状況
	this.r_rat;   // 講義室の使用回数
	this.r_rat1;   // 講義室の使用回数
	this.sch;   // 時間割
	this.sch1;   // 時間割
	this.move;   // 1:移動可能，0:曜日だけ変更可能，-1:移動不可能
	this.move1;   // 1:移動可能，0:曜日だけ変更可能，-1:移動不可能
	this.cond;   // 各制約条件に対する評価値
	this.cond1;   // 各制約条件に対する評価値
	this.pi;   // 評価値
	this.pi1;   // 評価値（旧）
	this.room;   // ワーク

	return this;
}
			//
			// Individual オブジェクト（メソッド initial_value）
			//   値の初期設定
			//
Individual.prototype.initial_value = function(k)
{
	var m = DS.day * DS.week;
				// 制約条件
	IND.cond  = new Array(DS.MAX_C);
	IND.cond1 = new Array(DS.MAX_C);
	for (var i1 = 0; i1 < DS.MAX_C; i1++)
		IND.cond[i1] = 0;
				// 講義室の使用状況
	var n      = EX.r_name.length;
	IND.r_use  = new Array(m);
	IND.r_use1 = new Array(m);
	IND.r_rat  = new Array(n);
	IND.r_rat1 = new Array(n);
	for (var i1 = 0; i1 < n; i1++)
		IND.r_rat[i1] = 0;
	for (var i1 = 0; i1 < m; i1++) {
		IND.r_use[i1]  = new Array(n);
		IND.r_use1[i1] = new Array(n);
		for (var i2 = 0; i2 < n; i2++)
			IND.r_use[i1][i2] = false;
	}
				// 時間割表
	n         = m * EX.s_nen.length;
	IND.sch   = new Array(n);
	IND.sch1  = new Array(n);
	IND.move  = new Array(n);
	IND.move1 = new Array(n);
	for (var i1 = 0; i1 < n; i1++) {
		IND.sch[i1]  = -1;
		IND.move[i1] = 1;
	}

	IND.room = new Array();
}
			//
			// Individual オブジェクト（メソッド initial_arrange）
			//   講義の初期配置
			//      return : =-1 : エラー
			//               =0 : 配置不可能
			//               =1 : 初期配置成功
			//
Individual.prototype.initial_arrange = function(k)
{
	var st = new Array(EX.r_lecture.lecture);
	var ok = true;
	var s  = 1;
				// 開講日時が指定されている講義の配置
	for (var i1 = 0; i1 < EX.r_lecture.length; i1++) {
		st[i1] = false;
					// 指定されているか否かの判定
		var rl = EX.r_lecture[i1];
		var sw = 0;
		var tc = null;
		var lc = null;
		for (var i2 = 0; i2 < rl.no.length && sw == 0; i2++) {
			var k = rl.no[i2];
			lc    = EX.lecture[k];
			sw    = 0;
			for (var i3 = 0; i3 < lc.t_name.length && sw == 0; i3++) {
				var str = lc.t_name[i3];
				for (var i4 = 0; i4 < EX.teacher.length && sw == 0; i4++) {
					tc = EX.teacher[i4];
					if (str == tc.name)
						sw = 1;
				}
				sw = 0;
				if (tc.no_yes)
					sw = 1;
			}
		}
					// 設定
		if (sw > 0) {
			if (tc.h_list.length > 0) {
				var jigen = tc.h_list[0] - lc.y;
				if (rl.start > 0 && jigen%DS.day != rl.start-1)
					jigen = Math.floor(jigen / DS.day) * DS.day + rl.start - 1;
				st[i1] = true;
				ok     = IND.fix(i1, jigen);   // 指定された日時に講義を設定
				if (!ok) {
					EX.go_ok = false;
					s        = -1;
				}
			}
			else {
				DS.ta    = DS.ta + "教員（" + tc.name + "）の講義可能日数が少なすぎます\n";
				EX.go_ok = false;
				s        = -1;
			}
		}
	}

	document.getElementById('ta').value = DS.ta;
				// 開講時限が指定されている講義の配置
	if (EX.go_ok) {
		for (var i1 = 0; i1 < EX.r_lecture.length; i1++) {
			if (!st[i1]) {
				var rl = EX.r_lecture[i1];
				if (rl.start > 0) {
					st[i1] = true;
					ok     = IND.s_fix(i1);   // 指定された時限に講義を設定
					if (!ok) {
						EX.go_ok = false;
						s        = 0;
					}
				}
			}
		}
	}

	document.getElementById('ta').value = DS.ta;
				// その他の講義の配置
	if (EX.go_ok) {
		var max = 0;
		for (var i1 = 0; i1 < EX.gakka.length; i1++) {
			var gk = EX.gakka[i1];
			if (gk.name.length > max)
				max = gk.name.length;
		}
		max *= DS.day;
		for (var i1 = max; i1 >= 1 && ok; i1--) {
			ok = IND.free(st, i1);   // ランダムに講義を設定
			if (!ok) {
				s        = 0;
				EX.go_ok = false;
				DS.ta    = DS.ta + "***講義の初期配置に失敗しました***\n";
			}
		}

		if (ok)
			DS.ta = DS.ta + "+++講義の初期配置に成功しました+++\n";
	}

	document.getElementById('ta').value = DS.ta;

	return s;
}
			//
			// Individual オブジェクト（メソッド fix）
			//   指定された日時に講義を設定
			//      k : 講義番号
			//      jigen : 時限
			//      return : 配置可能か否か
			//
Individual.prototype.fix = function(k, jigen)
{
				// 位置の決定
	var ok = true;
	var n  = 0;
	var p  = new Array(EX.s_nen.length);
	var rl = EX.r_lecture[k];
	var k1 = rl.no[0];
	var lc = EX.lecture[k1];

	for (var i1 = 0; i1 < rl.no.length; i1++) {
		k1      = rl.no[i1];
		var lc1 = EX.lecture[k1];
		for (var i2 = 0; i2 < lc1.gakka.length; i2++) {
			var str = lc1.gakka[i2];
			var sw  = 0;
			for (var i3 = 0; i3 < EX.s_nen.length && sw == 0; i3++) {
				if (lc1.nen == EX.s_nen[i3] && str == EX.s_name[i3]) {
					for (var i4 = 0; i4 < n && sw == 0; i4++) {
						if (p[i4] == EX.s_pos[i3])
							sw = 1;
					}
					if (sw == 0) {
						p[n] = EX.s_pos[i3];
						sw   = 1;
						n++;
					}
				}
			}
		}
	}
				// 設定
	ok = IND.teacher_same(rl, jigen);   // 同じ科目担当教員の都合
	if (!ok)
		EX.go_ok = false;
	else {
		for (var i1 = 0; i1 < n; i1++) {
			var k2 = p[i1] + jigen;
			for (var i2 = 0; i2 < rl.koma; i2++) {
				if (IND.sch[k2+i2] < 0) {
					var lc1 = IND.teacher_ck(k, k2, k2+i2);   // 教員の重なりをチェック
					if (lc1 == null) {
						IND.sch[k2+i2]  = k;
						IND.move[k2+i2] = -1;
					}
					else {
						ok    = false;
						DS.ta = DS.ta + "科目（" + lc1.k_name + "）と担当教員が重なっているため，科目（" + lc.k_name + "）を配置できません\n";
					}
				}
				else {
					ok      = false;
					var rl1 = EX.r_lecture[IND.sch[k2+i2]];
					var k3  = rl1.no[0];
					var lc1 = EX.lecture[k3];
					DS.ta = DS.ta + "科目（" + lc1.k_name + "）がすでに配置されているため，科目（" + lc.k_name + "）を配置できません\n";
				}
			}
		}
	}
				// 講義室の設定
	if (ok) {
		ok = IND.room_set(k, jigen);   // 講義室の設定
		if (!ok)
			DS.ta = DS.ta + "科目（" + lc.k_name + "）の講義室が確保できません\n";
	}

	return ok;
}
			//
			// Individual オブジェクト（メソッド s_fix）
			//   指定された時限に講義を設定
			//      k : 講義番号
			//
Individual.prototype.s_fix = function(k)
{
				// 位置の決定
	var ok = true;
	var m  = DS.day * DS.week;
	var n  = 0;
	var p  = new Array(EX.s_nen.length);
	var rl = EX.r_lecture[k];
	var k1 = rl.no[0];
	var lc = EX.lecture[k1];

	for (var i1 = 0; i1 < rl.no.length; i1++) {
		k1      = rl.no[i1];
		var lc1 = EX.lecture[k1];
		for (var i2 = 0; i2 < lc1.gakka.length; i2++) {
			var str = lc1.gakka[i2];
			var sw  = 0;
			for (var i3 = 0; i3 < EX.s_nen.length && sw == 0; i3++) {
				if (lc1.nen == EX.s_nen[i3] && str == EX.s_name[i3]) {
					for (var i4 = 0; i4 < n && sw == 0; i4++) {
						if (p[i4] == EX.s_pos[i3])
							sw = 1;
					}
					if (sw == 0) {
						p[n] = EX.s_pos[i3];
						sw   = 1;
						n++;
					}
				}
			}
		}
	}
				// 日時の設定
	var sw = 0;
	k1     = Math.floor(DS.week * Math.random());
	if (k1 >= DS.week)
		k1 = DS.week - 1;
	k1 = k1 * DS.day + rl.start - 1;
	for (var i0 = 0; i0 < DS.week && sw == 0; i0++) {
		ok = true;
		for (var i1 = 0; i1 < n && ok; i1++) {
			var k2 = p[i1] + k1;
			for (var i2 = 0; i2 < rl.koma && ok; i2++) {
				if (IND.sch[k2+i2] < 0) {
					var lc1 = IND.teacher_ck(k, k2, k2+i2);   // 教員の重なりをチェック
					if (lc1 != null)
						ok = false;
					else {
						for (var i3 = 0; i3 < rl.no.length && ok; i3++) {
							var k3 = rl.no[i3];
							lc1    = EX.lecture[k3];
							for (var i4 = 0; i4 < lc1.t_name.length && ok; i4++) {
								var str = lc1.t_name[i4];
								var tc  = null;
								for (var i5 = 0; i5 < EX.teacher.length && sw == 0; i5++) {
									tc = EX.teacher[i5];
									if (str == tc.name)
										sw = 1;
								}
								sw = 0;
								for (var i5 = 0; i5 < tc.h_list.length && ok; i5++) {
									k3 = tc.h_list[i5];
									if (k3 == (k2+i2)%m)
										ok = false;
								}
							}
						}
					}
				}
				else
					ok = false;
			}
		}
				// 講義室の設定
		if (ok) {
			ok = IND.room_set(k, k1);   // 講義室の設定
			if (ok)
				sw = 1;
			else {
				if (rl.room.length > 0)
					IND.room_reset(k);   // 講義室の解放
			}
		}

		if (sw == 0) {
			k1 += DS.day;
			if (k1 >= m)
				k1 = rl.start - 1;
		}
	}

	if (sw > 0) {
		ok = true;
		for (var i1 = 0; i1 < n; i1++) {
			var k2 = p[i1] + k1;
			for (var i2 = 0; i2 < rl.koma; i2++) {
				IND.sch[k2+i2]  = k;
				IND.move[k2+i2] = rl.fix ? -1 : 0;
			}
		}
	}
	else {
		DS.ta = DS.ta + "科目（" + lc.k_name + "）を配置できませんでした\n";
		ok    = false;
	}

	return ok;
}
			//
			// Individual オブジェクト（メソッド free）
			//   ランダムに講義を設定
			//      st : 配置済みか否か
			//      no : 対象学科数×コマ数の下限
			//
Individual.prototype.free = function(st, no)
{
				// 初期設定
	var p   = new Array(EX.s_nen.length);
	var tm  = new Array(st.length);
	var m   = DS.day * DS.week;
	var ok  = true;
	var st1 = new Array(st.length);
	for (var i1 = 0; i1 < st.length; i1++)
		st1[i1] = st[i1];
	var sch1 = new Array(IND.sch.length);
	for (var i1 = 0; i1 < IND.sch.length; i1++)
		sch1[i1] = IND.sch[i1];
				// 配置
	for (var i1 = 0; i1 < EX.r_lecture.length; i1++) {
		if (!st[i1]) {
					// 位置の決定
			var n  = 0;
			var rl = EX.r_lecture[i1];
			var k1 = rl.no[0];
			var lc = EX.lecture[k1];
			for (var i2 = 0; i2 < rl.no.length; i2++) {
				k1      = rl.no[i2];
				var lc1 = EX.lecture[k1];
				for (var i3 = 0; i3 < lc1.gakka.length; i3++) {
					var str = lc1.gakka[i3];
					var sw  = 0;
					for (var i4 = 0; i4 < EX.s_nen.length && sw == 0; i4++) {
						if (lc1.nen == EX.s_nen[i4] && str == EX.s_name[i4]) {
							for (var i5 = 0; i5 < n && sw == 0; i5++) {
								if (p[i5] == EX.s_pos[i4])
									sw = 1;
							}
							if (sw == 0) {
								p[n] = EX.s_pos[i4];
								sw   = 1;
								n++;
							}
						}
					}
				}
			}
					// 配置
			if (n*rl.koma >= no) {
				var sw = 0;
				k1     = Math.floor(m * Math.random());
				if (k1 >= m)
					k1 = m - 1;
				for (var i2 = 0; i2 < m && sw == 0; i2++) {
					sw = 1;
					for (var i3 = 0; i3 < n && sw > 0; i3++) {
						var k2 = p[i3] + k1;
						for (var i4 = 0; i4 < rl.koma && sw > 0; i4++) {
							if ((k1%DS.day)+i4 >= DS.day || k2+i4 >= sch1.length || sch1[k2+i4] >= 0)
								sw = 0;
						}
					}
					if (sw > 0) {
						st1[i1] = true;
						tm[i1]  = k1;
						for (var i3 = 0; i3 < n; i3++) {
							var k2 = p[i3] + k1;
							for (var i4 = 0; i4 < rl.koma; i4++)
								sch1[k2+i4] = i1;
						}
					}
					else {
						k1++;
						if (k1 >= m)
							k1 = 0;
					}
				}

				if (sw == 0) {
					DS.ta = DS.ta + "    free 科目（" + lc.k_name + "）を配置できませんでした！\n";
					ok    = false;
				}
			}
		}
	}
				// 実際の配置
	if (ok) {
		for (var i1 = 0; i1 < st.length; i1++) {
			if (st1[i1] && !st[i1]) {
				var rl = EX.r_lecture[i1];
				if (rl.room.length == 0)
					IND.room_set(i1, tm[i1]);   // 講義室の設定
				st[i1] = true;
			}
		}
		for (var i1 = 0; i1 < IND.sch.length; i1++)
			IND.sch[i1]  = sch1[i1];
	}

	return ok;
}
			//
			// Individual オブジェクト（メソッド room_reset）
			// 講義室の解放
			//      k : 講義番号
			//
Individual.prototype.room_reset = function(k)
{
	var rl = EX.r_lecture[k];
	for (var i1 = 0; i1 < rl.room.length; i1 += 2) {
		var k1 = rl.room[i1+1];
		if (k1 >= 0) {
			var kk            = rl.room[i1];
			IND.r_use[kk][k1] = false;
			IND.r_rat[k1]--;
		}
	}
	while (rl.room.length > 0)
		rl.room.pop();
}
			//
			// Individual オブジェクト（メソッド teacher_same）
			//   同じ科目担当教員の都合
			//      rl : 講義
			//      jigen : 時限
			//      return : OKか否か
			//
Individual.prototype.teacher_same = function(rl, jigen)
{
	var ok = true;

	for (var i1 = 0; i1 < rl.no.length; i1++) {
		var k1 = rl.no[i1];
		var lc = EX.lecture[k1];
		for (var i2 = 0; i2 < lc.t_name.length; i2++) {
			var str = lc.t_name[i2];
			var sw  = 0;
			for (var i3 = 0; i3 < EX.teacher.length && sw == 0; i3++) {
				var tc = EX.teacher[i3];
				if (str == tc.name) {
					sw = 1;
					if (tc.no_yes) {
						if (tc.h_list.length > 0) {
							for (var i4 = 0; i4 < tc.h_list.length && sw == 1; i4++) {
								k1 = tc.h_list[i4];
								if (k1 == jigen+lc.y) {
									sw = 2;
									for (var i5 = i4; i5 < tc.h_list.length-1; i5++)
										tc.h_list[i5] = tc.h_list[i5+1];
									tc.h_list.pop();
								}
							}
							if (sw == 1) {
								DS.ta = DS.ta + "教員（" + tc.name + "）の都合がつきません\n";
								ok    = false;
							}
						}
						else {
							DS.ta = DS.ta + "教員（" + tc.name + "）の講義可能日数が少なすぎます\n";
							ok    = false;
						}
					}
				}
			}
		}
	}

	return ok;
}
			//
			// Individual オブジェクト（メソッド teacher_ck）
			//   教員の重なりをチェック
			//      k : 講義番号
			//      pb : 基準位置
			//      p : 位置
			//      return : 重なっている講義
			//               （nullの場合は重なりなし）
			//
Individual.prototype.teacher_ck = function(k, pb, p)
{
	var lc2 = null;
	var rl  = EX.r_lecture[k];
	var m   = DS.day * DS.week;

	for (var i1 = 0; i1 < rl.no.length && lc2 == null; i1++) {
		var k1 = rl.no[i1];
		var lc = EX.lecture[k1];
		if (p%m >= (pb+lc.y)%m && p%m < (pb+lc.y)%m+lc.koma) {
			for (var i2 = 0; i2 < lc.t_name.length && lc2 == null; i2++) {
				var name = lc.t_name[i2];
				for (var i3 = p%m; i3 < IND.sch.length && lc2 == null; i3 += m) {
					if (IND.sch[i3] >= 0 && IND.sch[i3] != k) {
						var rl1 = EX.r_lecture[IND.sch[i3]];
						for (var i4 = 0; i4 < rl1.no.length && lc2 == null; i4++) {
							k1      = rl1.no[i4];
							var lc1 = EX.lecture[k1];
							var k2  = -1;
							for (var i5 = i3-1; i5 >= 0 && k2 < 0; i5--) {
								if (IND.sch[i5] != IND.sch[i3])
									k2 = i5 + 1;
							}
							if (k2 < 0)
								k2 = 0;
							if (p%m >= (k2+lc1.y)%m && p%m < (k2+lc1.y)%m+lc1.koma) {
								for (var i5 = 0; i5 < lc1.t_name.length && lc2 == null; i5++) {
									var name1 = lc1.t_name[i5];
									if (name1 == name)
										lc2 = lc1;
								}
							}
						}
					}
				}
			}
		}
	}

	return lc2;
}
			//
			// Individual オブジェクト（メソッド room_set）
			//   講義室の設定
			//      k : 講義番号
			//      p : 位置
			//      return : 設定可能か否か
			//
Individual.prototype.room_set = function(k, p)
{
	var ok = true;
	var rl = EX.r_lecture[k];
				// 講義室の設定
	for (var i1 = 0; i1 < rl.no.length; i1++) {
		var k1 = rl.no[i1];
		var lc = EX.lecture[k1];
		for (var i2 = 0; i2 < lc.room.length; i2++) {
					// 講義室を指定する
			var sw  = 0;
			var str = lc.room[i2];
			for (var i3 = 0; i3 < EX.r_name.length && sw == 0; i3++) {
				if (str == EX.r_name[i3]) {
					sw = 1;
					for (var i4 = 0; i4 < lc.koma; i4++) {
						rl.room[rl.room.length] = p + i4 + lc.y;
						if (IND.r_use[p+i4+lc.y][i3]) {
							rl.room[rl.room.length] = -1;
							ok = false;
						}
						else {
							IND.r_use[p+i4+lc.y][i3] = true;
							IND.r_rat[i3]++;
							rl.room[rl.room.length] = i3;
						}
					}
				}
			}
					// 講義室を指定しない
			if (sw == 0) {
						// 目標講義室
				var k2 = -1;
				for (var i3 = 0; i3 < EX.g_r_name.length && k2 < 0; i3++) {
					if (str == EX.g_r_name[i3])
						k2 = i3;
				}
				for (var i3 = EX.g_to_r[2*k2]; i3 <= EX.g_to_r[2*k2+1] && sw == 0; i3++) {
					sw = 1;
					for (var i4 = 0; i4 < lc.koma && sw > 0; i4++) {
						if (IND.r_use[p+i4+lc.y][i3])
							sw = 0;
					}
					if (sw > 0) {
						for (var i4 = 0; i4 < lc.koma; i4++) {
							IND.r_use[p+i4+lc.y][i3] = true;
							IND.r_rat[i3]++;
							rl.room[rl.room.length] = p + i4 + lc.y;
							rl.room[rl.room.length] = i3;
						}
					}
				}
						// 代替講義室
				if (sw == 0) {
					for (var i3 = 0; i3 < lc.r_room.length && sw == 0; i3++) {
						var str1 = lc.r_room[i3];
						k2       = -1;
						for (var i4 = 0; i4 < EX.g_r_name.length && k2 < 0; i4++) {
							if (str1 == EX.g_r_name[i4])
								k2 = i4;
						}
						for (var i4 = EX.g_to_r[2*k2]; i4 <= EX.g_to_r[2*k2+1] && sw == 0; i4++) {
							sw = 1;
							for (var i5 = 0; i5 < lc.koma && sw > 0; i5++) {
								if (IND.r_use[p+i5+lc.y][i4])
									sw = 0;
							}
							if (sw > 0) {
								for (var i5 = 0; i5 < lc.koma; i5++) {
									IND.r_use[p+i5+lc.y][i4] = true;
									IND.r_rat[i4]++;
									rl.room[rl.room.length] = p + i5 + lc.y;
									rl.room[rl.room.length] = i4;
								}
							}
						}
					}
				}
						// 講義室がない
				if (sw == 0) {
					ok = false;
					for (var i3 = 0; i3 < lc.koma; i3++) {
						rl.room[rl.room.length] = p + i3 + lc.y;
						rl.room[rl.room.length] = -1;
					}
				}
			}
		}
	}

	return ok;
}
			//
			// Individual オブジェクト（メソッド evaluation）
			//   評価値の計算
			//      return : 評価値
			//
Individual.prototype.evaluation = function()
{
	var s  = 0;
	var m  = DS.day * DS.week;
	var kd = new Array(DS.day);
	for (var i1 = 0; i1 < IND.cond.length; i1++)
		IND.cond[i1] = 0;
				// 講義室不足
	for (var i1 = 0; i1 < EX.r_lecture.length; i1++) {
		var rl = EX.r_lecture[i1];
		for (var i2 = 0; i2 < rl.room.length; i2 += 2) {
			var k1 = rl.room[i2+1];
			if (k1 < 0)
				IND.cond[1] += DS.weight[1];
		}
	}
				// 教員の重なり
	for (var i1 = 0; i1 < m; i1++) {
		for (var i2 = i1; i2 < IND.sch.length-m; i2 += m) {
			if (IND.sch[i2] >= 0)
				IND.cond[2] += DS.weight[2] * IND.teacher_pi(i2);
		}
	}
				// 複数コマ講義の中断，教員の都合，実験科目
	for (var i1 = 0; i1 < IND.sch.length; i1++) {
		if (IND.sch[i1] >= 0) {
			var rl    = EX.r_lecture[IND.sch[i1]];
			var now   = i1 % m;
			var sw    = 0;
			var jigen = 0;
			for (var i2 = i1-1; i2 >= 0 && sw == 0; i2--) {
				if (IND.sch[i2] != IND.sch[i1]) {
					jigen = i2 + 1;
					sw    = 1;
				}
			}
			jigen %= m;
					// 教員の都合
			var jikken = false;
			var hisshu = false;
			sw         = 0;
			var lc     = null;
			for (var i2 = 0; i2 < rl.no.length && sw == 0; i2++) {
				var k1 = rl.no[i2];
				lc     = EX.lecture[k1];
				if (lc.kind > 0)
					hisshu = true;
				if (lc.k_name.lastIndexOf("実験") >= 0)
					jikken = true;
				if (IND.move[i1] >= 0 && now >= jigen+lc.y && now < jigen+lc.y+lc.koma) {
					var tc = null;
					for (var i3 = 0; i3 < lc.t_name.length && sw == 0; i3++) {
						var str = lc.t_name[i3];
						for (var i4 = 0; i4 < EX.teacher.length && sw == 0; i4++) {
							tc = EX.teacher[i4];
							if (str == tc.name)
								sw = 1;
						}
					}
					sw = 0;
					for (var i3 = 0; i3 < tc.h_list.length && sw == 0; i3++) {
						k1 = tc.h_list[i3];
						if (k1 == now)
							sw = 1;
					}
				}
			}
			if (sw > 0)
				IND.cond[3] += DS.weight[3];
					// 複数コマ講義の中断
			if (rl.koma > 1 && jigen == now) {
				var k1 = jigen % DS.day + 1;
				var k2 = jigen % DS.day + rl.koma;
				if (k1 <= DS.mor && k2 > DS.mor || k2 > DS.day)
					IND.cond[4] += DS.weight[4];
			}
					// 実験科目
			if (jikken && IND.move[i1] >= 0 && jigen == now) {
				var k1 = jigen % DS.day + 1;
				var k2 = jigen % DS.day + rl.koma;
						// 実験の位置（午前中）
				if (k1 <= DS.mor && k2 <= DS.mor)
					IND.cond[6] += DS.weight[6];
						// 実験の位置（中間）
				else if (k1 > DS.mor && k2 < DS.day)
					IND.cond[5] += DS.weight[5];
			}
		}
	}
				// 配置（科目間）(大学用)
	if (DS.univ == 0) {
		for (var i1 = 0; i1 < IND.sch.length; i1 += DS.day) {
					// 科目の配置を調べる
			var k = 0;
			for (var i2 = i1; i2 < i1+DS.day; i2++) {
				if (IND.sch[i2] < 0)
					kd[k] = -1;
				else {
					var rl = EX.r_lecture[IND.sch[i2]];
					var sw = 0;
					for (var i3 = 0; i3 < rl.no.length && sw == 0; i3++) {
						var k1 = rl.no[i3];
						var lc = EX.lecture[k1];
						if (lc.kind > 0)
							sw = 1;
					}
					kd[k] = sw;
				}
				k++;
			}
					// 講義間に空き時間
					// 必修科目間に空き時間または選択科目
			var k1 = -1;
			var k2 = -1;
			for (var i2 = 0; i2 < DS.day; i2++) {
				if (kd[i2] >= 0) {
					if (k1 >= 0)
						IND.cond[7] += (i2 - k1 - 1) * DS.weight[7];
					k1 = i2;
					if (kd[i2] > 0) {
						if (k2 >= 0)
							IND.cond[8] += (i2 - k2 - 1) * DS.weight[8];
						k2 = i2;
					}
				}
			}
		}
	}
				// 配置（科目間）(高校用)
	else {
		for (var i1 = 0; i1 < IND.sch.length; i1 += DS.day) {
			for (var i2 = i1; i2 < i1+DS.day-1; i2++) {
				if (IND.sch[i2] >= 0) {
					var rl1 = EX.r_lecture[IND.sch[i2]];
					var k1  = rl1.no[0];
					var lc1 = EX.lecture[k1];
					for (var i3 = i2+rl1.koma; i3 < i1+DS.day; i3++) {
						if (IND.sch[i3] >= 0) {
							var rl2 = EX.r_lecture[IND.sch[i3]];
							k1      = rl2.no[0];
							var lc2 = EX.lecture[k1];
							if (lc1.k_name == lc2.k_name)
								IND.cond[7] += DS.weight[7];
							i3 += (rl2.koma - 1);
						}
					}
				}
			}
		}
	}

	var sw = 0;
	for (var i1 = 0; i1 < IND.cond.length; i1++) {
		s += IND.cond[i1];
		if (i1 < 4 && IND.cond[i1] > 0)
			sw = 1;
	}
	if (sw > 0)
		s = -s;

	return s;
}
			//
			// Individual オブジェクト（メソッド teacher_pi）
			// 教員の重なりに対する評価
			//      p : 位置
			//      return : 教員が重複している講義数
			//
Individual.prototype.teacher_pi = function(p)
{
	var s  = 0;
	var k  = IND.sch[p];
	var rl = EX.r_lecture[k];
	var m  = DS.day * DS.week;

	for (var i1 = 0; i1 < rl.no.length; i1++) {
		var k1 = rl.no[i1];
		var lc = EX.lecture[k1];
		k1     = -1;
		for (var i2 = p-1; i2 >= 0 && k1 < 0; i2--) {
			if (IND.sch[i2] != IND.sch[p])
				k1 = i2 + 1;
		}
		if (k1 < 0)
			k1 = 0;
		if (p%m >= (k1+lc.y)%m && p%m < (k1+lc.y)%m+lc.koma) {
			for (var i2 = 0; i2 < lc.t_name.length; i2++) {
				var name   = lc.t_name[i2];
				var k_name = null;
				for (var i3 = p+m; i3 < IND.sch.length; i3 += m) {
					if (IND.sch[i3] >= 0 && IND.sch[i3] != k) {
						var rl1 = EX.r_lecture[IND.sch[i3]];
						for (var i4 = 0; i4 < rl1.no.length; i4++) {
							k1      = rl1.no[i4];
							var lc1 = EX.lecture[k1];
							if (k_name == null || lc1.k_name != k_name) {
								var k2  = -1;
								for (var i5 = i3-1; i5 >= 0 && k2 < 0; i5--) {
									if (IND.sch[i5] != IND.sch[i3])
										k2 = i5 + 1;
								}
								if (k2 < 0)
									k2 = 0;
								if (p%m >= (k2+lc1.y)%m && p%m < (k2+lc1.y)%m+lc1.koma) {
									for (var i5 = 0; i5 < lc1.t_name.length; i5++) {
										var name1 = lc1.t_name[i5];
										if (name1 == name) {
											s++;
											k_name = lc1.k_name;
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}

	return s;
}
			//
			// Individual オブジェクト（メソッド neighbor_search）
			//   近傍探索
			//      return : 成功か否か
			//
Individual.prototype.neighbor_search = function()
{
	var koma_s = -1;
	var m2_s   = -1;
	var m3_s   = -1;
	var ok     = -1;
	var ob     = new Array(EX.s_nen.length+1);
	var ob_s   = new Array(EX.s_nen.length+1);
	var res    = true;
	var same   = false;
				// 現在状態の保存
	var m   = DS.day * DS.week;
	IND.pi1 = IND.pi;
	for (var i1 = 0; i1 < IND.cond.length; i1++)
		IND.cond1[i1] = IND.cond[i1];
	for (var i1 = 0; i1 < EX.r_name.length; i1++)
		IND.r_rat1[i1] = IND.r_rat[i1];
	for (var i1 = 0; i1 < m; i1++) {
		for (var i2 = 0; i2 < EX.r_name.length; i2++)
			IND.r_use1[i1][i2] = IND.r_use[i1][i2];
	}
	for (var i1 = 0; i1 < EX.r_lecture.length; i1++) {
		var rl  = EX.r_lecture[i1];
		var tmp = new Array();
		for (var i2 = 0; i2 < rl.room.length; i2++)
			tmp[i2] = rl.room[i2];
		IND.room[i1] = tmp;
	}
	for (var i1 = 0; i1 < IND.sch.length; i1++) {
		IND.sch1[i1]  = IND.sch[i1];
		IND.move1[i1] = IND.move[i1];
	}
				// 学科，学年の選択
	var m1 = Math.floor(EX.s_nen.length * Math.random());
	if (m1 >= EX.s_nen.length)
		m1 = EX.s_nen.length - 1;
	m1 *= m;

	for (var i1 = 0; i1 < EX.s_nen.length && ok <= 0; i1++) {
				// 科目の選択（その1）
		var m2 = Math.floor(m * Math.random());
		if (m2 >= m)
			m2 = m - 1;
		var sw = 0;
		while (sw == 0) {
			if (m2 == 0)
				sw = 1;
			else {
				if (IND.sch[m1+m2-1] < 0 || IND.sch[m1+m2-1] != IND.sch[m1+m2])
					sw = 1;
				else
					m2--;
			}
		}

		for (var i2 = 0; i2 < m && ok <= 0; i2++) {
				// 科目の選択（その2）
			var k1;
			if (IND.sch[m1+m2] >= 0) {
				var rl = EX.r_lecture[IND.sch[m1+m2]];
				k1     = m2 + rl.koma;
			}
			else
				k1 = m2 + 1;

			for (var i3 = k1; i3 < m && ok <= 0; i3++) {
				var m3   = i3;
				var koma = IND.change_check(m1+m2, m1+m3, ob);   // 交換可能か
				if (koma > 0) {
					ok = IND.change((m1+m2)%m, (m1+m3)%m, ob, koma, false);   // 交換
					if (ok == 0 && !same) {
						same   = true;
						m2_s   = (m1 + m2) % m;
						m3_s   = (m1 + m3) % m;
						koma_s = koma;
						for (var i4 = 0; i4 < ob_s.length; i4++)
							ob_s[i4] = ob[i4];
					}
				}
				if (ok <= 0) {
					if (IND.sch[m1+m3] >= 0) {
						var rl = EX.r_lecture[IND.sch[m1+m3]];
						if (rl.koma > 1) {
							m3 += (rl.koma - 1);
							i3 += (rl.koma - 1);
						}
					}
					m3++;
				}
			}

			if (ok <= 0) {
				if (IND.sch[m1+m2] >= 0) {
					var rl = EX.r_lecture[IND.sch[m1+m2]];
					if (rl.koma > 1) {
						m2 += (rl.koma - 1);
						i2 += (rl.koma - 1);
					}
				}
				m2++;
				if (m2 >= m)
					m2 = 0;
			}
		}

		if (ok <= 0) {
			m1 += m;
			if (m1 >= m * EX.s_nen.length)
				m1 = 0;
		}
	}

	if (ok > 0)
		EX.count_a = 0;
	else {
		res = false;
		if (same && IND.pi != 0) {
			EX.count_a++;
			if (EX.count_a < DS.max_tri) {
				ok  = IND.change(m2_s, m3_s, ob_s, koma_s, true);
				res = true;
			}
		}
	}

	while (IND.room.length > 0)   // クリア
		IND.room.pop();

	return res;
}
			//
			// Individual オブジェクト（メソッド change_check）
			// 位置の交換が可能か否かのチェック
			//      m1, m2 : 2つの位置
			//      ob : 交換対象位置
			//      return : コマ数
			//
Individual.prototype.change_check = function(m1, m2, ob)
{
	var koma = 0;
	var m    = DS.day * DS.week;
	var k1   = m1 % m;
	var k2   = m2 % m;
	ob[0]    = 1;
	ob[1]    = Math.floor(m1 / m);
	var temp = new Array();
				// コマ数のチェック（自学科）
	if (IND.sch[m1] >= 0) {
		var rl1  = EX.r_lecture[IND.sch[m1]];
		koma     = rl1.koma;
		temp.push(IND.sch[m1]);
		if (IND.sch[m2] >= 0) {
			var rl2 = EX.r_lecture[IND.sch[m2]];
			temp.push(IND.sch[m2]);
			if (rl2.koma != koma) {
				var k;
				if (rl2.koma > koma) {
					k    = m1;
					koma = rl2.koma;
				}
				else
					k = m2;
				var kk = 0;
				while (kk < koma) {
					if (k >= IND.sch.length)
						kk = koma + 1;
					else {
						if (IND.sch[k] < 0) {
							kk++;
							k++;
						}
						else {
							if (kk > 0)
								temp.push(IND.sch[k]);
							var rl = EX.r_lecture[IND.sch[k]];
							kk    += rl.koma;
							k     += rl.koma;
						}
					}
				}
				if (kk > koma || k1+kk > m || k2+kk > m)
					koma = 0;
			}
		}
		else {
			var kk = 1;
			var k  = m2 + 1;
			while (kk < koma) {
				if (k >= IND.sch.length)
					kk = koma + 1;
				else {
					if (IND.sch[k] < 0) {
						kk++;
						k++;
					}
					else {
						temp.push(IND.sch[k]);
						var rl = EX.r_lecture[IND.sch[k]];
						kk    += rl.koma;
						k     += rl.koma;
					}
				}
			}
			if (kk > koma || k1+kk > m || k2+kk > m)
				koma = 0;
		}
	}
	else {
		if (IND.sch[m2] >= 0) {
			temp.push(IND.sch[m2]);
			var rl2 = EX.r_lecture[IND.sch[m2]];
			koma    = rl2.koma;
			var kk  = 1;
			var k   = m1 + 1;
			while (kk < koma) {
				if (k >= IND.sch.length)
					kk = koma + 1;
				else {
					if (IND.sch[k] < 0) {
						kk++;
						k++;
					}
					else {
						temp.push(IND.sch[k]);
						var rl = EX.r_lecture[IND.sch[k]];
						kk    += rl.koma;
						k     += rl.koma;
					}
				}
			}
			if (kk > koma || k1+kk > m || k2+kk > m)
				koma = 0;
		}
		else
			koma = 0;
	}
				// コマ数のチェック（他学科）
	if (koma > 0 && (m2 >= m1+koma || m1 >= m2+koma)) {
		var sw0 = 1;
		while (sw0 > 0) {
			sw0 = 0;
			for (var i1 = 0; i1 < IND.sch.length && koma > 0; i1 += m) {
				var sw = 0;
				for (var i2 = 1; i2 <= ob[0] && sw == 0; i2++) {
					if (Math.floor(i1/m) == ob[i2])
						sw = 1;
				}
				if (sw == 0) {
					for (var i2 = 0; i2 < koma; i2++) {
						if (i1+k1+i2 < IND.sch.length && IND.sch[i1+k1+i2] >= 0) {
							for (var i3 = 0; i3 < temp.length; i3++) {
								if (temp[i3] == IND.sch[i1+k1+i2]) {
									sw = 1;
									break;
								}
							}
						}
						if (i1+k2+i2 < IND.sch.length && IND.sch[i1+k2+i2] >= 0) {
 							for (var i3 = 0; i3 < temp.length; i3++) {
								if (temp[i3] == IND.sch[i1+k2+i2]) {
									sw = 1;
									break;
								}
							}
						}
					}
					if (sw > 0) {
						if (k1 > 0 && IND.sch[i1+k1-1] >= 0 && IND.sch[i1+k1-1] == IND.sch[i1+k1])
							koma = 0;
						else if (k2 > 0 && IND.sch[i1+k2-1] >= 0 && IND.sch[i1+k2-1] == IND.sch[i1+k2])
							koma = 0;
						if (koma > 0) {
							var kk = 0;
							var k  = i1 + k1;
							while (kk < koma) {
								if (k >= IND.sch.length)
									kk = koma + 1;
								else {
									if (IND.sch[k] < 0) {
										kk++;
										k++;
									}
									else {
										var sw2 = 0;
										for (var i2 = 0; i2 < temp.length; i2++) {
											if (temp[i2] == IND.sch[k]) {
												sw2 = 1;
												break;
											}
										}
										if (sw2 == 0) {
											temp.push(IND.sch[k]);
											sw0 = 1;
										}
										var rl = EX.r_lecture[IND.sch[k]];
										kk    += rl.koma;
										k     += rl.koma;
									}
								}
							}
							if (kk > koma || k1+kk > m || k2+kk > m)
								koma = 0;
							else {
								kk = 0;
								k  = i1 + k2;
								while (kk < koma) {
									if (k >= IND.sch.length)
										kk = koma + 1;
									else {
										if (IND.sch[k] < 0) {
											kk++;
											k++;
										}
										else {
											var sw2 = 0;
											for (var i2 = 0; i2 < temp.length; i2++) {
												if (temp[i2] == IND.sch[k]) {
													sw2 = 1;
													break;
												}
											}
											if (sw2 == 0) {
												temp.push(IND.sch[k]);
												sw0 = 1;
											}
											var rl = EX.r_lecture[IND.sch[k]];
											kk    += rl.koma;
											k     += rl.koma;
										}
									}
								}
								if (kk > koma || k1+kk > m || k2+kk > m)
									koma = 0;
								else {
									ob[0]++;
									ob[ob[0]] = Math.floor(i1 / m);
								}
							}
						}
					}
				}
			}
		}
	}
				// 開始時限の指定がある場合
	if (koma > 0) {
		for (var i1 = 1; i1 <= ob[0] && koma > 0; i1++) {
			var sw = 0;
			var kk = m * ob[i1];
			var k  = 0;
			while (k < koma && sw == 0) {
				if (IND.sch[kk+k1+k] >= 0) {
					if (IND.move[kk+k1+k] == 0)
						sw = 1;
					else {
						var rl = EX.r_lecture[IND.sch[kk+k1+k]];
						k     += rl.koma;
					}
				}
				else
					k++;
			}
			if (sw == 0) {
				k = 0;
				while (k < koma && sw == 0) {
					if (IND.sch[kk+k2+k] >= 0) {
						if (IND.move[kk+k2+k] == 0)
							sw = 1;
						else {
							var rl = EX.r_lecture[IND.sch[kk+k2+k]];
							k     += rl.koma;
						}
					}
					else
						k++;
				}
			}
			if (sw > 0) {
				if ((kk+k1)%DS.day != (kk+k2)%DS.day)
					koma = 0;
			}
		}
	}
				// 開講日時指定科目
	if (koma > 0) {
		for (var i1 = 1; i1 <= ob[0] && koma > 0; i1++) {
			var kk = m * ob[i1];
			var k  = 0;
			while (k < koma && koma > 0) {
				if (IND.sch[kk+k1+k] >= 0) {
					if (IND.move[kk+k1+k] < 0)
						koma = 0;
					else {
						var rl = EX.r_lecture[IND.sch[kk+k1+k]];
						k     += rl.koma;
					}
				}
				else
					k++;
			}
			if (koma > 0) {
				k = 0;
				while (k < koma && koma > 0) {
					if (IND.sch[kk+k2+k] >= 0) {
						if (IND.move[kk+k2+k] < 0)
							koma = 0;
						else {
							var rl = EX.r_lecture[IND.sch[kk+k2+k]];
							k     += rl.koma;
						}
					}
					else
						k++;
				}
			}
		}
	}

	return koma;
}
			//
			// Individual オブジェクト（メソッド change
			// 位置の交換
			//      m1, m2 : 2つの位置
			//      ob : 交換対象位置
			//      koma : コマ数
			//      same : 同じ場合に変換するか否か
			//      return : =1:改善，=0:同じ，-1:改悪
			//
Individual.prototype.change = function(m1, m2, ob, koma, same)
{
	var ok = 1;
	var m  = DS.day * DS.week;
				// 交換の実施
					// 使用している講義室を開放
	for (var i1 = 1; i1 <= ob[0]; i1++) {
		var kb = m * ob[i1];
		for (var i2 = 0; i2 < 2; i2++) {
			var k  = 0;
			var kk = (i2 == 0) ? kb + m1 : kb + m2;
			while (k < koma) {
				var k1 = kk + k;
				if (IND.sch[k1] >= 0) {
					var rl = EX.r_lecture[IND.sch[k1]];
					if (rl.room.length > 0)
						IND.room_reset(IND.sch[k1]);
					for (var i3 = 0; i3 < rl.koma; i3++)
						IND.sch[k1+i3] = -1;
					k += rl.koma;
				}
				else
					k++;
			}
		}
	}
					// 位置を交換
	var sch2 = new Array(IND.sch.length);
	for (var i1 = 0; i1 < sch2.length; i1++)
		sch2[i1] = true;
	for (var i1 = 1; i1 <= ob[0]; i1++) {
		var kb = m * ob[i1];
		for (var i2 = 0; i2 < 2; i2++) {
			var k1;
			var k2;
			var k3;
			if (i2 == 0) {
				k1 = kb + m1;
				k2 = kb + m2;
				k3 = m1;
			}
			else {
				k1 = kb + m2;
				k2 = kb + m1;
				k3 = m2;
			}
			var k = 0;
			while (k < koma) {
				if (IND.sch1[k2+k] >= 0) {
					var rl = EX.r_lecture[IND.sch1[k2+k]];
					for (var i3 = 0; i3 < rl.koma; i3++) {
						IND.sch[k1+k+i3]  = IND.sch1[k2+k+i3];
						sch2[k1+k+i3]     = false;
						IND.move[k1+k+i3] = IND.move1[k2+k+i3];
					}
					if (rl.room.length == 0)
						IND.room_set(IND.sch[k1+k], k3);
					k  += rl.koma;
					k3 += rl.koma;
				}
				else {
					IND.sch[k1+k]  = -1;
					IND.move[k1+k] = 1;
					k++;
				}
			}
		}
	}
					// 交換による講義室確保状況の変更
	for (var i1 = 0; i1 < sch2.length; i1++) {
		if (IND.sch[i1] >= 0) {
			var rl = EX.r_lecture[IND.sch[i1]];
			if (sch2[i1]) {
				var k1 = i1 % m;
				var k2 = k1 + rl.koma - 1;
				if (k1 >= m1 && k1 < m1+koma || k1 >= m2 && k1 < m2+koma || k2 >= m1 && k2 < m1+koma || k2 >= m2 && k2 < m2+koma) {
					var sw = 0;
					for (var i2 = 0; i2 < rl.room.length && sw == 0; i2 += 2) {
						k2 = rl.room[i2+1];
						if (k2 < 0)
							sw = 1;
					}
					if (sw > 0) {
						IND.room_reset(IND.sch[i1]);
						IND.room_set(IND.sch[i1], k1);
					}
				}
			}
			i1 += (rl.koma - 1);
		}
	}
					// 評価値の計算
	IND.pi = IND.evaluation();
				// 元の状態に戻す
	if (Math.abs(IND.pi) >= Math.abs(IND.pi1)) {
		if (Math.abs(IND.pi) == Math.abs(IND.pi1))
			ok = 0;
		else
			ok = -1;
		if (ok < 0 || !same) {
			IND.pi = IND.pi1;
			for (var i1 = 0; i1 < IND.cond.length; i1++)
				IND.cond[i1] = IND.cond1[i1];
			for (var i1 = 0; i1 < EX.r_name.length; i1++)
				IND.r_rat[i1] = IND.r_rat1[i1];
			for (var i1 = 0; i1 < m; i1++) {
				for (var i2 = 0; i2 < EX.r_name.length; i2++)
					IND.r_use[i1][i2] = IND.r_use1[i1][i2];
			}
			for (var i1 = 0; i1 < EX.r_lecture.length; i1++) {
				var rl = EX.r_lecture[i1];
				var tmp = new Array();
				for (var i2 = 0; i2 < IND.room[i1].length; i2++)
					tmp[i2] = IND.room[i1][i2];
				rl.room = tmp;
			}
			for (var i1 = 0; i1 < IND.sch.length; i1++) {
				IND.sch[i1]  = IND.sch1[i1];
				IND.move[i1] = IND.move1[i1];
			}
		}
	}

	return ok;
}
