/********************/
/* 入力データの設定 */
/********************/
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class Data_set extends Panel
{
	TextArea room_data;   // 講義室データ
	TextArea teacher_data;   // 教員データ
	TextArea lecture_data;   // 講義データ
	int MAX_C = 9;
	int max_tri;   // 最大試行回数
	int o_lvl;   // 出力レベル
	int seed;   // 乱数の初期値
	int mor;   // 午前中コマ数
	int week;   // １週間の講義日数
	int day;   // １日あたりのコマ数
	int weight[] = new int [MAX_C];
	int univ = 0;   // 大学用(0)，高校用(1)
	Schedule_w Sch;

	/******************/
	/* コンストラクタ */
	/******************/
	Data_set(Schedule_w Sch_i)
	{
		Sch = Sch_i;
					// レイアウト
		setLayout(new BorderLayout(5, 10));
					// 一般データ
		Data_g DG = new Data_g(this);
		add(DG, BorderLayout.SOUTH);
					// 講義室データ，教員データ，科目データ
		add(new Data_f(this, DG), BorderLayout.CENTER);
	}
}

/**********************************/
/* 講義室，教員，及び，科目データ */
/**********************************/
class Data_f extends Panel implements ActionListener {
	Data_set DS;
	Data_g DG;
	Button bt, room_bt, teacher_bt, lecture_bt;

	String room_csv0 = "ＷＳ室１,501第1ＷＳ室,,,,,\nＷＳ室２,508第2ＷＳ室,,,,,\nＷＳ室３,509第3ＷＳ室,,,,,\n情報演習室１,504第1情報演習室,,,,,\n情報演習室２,201第2情報演習室,202第2情報演習室,505第2情報演習室,506第2情報演習室,,\nＬＬ教室,205ＬＬ教室,206ＬＬ教室,,,,\n大講義室１,300講義室,,,,,\n大講義室２,302講義室,309講義室,,,,\n中講義室,101講義室,102講義室,104講義室,105講義室,106講義室,107講義室\n小講義室,301講義室,305講義室,306講義室,307講義室,308講義室,310講義室\nセミナー室,512-1セミナー室,512-2セミナー室,,,,\n製図室,206製図室,,,,,\n実験室１,201実験室,,,,,\n実験室２,202実験室,,,,,\n実験室３,301実験室,,,,,\n実験室４,302実験室,,,,,\n実験室５,326多目的実験室\n実験室６,401実験室\n実験室７,創作ショップ\n実験室８,第２工作センター\n屋内体育施設,体育館\n屋外体育施設,グランド\n";

	String room_csv1 = "講義室,１の１,１の２,１の３,１の４,１の５,１の６,１の７,２の１,２の２,２の３,２の４,２の５,２の６,２の７,２の８,３の１,３の２,３の３,３の４,３の５,３の６,３の７,３の８,３の９\n屋外体育施設,グランド,,,,,,,,,,,,,,,,,,,,,,,\n音楽教室,101音楽教室,,,,,,,,,,,,,,,,,,,,,,,\n家庭科室,101家庭科室,,,,,,,,,,,,,,,,,,,,,,,\n情報教室,101情報教室,,,,,,,,,,,,,,,,,,,,,,,\n美術教室,101美術教室,,,,,,,,,,,,,,,,,,,,,,,\nダミー教室,ダミー教室１,ダミー教室２,ダミー教室３,,,,,,,,,,,,,,,,,,,,,\n";

	String teacher_csv0 = "山田太郎,,,,,\n,所属,基礎教育室,,,\n,不可能,火,4,火,5\n山田次郎,,,,,\n,所属,基礎教育室,,,\n,不可能,火,4,火,5\n山田三郎,,,,,\n,所属,機械工学科,,,\n,不可能,火,4,火,5\n山田四郎,,,,,\n,所属,機械工学科,,,\n,不可能,火,4,火,5\n山田五郎,,,,,\n,所属,機械工学科,,,\n,不可能,火,4,火,5\n鈴木一郎,,,,,\n,所属,機械工学科,,,\n,不可能,火,4,火,5\n鈴木次郎,,,,,\n,所属,機械工学科,,,\n,不可能,火,4,火,5\n鈴木三郎,,,,,\n,所属,機械工学科,,,\n,不可能,火,4,火,5\n鈴木六郎,,,,,\n,所属,機械工学科,,,\n,不可能,火,4,火,5\n鈴木史朗,,,,,\n,所属,機械工学科,,,\n,不可能,火,4,火,5\n鈴木五郎,,,,,\n,所属,機械工学科,,,\n,不可能,火,4,火,5,,\n佐藤一郎,,,,,,,\n,所属,機械工学科,,,,,\n,不可能,火,4,火,5,,\n佐藤二朗,,,,,,,\n,所属,機械工学科,,,,,\n,不可能,火,4,火,5,,\n佐藤三郎,,,,,,,\n,所属,機械工学科,,,,,\n,不可能,火,4,火,5,火,3\n佐藤四郎,,,,,,,\n,所属,機械工学科,,,,,\n,不可能,火,4,火,5,,\n機械新任Ａ,,,,,,,\n,所属,機械工学科,,,,,\n,不可能,火,4,火,5,,\n機械新任Ｂ,,,,,,,\n,所属,機械工学科,,,,,\n,不可能,火,4,火,5,,\n佐藤五郎,,,,,,,\n,所属,電気電子工学科,,,,,\n,不可能,火,4,火,5,,\n山田花子,,,,,,,\n,所属,電気電子工学科,,,,,\n,不可能,火,4,火,5,火,3\n鈴木花子,,,,,,,\n,所属,電気電子工学科,,,,,\n,不可能,火,4,火,5,火,3\n佐藤花子,,,,,,,\n,所属,電気電子工学科,,,,,\n,不可能,火,4,火,5,,\n川村一郎,,,,,,,\n,所属,電気電子工学科,,,\n,不可能,火,4,火,5\n川村次郎,,,,,\n,所属,電気電子工学科,,,\n,不可能,火,4,火,5\n川村三郎,,,,,\n,所属,電気電子工学科,,,\n,不可能,火,4,火,5\n川村四郎,,,,,\n,所属,電気電子工学科,,,\n,不可能,火,4,火,5\n川村五郎,,,,,\n,所属,電気電子工学科,,,\n,不可能,火,4,火,5\n林一郎,,,,,\n,所属,電気電子工学科,,,\n,不可能,火,4,火,5\n林次郎,,,,,\n,所属,電気電子工学科,,,\n,不可能,火,4,火,5\n林三郎,,,,,\n,所属,電気電子工学科,,,\n,不可能,火,4,火,5\n林四郎,,,,,\n,所属,コンピュータシステム学科,情報システム学科,,\n,不可能,火,4,火,5\n林五郎,,,,,\n,所属,コンピュータシステム学科,情報システム学科,,\n,不可能,火,4,火,5\n菅沼花子,,,,,\n,所属,コンピュータシステム学科,情報システム学科,,\n,不可能,火,4,火,5\n菅沼幸子,,,,,,,\n,所属,コンピュータシステム学科,情報システム学科,,,,\n,不可能,火,4,火,5,,\n田中一郎,,,,,,,\n,所属,コンピュータシステム学科,情報システム学科,,,,\n,不可能,火,4,火,5,,\n田中次郎,,,,,,,\n,所属,コンピュータシステム学科,情報システム学科,,,,\n,不可能,火,4,火,5,火,3\n田中三郎,,,,,,,\n,所属,コンピュータシステム学科,情報システム学科,,,,\n,不可能,火,4,火,5,,\n田中四郎,,,,,,,\n,所属,コンピュータシステム学科,情報システム学科,,,,\n,不可能,火,4,火,5,,\n田中五郎,,,,,,,\n,所属,コンピュータシステム学科,情報システム学科,,,,\n,不可能,火,4,火,5,,\n田中花子,,,,,,,\n,所属,人間情報デザイン学科,情報システム学科,,,,\n,不可能,火,4,火,5,火,3\n田中幸子,,,,,,,\n,所属,人間情報デザイン学科,情報システム学科,,,,\n,不可能,火,4,火,5,,\n菅沼一郎,,,,,,,\n,所属,人間情報デザイン学科,情報システム学科,,,,\n,不可能,火,4,火,5,,\n菅沼次郎,,,,,,,\n,所属,人間情報デザイン学科,情報システム学科,,,,\n,不可能,火,4,火,5,,\n菅沼三郎,,,,,,,\n,所属,人間情報デザイン学科,情報システム学科,,,,\n,不可能,火,4,火,5\n菅沼四郎,,,,,\n,所属,人間情報デザイン学科,情報システム学科,,\n,不可能,火,4,火,5\n菅沼五郎,,,,,\n,所属,人間情報デザイン学科,情報システム学科,,\n,不可能,火,4,火,5\n夏目一郎,,,,,\n,所属,人間情報デザイン学科,情報システム学科,,\n,不可能,火,4,火,5\n夏目次郎,,,,,\n,所属,人間情報デザイン学科,情報システム学科,,\n,不可能,火,4,火,5\n夏目三郎,,,,,\n,所属,人間情報デザイン学科,情報システム学科,,\n,不可能,火,4,火,5\n夏目四郎,,,,,,,\n,所属,人間情報デザイン学科,情報システム学科,,,,\n,不可能,火,4,火,5,,\n夏目五郎,,,,,,,\n,所属,人間情報デザイン学科,情報システム学科,,,,\n,不可能,火,4,火,5,,\n夏目花子,,,,,,,\n,所属,人間情報デザイン学科,情報システム学科,,,,\n,不可能,火,4,火,5,,\n夏目幸子,,,,,,,\n,所属,人間情報デザイン学科,情報システム学科,,,,\n,不可能,火,4,火,5,火,3\n高柳一郎,,,,,,,\n,所属,人間情報デザイン学科,情報システム学科,,,,\n,不可能,火,4,火,5,,\n高柳次郎,,,,,,,\n,所属,人間情報デザイン学科,情報システム学科,,,,,,,,,,,,\n,不可能,火,4,火,5,,,,,,,,,,\n高柳三郎,,,,,,,,,,,,,,,\n,所属,物質生命科学科,,,,,,,,,,,,,\n,不可能,火,4,火,5,,,,,,,,,,\n高柳四郎,,,,,,,,,,,,,,,\n,所属,物質生命科学科,,,,,,,,,,,,,\n,不可能,火,4,火,5,,,,,,,,,,\n高柳五郎,,,,,,,,,,,,,,,\n,所属,物質生命科学科,,,,,,,,,,,,,\n,不可能,火,4,火,5,火,3,月,2,水,1,水,2,水,3\n高柳花子,,,,,,,,,,,,,,,\n,所属,物質生命科学科,,,,,,,,,,,,,\n,不可能,火,4,火,5,,,,,,,,,,\n高柳幸子,,,,,,,,,,,,,,,\n,所属,物質生命科学科,,,,,,,,,,,,,\n,不可能,火,4,火,5,,\n横山一郎,,,,,,,\n,所属,物質生命科学科,,,,,\n,不可能,火,4,火,5,火,3\n横山次郎,,,,,,,\n,所属,物質生命科学科,,,,,\n,不可能,火,4,火,5,,\n横山三郎,,,,,,,\n,所属,物質生命科学科,,,,,\n,不可能,火,4,火,5,,\n横山四郎,,,,,,,\n,所属,物質生命科学科,,,,,\n,不可能,火,4,火,5,,\n横山五郎,,,,,,,\n,所属,物質生命科学科,,,,,\n,不可能,火,4,火,5,,\n横山花子,,,,,\n,所属,物質生命科学科,,,\n,不可能,火,4,火,5\n横山幸子,,,,,\n,所属,物質生命科学科,,,\n,不可能,火,4,火,5\n土方一郎,,,,,\n,所属,物質生命科学科,,,\n,不可能,火,4,火,5\n物質新任Ａ,,,,,\n,所属,物質生命科学科,,,\n,不可能,火,4,火,5\n物質新任Ｂ,,,,,\n,所属,物質生命科学科,,,\n,不可能,火,4,火,5\n土方次郎,,,,,\n,所属,教育開発センター,,,\n,不可能,,,,\n土方三郎,,,,,\n,所属,教育開発センター,,,\n,不可能,,,,\n土方四郎,,,,,\n,所属,教育開発センター,,,\n,不可能,,,,\n土方五郎,,,,,\n,所属,教育開発センター,,,\n,不可能,,,,\n加藤一郎,,,,,\n,所属,学長,,,\n,可能,水,1,水,2\n加藤次郎,,,,,\n,所属,理事,,,\n,可能,水,1,水,2\n加藤三郎,,,,,\n,所属,客員,,,\n,不可能,,,,\n加藤四郎,,,,,\n,所属,非常勤,,,\n,可能,火,4,火,5\n加藤五郎,,,,,\n,所属,非常勤,,,\n,可能,火,1,,\n加藤花子,,,,,\n,所属,非常勤,,,\n,可能,火,1,,\n加藤幸子,,,,,\n,所属,非常勤,,,\n,可能,金,1,金,2\n石田一郎,,,,,,,\n,所属,非常勤,,,,,\n,可能,火,4,火,5,,\n石田次郎,,,,,,,\n,所属,非常勤,,,,,\n,可能,火,1,火,2,月,2\n石田三郎,,,,,,,\n,所属,非常勤,,,,,\n,可能,火,1,火,2,,\n石田四郎,,,,,,,\n,所属,非常勤,,,,,\n,可能,水,1,水,2,,\n石田五郎,,,,,,,\n,所属,非常勤,,,,,\n,可能,木,1,木,2,,\n石田花子,,,,,,,\n,所属,非常勤,,,\n,可能,木,1,木,2\n石田幸子,,,,,\n,所属,非常勤,,,\n,可能,火,3,,\n近藤一郎,,,,,\n,所属,非常勤,,,\n,可能,火,4,火,5\n近藤次郎,,,,,\n,所属,非常勤,,,\n,可能,金,1,,\n近藤三郎,,,,,\n,所属,非常勤,,,\n,可能,火,4,火,5\n近藤四郎,,,,,\n,所属,非常勤,,,\n,可能,木,1,木,2\n近藤五郎,,,,,\n,所属,非常勤,,,\n,可能,火,1,,\n近藤花子,,,,,\n,所属,非常勤,,,\n,可能,水,1,水,2\n近藤幸子,,,,,\n,所属,非常勤,,,\n,可能,月,1,,\n沖田一郎,,,,,\n,所属,非常勤,,,\n,可能,火,4,火,5\n沖田次郎,,,,,\n,所属,非常勤,,,\n,可能,金,1,金,2\n沖田三郎,,,,,\n,所属,非常勤,,,\n,可能,火,1,火,2\n沖田四郎,,,,,\n,所属,非常勤,,,\n,可能,火,1,火,2\n沖田五郎,,,,,\n,所属,非常勤,,,\n,可能,火,4,火,5\n電子非常勤Ａ,,,,,\n,所属,非常勤,,,\n,可能,火,2,,\n物質非常勤Ｂ,,,,,\n,所属,非常勤,,,\n,可能,火,4,,\n";

	String teacher_csv1 = "愛澤,,\n,所属,専任\n,不可能,\n青柳,,\n,所属,専任\n,不可能,\n浅野,,\n,所属,専任\n,不可能,\n池田,,\n,所属,専任\n,不可能,\n岩館,,\n,所属,専任\n,不可能,\n岩淵,,\n,所属,専任\n,不可能,\n上杉,,\n,所属,専任\n,不可能,\n宇都宮,,\n,所属,専任\n,不可能,\n奥山,,\n,所属,専任\n,不可能,\n桂島,,\n,所属,専任\n,不可能,\n狩野,,\n,所属,専任\n,不可能,\n神成,,\n,所属,専任\n,不可能,\n川上,,\n,所属,専任\n,不可能,\n川村,,\n,所属,専任\n,不可能,\n木村篤,,\n,所属,専任\n,不可能,\n木村剛,,\n,所属,専任\n,不可能,\n黒澤,,\n,所属,専任\n,不可能,\n小林,,\n,所属,専任\n,不可能,\n齋藤,,\n,所属,専任\n,不可能,\n嵯峨,,\n,所属,専任\n,不可能,\n佐々木,,\n,所属,専任\n,不可能,\n佐二,,\n,所属,専任\n,不可能,\n佐竹,,\n,所属,専任\n,不可能,\n佐藤一,,\n,所属,専任\n,不可能,\n佐藤浩,,\n,所属,専任\n,不可能,\n佐藤春,,\n,所属,専任\n,不可能,\n清水,,\n,所属,専任\n,不可能,\n庄司,,\n,所属,専任\n,不可能,\n神保,,\n,所属,専任\n,不可能,\n菅原,,\n,所属,専任\n,不可能,\n鈴木秀,,\n,所属,専任\n,不可能,\n鈴利,,\n,所属,専任\n,不可能,\n高橋,,\n,所属,専任\n,不可能,\n竹内,,\n,所属,専任\n,不可能,\n鶴岡,,\n,所属,専任\n,不可能,\n富岡,,\n,所属,専任\n,不可能,\n富永,,\n,所属,専任\n,不可能,\n中鉢,,\n,所属,専任\n,不可能,\n中村,,\n,所属,専任\n,不可能,\n長谷川,,\n,所属,専任\n,不可能,\n早坂,,\n,所属,専任\n,不可能,\n針生,,\n,所属,専任\n,不可能,\n細倉,,\n,所属,専任\n,不可能,\n本田,,\n,所属,専任\n,不可能,\n増田,,\n,所属,専任\n,不可能,\n松崎,,\n,所属,専任\n,不可能,\n三浦,,\n,所属,専任\n,不可能,\n村上,,\n,所属,専任\n,不可能,\n村松,,\n,所属,専任\n,不可能,\n山形,,\n,所属,専任\n,不可能,\n遊佐,,\n,所属,専任\n,不可能,\n雪江,,\n,所属,専任\n,不可能,\n横橋,,\n,所属,専任\n,不可能,\n横山,,\n,所属,専任,,,,,\n,不可能,,,,,,\n渡部,,,,,,,\n,所属,専任,,,,,\n,不可能,,,,,,\nａｉｋｏ,,,,,,,\n,所属,専任,,,,,\n,不可能,,,,,,\nダミー教員１,,,,,,,\n,所属,ダミー,,,,,\n,可能,月,7,水,7,金,7\nダミー教員２,,,,,,,\n,所属,ダミー,,,,,\n,可能,月,7,水,7,金,7\nダミー教員３,,,,,,,\n,所属,ダミー,,,,,\n,可能,月,7,水,7,金,7\nダミー教員HR１,,,,,,,\n,所属,ダミー,,,,,\n,可能,金,5,,,,\nダミー教員HR２,,,,,,,\n,所属,ダミー,,,,,\n,可能,金,5,,,,\nダミー教員HR３,,,,,,,\n,所属,ダミー,,,,,\n,可能,金,5,火,7,,\n";

	String lecture_csv0 = "スポーツ１,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,夏目三郎,近藤花子,,\n,学科,機械工学科,,,\n,講義室,グランド,体育館,,\n,代替,,,,\n,同時,,,,\nスポーツ１,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,夏目三郎,近藤花子,,\n,学科,電気電子工学科,,,\n,講義室,グランド,体育館,,\n,代替,,,,\n,同時,,,,\nスポーツ１,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,夏目三郎,近藤幸子,,\n,学科,物質生命科学科,,,\n,講義室,グランド,体育館,,\n,代替,,,,\n,同時,,,,\nスポーツ１,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,夏目三郎,沖田次郎,,\n,学科,コンピュータシステム学科,,,\n,講義室,グランド,体育館,,\n,代替,,,,\n,同時,,,,\nスポーツ１,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,夏目三郎,沖田次郎,,\n,学科,人間情報デザイン学科,,,\n,講義室,グランド,体育館,,,,,\n,代替,,,,,,,\n,同時,,,,,,,\nスポーツ１(女子),,,,,,,,\n,開講時期等,1,前期,必修,1,,,\n,担当教員,夏目三郎,,,,,,\n,学科,機械工学科,電気電子工学科,物質生命科学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,グランド,体育館,,,,,\n,代替,,,,,,,\n,同時,,,,,,,\n創造工学入門,,,,,,,,\n,開講時期等,1,前期,必修,1,,,\n,担当教員,佐藤三郎,山田三郎,鈴木六郎,鈴木三郎,佐藤一郎,山田五郎,鈴木次郎\n,学科,機械工学科,,,,,,\n,講義室,201実験室,創作ショップ,中講義室,,,,\n,代替,情報演習室２,ＬＬ教室,,,,,\n,同時,,,,,,\n創造工学入門,,,,,,,\n,開講時期等,1,前期,必修,1,,\n,担当教員,山田四郎,鈴木一郎,佐藤二朗,鈴木五郎,鈴木史朗,佐藤四郎\n,学科,機械工学科,,,,,\n,講義室,201実験室,創作ショップ,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,,,\n,同時,,,,,,\nフレッシュマンセミナー,,,,,,,\n,開講時期等,1,前期,必修,1,,\n,担当教員,佐藤五郎,,,,,\n,学科,電気電子工学科,,,,,\n,講義室,小講義室,,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室,\n,同時,フレッシュマン(電子),0,0,,,\nフレッシュマンセミナー,,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,山田花子,,,,\n,学科,電気電子工学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(電子),1,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,鈴木花子,,,,\n,学科,電気電子工学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(電子),2,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,佐藤花子,,,,\n,学科,電気電子工学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(電子),3,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,川村一郎,,,,\n,学科,電気電子工学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(電子),4,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,川村次郎,,,,\n,学科,電気電子工学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(電子),5,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,川村三郎,,,,\n,学科,電気電子工学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(電子),6,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,川村四郎,,,,\n,学科,電気電子工学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(電子),7,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,川村五郎,,,,\n,学科,電気電子工学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(電子),8,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,林一郎,,,,\n,学科,電気電子工学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(電子),9,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,林次郎,,,,\n,学科,電気電子工学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(電子),10,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,林三郎,,,,\n,学科,電気電子工学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(電子),11,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,高柳三郎,,,,\n,学科,物質生命科学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(物質),0,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,高柳四郎,,,,\n,学科,物質生命科学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(物質),1,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,高柳五郎,,,,\n,学科,物質生命科学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(物質),2,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,高柳花子,,,,\n,学科,物質生命科学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(物質),3,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,高柳幸子,,,,\n,学科,物質生命科学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(物質),4,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,横山一郎,,,,\n,学科,物質生命科学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(物質),5,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,横山次郎,,,,\n,学科,物質生命科学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(物質),6,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,横山三郎,,,,\n,学科,物質生命科学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(物質),7,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,横山四郎,,,,\n,学科,物質生命科学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(物質),8,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,横山五郎,,,,\n,学科,物質生命科学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(物質),9,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,横山花子,,,,\n,学科,物質生命科学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(物質),10,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,横山幸子,,,,\n,学科,物質生命科学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(物質),11,0,,\nフレッシュマンセミナー,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,土方一郎,,,,\n,学科,物質生命科学科,,,,\n,講義室,小講義室,,,,\n,代替,セミナー室,中講義室,情報演習室２,情報演習室１,ＬＬ教室\n,同時,フレッシュマン(物質),12,0,,\nフレッシュマンセミナー，コンピュータ基礎,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,田中四郎,菅沼四郎,夏目五郎,夏目一郎,\n,学科,コンピュータシステム学科,人間情報デザイン学科,,,\n,講義室,情報演習室２,,,,\n,代替,情報演習室１,ＬＬ教室,,,\n,同時,フレッシュマン1(情報),0,0,,\nフレッシュマンセミナー，コンピュータ基礎,,,,,,\n,開講時期等,1,前期,必修,1,\n,担当教員,菅沼五郎,夏目幸子,菅沼花子,林五郎\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,情報演習室２,,,\n,代替,情報演習室１,ＬＬ教室,,\n,同時,フレッシュマン1(情報),1,0,\nフレッシュマンセミナー，コンピュータ基礎,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,林四郎,田中幸子,菅沼一郎,\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,情報演習室２,,,\n,代替,情報演習室１,ＬＬ教室,,\n,同時,フレッシュマン2(情報),0,0,\nフレッシュマンセミナー，コンピュータ基礎,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,菅沼次郎,夏目四郎,高柳一郎,\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,情報演習室２,,,\n,代替,情報演習室１,ＬＬ教室,,\n,同時,フレッシュマン2(情報),1,0,\nフレッシュマンセミナー，コンピュータ基礎,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,夏目花子,田中五郎,菅沼三郎,\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,情報演習室２,,,\n,代替,情報演習室１,ＬＬ教室,,\n,同時,フレッシュマン2(情報),2,0,\nフレッシュマンセミナー，コンピュータ基礎,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,田中花子,田中次郎,夏目次郎,田中一郎\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,情報演習室２,,,\n,代替,情報演習室１,ＬＬ教室,,\n,同時,フレッシュマン3(情報),0,0,\nフレッシュマンセミナー，コンピュータ基礎,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,菅沼幸子,夏目三郎,田中三郎,\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,情報演習室２,,,\n,代替,情報演習室１,ＬＬ教室,,\n,同時,フレッシュマン3(情報),1,0,\n文章表現法,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,鈴木三郎,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,情報演習室１,,\n,同時,,,,\n文章表現法,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,山田花子,,,\n,学科,電気電子情報工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,情報演習室１,\n,同時,,,,\n文章表現法,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,高柳四郎,,,\n,学科,物質生命科学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,情報演習室１,\n,同時,,,,\n文章表現法,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,菅沼三郎,,,\n,学科,情報システム学科,,,\n,講義室,情報演習室２,,,\n,代替,ＬＬ教室,情報演習室１,,\n,同時,文章表現法(情報),0,0,\n文章表現法,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,夏目幸子,,,\n,学科,情報システム学科,,,\n,講義室,情報演習室２,,,\n,代替,ＬＬ教室,情報演習室１,,\n,同時,文章表現法(情報),1,0,\n文章表現法,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,高柳一郎,,,\n,学科,情報システム学科,,,\n,講義室,情報演習室２,,,\n,代替,ＬＬ教室,情報演習室１,,\n,同時,文章表現法(情報),2,0,\n英語１Ｅ,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,石田三郎,,,\n,学科,機械工学科,,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,機械工学科(英語1),0,0,\n英語１Ａ,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,沖田四郎,,,\n,学科,機械工学科,,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,機械工学科(英語1),1,0,\n英語１Ｅ,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,石田三郎,,,\n,学科,電気電子工学科,,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,電気電子工学科(英語1),0,0,\n英語１Ａ,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,沖田四郎,,,\n,学科,電気電子工学科,,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,電気電子工学科(英語1),1,0,\n英語１Ｅ,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,高柳次郎,,,\n,学科,物質生命科学科,,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,物質生命科学科(英語1),0,0,\n英語１Ａ,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,土方五郎,,,\n,学科,物質生命科学科,,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,物質生命科学科(英語1),1,0,\n英語１Ｅ,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,夏目五郎,,,\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,総合情報学部(英語1),0,0,\n英語１Ｇ,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,夏目四郎,,,\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,総合情報学部(英語1),1,0,\n英語１Ａ,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,高柳次郎,,,\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,総合情報学部(英語1),2,0,\n英語１Ｃ,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,土方五郎,,,\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,総合情報学部(英語1),3,0,\n英語３,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,石田次郎,,,\n,学科,機械工学科,,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,機械工学科(英語3),0,0,\n英語３,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,高柳次郎,,,\n,学科,機械工学科,,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,機械工学科(英語3),1,0,\n英語３,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,沖田三郎,,,\n,学科,電気電子情報工学科,,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,電気電子工学科(英語3),0,0,\n英語３,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,土方五郎,,,\n,学科,電気電子情報工学科,,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,電気電子工学科(英語3),1,0,\n英語３,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,沖田三郎,,,\n,学科,物質生命科学科,,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,物質生命科学科(英語3),0,0,\n英語３,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,石田次郎,,,\n,学科,物質生命科学科,,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,物質生命科学科(英語3),1,0,\n英語３,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,石田次郎,,,\n,学科,情報システム学科,,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,総合情報学部(英語3),0,0,\n英語３,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,夏目四郎,,,\n,学科,情報システム学科,,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,総合情報学部(英語3),1,0,\n英語３,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,高柳次郎,,,\n,学科,情報システム学科,,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,総合情報学部(英語3),2,0,\n英語３,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,土方五郎,,,\n,学科,情報システム学科,,,\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,小講義室,中講義室,\n,同時,総合情報学部(英語3),3,0,\n文芸の世界,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,近藤四郎,,,\n,学科,機械工学科,電気電子工学科,,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,中国語１1,2,0,\n文芸の世界,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,近藤四郎,,,\n,学科,物質生命科学科,コンピュータシステム学科,人間情報デザイン学科,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,中国語１2,2,0,\n社会学,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,田中花子,,,\n,学科,機械工学科,電気電子工学科,,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,,,,\n社会学,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,田中花子,,,\n,学科,物質生命科学科,コンピュータシステム学科,人間情報デザイン学科,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,社会学,0,0,\n国際関係論,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,近藤三郎,,,\n,学科,機械工学科,電気電子工学科,,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,ドイツ語１１,2,0,\n国際関係論,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,近藤三郎,,,\n,学科,物質生命科学科,コンピュータシステム学科,人間情報デザイン学科,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,ドイツ語１2,2,0,\n科学技術概論,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,高柳幸子,,,\n,学科,機械工学科,電気電子工学科,,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,,,,\n科学技術概論,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,高柳幸子,,,\n,学科,物質生命科学科,コンピュータシステム学科,人間情報デザイン学科,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,科学技術概論,0,0,\n心理学,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,夏目幸子,,,\n,学科,機械工学科,電気電子情報工学科,,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,,,,\n心理学,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,菅沼五郎,,,\n,学科,物質生命科学科,情報システム学科,,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,心理学,0,0,\n日本の歴史,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,菅沼次郎,,,\n,学科,機械工学科,電気電子情報工学科,,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,,,,\n日本の歴史,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,菅沼次郎,,,\n,学科,物質生命科学科,情報システム学科,,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,日本の歴史,0,0,\n経済学,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,近藤一郎,,,\n,学科,機械工学科,電気電子情報工学科,,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,経済学1,0,0,\n経済学,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,近藤一郎,,,\n,学科,物質生命科学科,情報システム学科,,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,経済学2,0,0,\n科学技術者の倫理,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,山田五郎,,,\n,学科,機械工学科,電気電子情報工学科,,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,,,,\n科学技術者の倫理,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,石田幸子,,,\n,学科,物質生命科学科,情報システム学科,,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,,,,\n法と市民生活,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,石田一郎,,,,\n,学科,機械工学科,電気電子情報工学科,,,\n,講義室,大講義室１,,,,\n,代替,大講義室２,,,,\n,同時,,,,,\n法と市民生活,,,,,,\n,開講時期等,3,前期,選択,1,\n,担当教員,石田一郎,,,,\n,学科,物質生命科学科,情報システム学科,,,\n,講義室,大講義室１,,,,\n,代替,大講義室２,,,,\n,同時,,,,,\n英語ワークショップ１(Reading),,,,,,\n,開講時期等,1,前期,選択,1,\n,担当教員,夏目四郎,,,,\n,学科,機械工学科,電気電子工学科,物質生命科学科,コンピュータシステム学科,人間情報デザイン学科\n,講義室,ＬＬ教室,,,,\n,代替,情報演習室２,中講義室,,,\n,同時,英語ワークショップ１(Reading),0,0,,\n英語ワークショップ１(Communication),,,,,,\n,開講時期等,1,前期,選択,1,\n,担当教員,高柳次郎,,,,\n,学科,機械工学科,電気電子工学科,物質生命科学科,コンピュータシステム学科,人間情報デザイン学科\n,講義室,ＬＬ教室,,,,\n,代替,情報演習室２,中講義室,,,\n,同時,英語ワークショップ１(Reading),1,0,,\n英語ワークショップ3(Reading),,,,,,\n,開講時期等,2,前期,選択,1,\n,担当教員,夏目五郎,,,,\n,学科,機械工学科,電気電子情報工学科,物質生命科学科,情報システム学科,\n,講義室,ＬＬ教室,,,,\n,代替,情報演習室２,中講義室,,,\n,同時,英語ワーク3,0,0,\n英語ワークショップ3(Communication),,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,高柳次郎,,,\n,学科,機械工学科,電気電子情報工学科,物質生命科学科,情報システム学科\n,講義室,ＬＬ教室,,,\n,代替,情報演習室２,中講義室,,\n,同時,英語ワーク3,1,0,\nCurrent English,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,夏目五郎,,,\n,学科,機械工学科,電気電子情報工学科,物質生命科学科,情報システム学科\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,Current English,0,0,\nドイツ語１,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,沖田一郎,,,\n,学科,機械工学科,電気電子工学科,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,ドイツ語１１,0,0,\nドイツ語１,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,沖田一郎,,,\n,学科,物質生命科学科,コンピュータシステム学科,人間情報デザイン学科,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,ドイツ語１2,0,0,\nフランス語１,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,沖田五郎,,,\n,学科,機械工学科,電気電子工学科,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,ドイツ語１１,1,0,\nフランス語１,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,沖田五郎,,,\n,学科,物質生命科学科,コンピュータシステム学科,人間情報デザイン学科,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,ドイツ語１2,1,0,\n中国語１,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,石田花子,,,\n,学科,機械工学科,電気電子工学科,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,中国語１1,0,0,\n中国語１,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,石田花子,,,\n,学科,物質生命科学科,コンピュータシステム学科,人間情報デザイン学科,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,中国語１2,0,0,\n韓国語１,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,石田五郎,,,\n,学科,機械工学科,電気電子工学科,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,中国語１1,1,0,\n韓国語１,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,石田五郎,,,\n,学科,物質生命科学科,コンピュータシステム学科,人間情報デザイン学科,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,中国語１2,1,0,\n健康の科学,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,夏目三郎,加藤五郎,加藤花子,\n,学科,機械工学科,電気電子情報工学科,物質生命科学科,情報システム学科\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,Current English,1,0,\n微分積分／演習,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,佐藤三郎,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,基礎数学(機械1),0,0,\n微分積分／演習,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,佐藤三郎,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,基礎数学(機械2),0,0,\n微分積分／演習,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,山田花子,,,\n,学科,電気電子工学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,基礎数学(電子1),0,0,\n微分積分／演習,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,山田花子,,,\n,学科,電気電子工学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,基礎数学(電子2),0,0,\n微分積分／演習,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,土方一郎,,,\n,学科,物質生命科学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,基礎数学(物質1),0,0,\n微分積分／演習,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,土方一郎,,,\n,学科,物質生命科学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,基礎数学(物質2),0,0,\n微分積分／演習,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,土方四郎,,,\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,基礎数学(情報1),0,0,\n微分積分／演習,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,土方四郎,,,\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,基礎数学(情報2),0,0,\n基礎数学,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,土方四郎,,,\n,学科,機械工学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,基礎数学(機械1),1,0,\n基礎数学,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,土方四郎,,,\n,学科,機械工学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,基礎数学(機械2),1,0,\n基礎数学,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,土方三郎,,,\n,学科,電気電子工学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,基礎数学(電子1),1,0,\n基礎数学,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,土方三郎,,,\n,学科,電気電子工学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,基礎数学(電子2),1,0,\n基礎数学,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,土方四郎,,,\n,学科,物質生命科学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,基礎数学(物質1),1,0,\n基礎数学,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,土方四郎,,,\n,学科,物質生命科学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,基礎数学(物質2),1,0,\n基礎数学,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,土方三郎,,,\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,基礎数学(情報1),1,0,\n基礎数学,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,土方三郎,,,\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,,,,\n基礎数学,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,土方三郎,,,\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,基礎数学(情報2),1,0,\n基礎数学,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,土方三郎,,,\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,,,,\nコンピュータ入門,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,鈴木五郎,,,\n,学科,機械工学科,,,\n,講義室,情報演習室２,,,\n,代替,情報演習室１,,,\n,同時,,,,\nコンピュータ入門,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,林次郎,,,\n,学科,電気電子工学科,,,\n,講義室,情報演習室２,,,\n,代替,情報演習室１,ＬＬ教室,,\n,同時,,,,\nコンピュータ入門,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,横山次郎,,,\n,学科,物質生命科学科,,,\n,講義室,情報演習室２,,,\n,代替,情報演習室１,ＬＬ教室,,\n,同時,,,,\n情報数学基礎,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,田中五郎,,,\n,学科,機械工学科,電気電子工学科,コンピュータシステム学科,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,情報数学,0,0,\n情報数学基礎,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,夏目一郎,,,\n,学科,機械工学科,電気電子工学科,コンピュータシステム学科,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,情報数学,1,0,\n情報数学基礎,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,林五郎,,,\n,学科,物質生命科学科,人間情報デザイン学科,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,情報数学,2,0,\n情報数学基礎,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,林四郎,,,\n,学科,物質生命科学科,人間情報デザイン学科,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,情報数学,3,0,\nインターネットと情報倫理,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,菅沼四郎,,,\n,学科,機械工学科,電気電子工学科,,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,,,,\nインターネットと情報倫理,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,菅沼四郎,,,\n,学科,物質生命科学科,コンピュータシステム学科,人間情報デザイン学科,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,,,,\n基礎物理学,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,高柳三郎,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,,,,\n物理学入門,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,川村四郎,,,\n,学科,電気電子工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\n物理学入門,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,高柳花子,,,\n,学科,物質生命科学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\n物理学入門,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,高柳幸子,,,\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,大講義室２,,,\n,代替,大講義室１,,,\n,同時,社会学,1,0,\n化学入門,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,高柳五郎,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,,,,\n化学入門,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,横山次郎,,,\n,学科,電気電子工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\n化学入門,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,高柳五郎,,,\n,学科,物質生命科学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\n化学入門,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,横山次郎,,,\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,大講義室２,,,\n,代替,大講義室１,,,\n,同時,科学技術概論,1,0,\n生物学入門,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,夏目幸子,菅沼三郎,田中幸子,\n,学科,機械工学科,電気電子工学科,,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,,,,\n生物学入門,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,夏目幸子,菅沼三郎,田中幸子,\n,学科,物質生命科学科,コンピュータシステム学科,人間情報デザイン学科,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,,,,\n線形代数,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,加藤三郎,,,\n,学科,機械工学科,電気電子情報工学科,物質生命科学科,\n,講義室,大講義室２,,,\n,代替,大講義室１,,,\n,同時,,,,\nベクトル解析,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,山田太郎,,,\n,学科,機械工学科,電気電子情報工学科,,\n,講義室,大講義室２,,,\n,代替,大講義室１,,,\n,同時,,,,\nベクトル解析,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,山田太郎,,,\n,学科,物質生命科学科,情報システム学科,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,心理学,1,0,\n微分方程式,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,山田三郎,,,\n,学科,機械工学科,電気電子情報工学科,,\n,講義室,大講義室２,,,\n,代替,大講義室１,,,\n,同時,,,,\n微分方程式,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,横山五郎,,,\n,学科,物質生命科学科,情報システム学科,,\n,講義室,大講義室２,,,\n,代替,大講義室１,,,\n,同時,日本の歴史,1,0,\nC言語,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,加藤幸子,,,\n,学科,機械工学科,,,\n,講義室,情報演習室２,,,\n,代替,ＬＬ教室,情報演習室１,,\n,同時,,,,\nC言語,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,林四郎,,,\n,学科,電気電子情報工学科,,,\n,講義室,情報演習室２,,,\n,代替,ＬＬ教室,情報演習室１,,\n,同時,,,,\nC言語,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,近藤次郎,,,\n,学科,物質生命科学科,,,\n,講義室,情報演習室２,,,\n,代替,ＬＬ教室,情報演習室１,,\n,同時,,,,\nFortran言語,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,山田次郎,,,\n,学科,機械工学科,電気電子情報工学科,物質生命科学科,情報システム学科\n,講義室,情報演習室２,,,\n,代替,情報演習室１,,,\n,同時,英語ワーク3,2,0,\n熱物理学,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,山田次郎,,,\n,学科,機械工学科,電気電子情報工学科,,\n,講義室,大講義室２,,,\n,代替,大講義室１,,,\n,同時,,,,\n熱物理学,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,山田次郎,,,\n,学科,物質生命科学科,情報システム学科,,\n,講義室,大講義室２,,,\n,代替,大講義室１,,,\n,同時,学習と記憶,2,0,\n基礎電磁気学,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,加藤三郎,,,\n,学科,機械工学科,情報システム学科,,\n,講義室,大講義室２,,,\n,代替,大講義室１,,,\n,同時,オペレーションズ・リサーチ1,1,0,\n地球科学,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,加藤四郎,,,\n,学科,機械工学科,電気電子情報工学科,,\n,講義室,中講義室,,,\n,代替,,,,\n,同時,経済学1,1,0,\n地球科学,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,加藤四郎,,,\n,学科,物質生命科学科,情報システム学科,,\n,講義室,中講義室,,,,\n,代替,,,,,\n,同時,経済学2,1,0,,\n機械工学通論,,,,,,\n,開講時期等,2,前期,選択,1,\n,担当教員,山田四郎,,,,\n,学科,電気電子情報工学科,物質生命科学科,情報システム学科,,\n,講義室,大講義室１,,,,\n,代替,大講義室２,,,,\n,同時,オペレーションズ・リサーチ2,1,0,,\nメカトロニクス基礎実験,,,,,,\n,開講時期等,2,前期,必修,2,4\n,担当教員,山田三郎,佐藤四郎,,,\n,学科,機械工学科,,,,\n,講義室,202実験室,,,,\n,代替,,,,,\n,同時,,,,,\nメカトロニクス基礎実験,,,,,,\n,開講時期等,2,前期,必修,2,4\n,担当教員,山田花子,鈴木五郎,,,\n,学科,電気電子情報工学科,,,,\n,講義室,202実験室,,,,\n,代替,,,,,\n,同時,,,,,\n環境・生物実験,,,,,,\n,開講時期等,2,前期,必修,2,4\n,担当教員,高柳三郎,横山三郎,横山四郎,,\n,学科,物質生命科学科,情報システム学科,,,\n,講義室,202実験室,301実験室,302実験室,,\n,代替,,,,,\n,同時,環境・生物実験,0,0,,\nエネルギー論,,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,鈴木三郎,加藤一郎,加藤次郎,\n,学科,機械工学科,電気電子情報工学科,,\n,講義室,大講義室２,,,\n,代替,大講義室１,,,\n,同時,,,,\nエネルギー論,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,鈴木三郎,加藤一郎,加藤次郎,\n,学科,物質生命科学科,情報システム学科,,\n,講義室,大講義室２,,,\n,代替,大講義室１,,,\n,同時,脳と情報,1,0,\nデータ解析,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,鈴木次郎,,,\n,学科,機械工学科,電気電子情報工学科,物質生命科学科,情報システム学科\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,運動と行動,1,0,\n現代物理学,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,山田太郎,,,\n,学科,機械工学科,電気電子情報工学科,物質生命科学科,情報システム学科\n,講義室,大講義室２,,,\n,代替,大講義室１,,,\n,同時,,,,\n機械創作入門,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,山田三郎,佐藤四郎,,\n,学科,機械工学科,,,\n,講義室,201実験室,中講義室,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,機械創作入門１,0,0,\n機械創作入門,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,山田四郎,佐藤四郎,,\n,学科,機械工学科,,,\n,講義室,201実験室,中講義室,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,機械創作入門2,0,0,\n工業力学１,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,鈴木五郎,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,機械創作入門１,1,0,\n工業力学１,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,山田三郎,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,機械創作入門2,1,0,\n材料力学１,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,佐藤一郎,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,,,,\nメカトロニクス１,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,佐藤二朗,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,,,,\n機械材料学,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,山田五郎,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,,,,\n機械加工学,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,山田四郎,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,,,,\n機械製図,,,,,\n,開講時期等,2,前期,必修,2\n,担当教員,鈴木六郎,鈴木五郎,,\n,学科,機械工学科,,,\n,講義室,206製図室,,,\n,代替,,,,\n,同時,,,,\n機構学,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,鈴木六郎,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,,,,,\n計測・信号処理,,,,,,\n,開講時期等,3,前期,必修,1,\n,担当教員,佐藤三郎,,,,\n,学科,機械工学科,,,,\n,講義室,中講義室,,,,\n,代替,情報演習室２,,,,\n,同時,,,,,\n機械工学実験１,,,,,,\n,開講時期等,3,前期,必修,2,4\n,担当教員,鈴木一郎,鈴木三郎,鈴木次郎,鈴木六郎,佐藤四郎\n,学科,機械工学科,,,,\n,講義室,201実験室,,,,\n,代替,,,,,\n,同時,,,,,\n制御基礎Ｇ,,,,,,\n,開講時期等,3,前期,必修,1\n,担当教員,佐藤二朗,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,制御基礎Ｇ,0,0,\n生産システム設計製図２,,,,,\n,開講時期等,3,前期,必修,2\n,担当教員,鈴木史朗,,,\n,学科,機械工学科,,,\n,講義室,501第1ＷＳ室,中講義室,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\nメカトロニクス設計製図２,,,,,\n,開講時期等,3,前期,必修,2\n,担当教員,鈴木次郎,,,\n,学科,機械工学科,,,\n,講義室,501第1ＷＳ室,中講義室,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\n制御基礎Ｓ,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,佐藤二朗,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,制御基礎Ｓ,0,0,\n流体工学2Ｓ,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,鈴木六郎,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,制御基礎Ｇ,1,0,\n流体工学2Ｇ,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,鈴木六郎,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,制御基礎Ｓ,1,0,\n応用数値解析,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,山田三郎,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,,,,\nエネルギー工学,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,鈴木一郎,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,,,,\n材料加工学,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,山田五郎,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,,,,\n機械工学特別講義,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,山田五郎,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,,,,\nトライボロジー,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,山田四郎,,,\n,学科,機械工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,,,,\n電気電子工学入門,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,佐藤花子,,,\n,学科,電気電子工学科,,,\n,講義室,401実験室,,,\n,代替,,,,\n,同時,,,,\n電気回路学１,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,川村次郎,,,\n,学科,電気電子工学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,電気回路学１,0,0,\n電気回路学１,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,佐藤五郎,,,\n,学科,電気電子工学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,電気回路学１,1,0,\n電気回路学演習,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,川村次郎,,,\n,学科,電気電子工学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,電気回路学演習,0,0,\n電気回路学演習,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,佐藤五郎,,,\n,学科,電気電子工学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,電気回路学演習,1,0,\n電磁気学１,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,林次郎,,,\n,学科,電気電子情報工学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,電磁気学１,0,0,\n電磁気学１,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,川村四郎,,,\n,学科,電気電子情報工学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,電磁気学１,1,0,\n電子回路学１,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,川村五郎,,,\n,学科,電気電子情報工学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,電子回路学１,0,0,\n電子回路学１,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,林一郎,,,\n,学科,電気電子情報工学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,電子回路学１,1,0,\n電子回路学演習,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,川村五郎,,,\n,学科,電気電子情報工学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,電子回路学演習,0,0,\n電子回路学演習,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,林一郎,,,\n,学科,電気電子情報工学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,電子回路学演習,1,0,\n電子計測,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,川村三郎,,,\n,学科,電気電子情報工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\n電気回路学３,,,,,,\n,開講時期等,2,前期,選択,1,\n,担当教員,川村一郎,,,,\n,学科,電気電子情報工学科,,,,\n,講義室,中講義室,,,,\n,代替,情報演習室２,ＬＬ教室,,,\n,同時,,,,,\n半導体デバイス,,,,,,\n,開講時期等,2,前期,選択,1,\n,担当教員,川村一郎,,,,\n,学科,電気電子情報工学科,,,,\n,講義室,中講義室,,,,\n,代替,情報演習室２,ＬＬ教室,,,\n,同時,,,,,\n電子工学実験,,,,,,\n,開講時期等,3,前期,必修,3,3\n,担当教員,川村次郎,林次郎,鈴木花子,,\n,学科,電気電子情報工学科,,,,\n,講義室,401実験室,508第2ＷＳ室,,,\n,代替,,,,,\n,同時,,,,,\n電子工学実験,,,,,,\n,開講時期等,3,前期,必修,3,3\n,担当教員,川村一郎,鈴木花子,林三郎,,\n,学科,電気電子情報工学科,,,,\n,講義室,401実験室,508第2ＷＳ室,,,\n,代替,,,,,\n,同時,,,,,\nパルス回路,,,,,,\n,開講時期等,3,前期,選択,1,\n,担当教員,佐藤五郎,,,,\n,学科,電気電子情報工学科,,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\n集積回路工学,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,林次郎,,,\n,学科,電気電子情報工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\nセンサ工学,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,山田花子,,,\n,学科,電気電子情報工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\n光通信工学,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,林一郎,,,\n,学科,電気電子情報工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\n画像工学,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,川村五郎,,,\n,学科,電気電子情報工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\n電子制御工学,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,佐藤花子,,,\n,学科,電気電子情報工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\n電気機器,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,佐藤五郎,,,\n,学科,電気電子情報工学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\n高電圧工学,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,電子非常勤Ａ,,,\n,学科,電気電子情報工学科,,,,,,,,,,,,,,\n,講義室,中講義室,,,,,,,,,,,,,,\n,代替,情報演習室２,ＬＬ教室,,,,,,,,,,,,,\n,同時,,,,,,,,,,,,,,,\n物質生命科学概論,,,,,,,,,,,,,,,,\n,開講時期等,1,前期,必修,1,,,,,,,,,,,\n,担当教員,高柳三郎,高柳四郎,高柳五郎,高柳花子,高柳幸子,横山一郎,横山次郎,横山三郎,横山四郎,横山五郎,横山花子,横山幸子,土方一郎,物質新任Ａ,物質新任Ｂ\n,学科,物質生命科学科,,,,,,,,,,,,,,\n,講義室,中講義室,,,,,,,,,,,,,,\n,代替,情報演習室２,ＬＬ教室,,,,,,,,,,,,,\n,同時,,,,,,,,,,,,,,,\n基礎有機化学,,,,,,,,,,,,,,,,\n,開講時期等,1,前期,必修,1,,,,,,,,,,,\n,担当教員,高柳四郎,,,,,,,,,,,,,,\n,学科,物質生命科学科,,,,,,,,,,,,,,\n,講義室,中講義室,,,,,,,,,,,,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\n物質生命科学演習１,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,横山一郎,,,\n,学科,物質生命科学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,物質生命科学演習１,0,0,\n物質生命科学演習１,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,高柳花子,,,\n,学科,物質生命科学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,物質生命科学演習１,1,0,\n分析化学１,,,,,\n,開講時期等,1,前期,必修,1\n,担当教員,横山一郎,,,\n,学科,物質生命科学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\n分析化学,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,横山一郎,,,\n,学科,物質生命科学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,,,,\n物質生命科学演習２,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,横山幸子,,,\n,学科,物質生命科学科,,,\n,講義室,情報演習室２,,,\n,代替,ＬＬ教室,,,\n,同時,物質生命科学演習２,0,0,\n物質生命科学演習２,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,土方一郎,,,\n,学科,物質生命科学科,,,\n,講義室,326多目的実験室,情報演習室２,,\n,代替,ＬＬ教室,,,\n,同時,物質生命科学演習２,1,0,\n基礎熱学,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,高柳五郎,,,\n,学科,物質生命科学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\n有機化学１,,,,,\n,開講時期等,2,前期,必修,1\n,担当教員,高柳四郎,,,\n,学科,物質生命科学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\n細胞生物学,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,横山四郎,,,\n,学科,物質生命科学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,,,,\n物質の電磁気学,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,横山五郎,,,\n,学科,物質生命科学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,,,,\n機器分析,,,,,\n,開講時期等,3,前期,必修,1\n,担当教員,横山幸子,,,\n,学科,物質生命科学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\n物質生命科学実験１,,,,,\n,開講時期等,3,前期,必修,3,3\n,担当教員,高柳四郎,横山一郎,高柳花子,横山幸子,\n,学科,物質生命科学科,,,,\n,講義室,301実験室,302実験室,326多目的実験室,,\n,代替,,,,,\n,同時,,,,,\n生化学１,,,,,,\n,開講時期等,3,前期,選択,1,\n,担当教員,高柳四郎,,,,\n,学科,物質生命科学科,,,,\n,講義室,小講義室,,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,,\n,同時,,,,,\n化学反応の基礎と応用,,,,,,\n,開講時期等,3,前期,選択,1,\n,担当教員,横山一郎,,,,\n,学科,物質生命科学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,,,,\n上級：専門英語１,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,高柳幸子,,,\n,学科,物質生命科学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,,,,\n上級：微生物と酵素,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,横山三郎,横山花子,,\n,学科,物質生命科学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,,,,\n応用微生物,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,横山三郎,,,\n,学科,物質生命科学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,,,,\nバイオテクノロジー,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,横山四郎,,,\n,学科,物質生命科学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,,,,\n材料とプロセス,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,高柳花子,,,\n,学科,物質生命科学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,,,,\n化学結合論,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,横山次郎,,,\n,学科,物質生命科学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,,,,\nナノマテリアル,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,土方一郎,,,\n,学科,物質生命科学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,,,,\n上級：ナノ材料科学,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,高柳五郎,高柳三郎,,\n,学科,物質生命科学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,,,,\n情報学概論,,,,,\n,開講時期等,1,前期,選択,1\n,担当教員,夏目次郎,,,\n,学科,コンピュータシステム学科,人間情報デザイン学科,,\n,講義室,大講義室２,,,\n,代替,大講義室１,,,\n,同時,,,,\nプログラミング及び演習１,,,,,\n,開講時期等,2,前期,選択,2\n,担当教員,夏目次郎,,,\n,学科,情報システム学科,,,\n,講義室,情報演習室２,,,\n,代替,ＬＬ教室,情報演習室１,,\n,同時,プログラミング及び演習１,0,0,\nプログラミング及び演習２,,,,,\n,開講時期等,2,前期,選択,2\n,担当教員,田中四郎,,,\n,学科,情報システム学科,,,\n,講義室,情報演習室２,,,\n,代替,ＬＬ教室,情報演習室１,,\n,同時,プログラミング及び演習１,1,0,\n計算機ハードウェア,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,田中次郎,,,\n,学科,情報システム学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,計算機ハードウェア1,0,0,\n計算機ハードウェア,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,田中次郎,,,\n,学科,情報システム学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,計算機ハードウェア2,0,0,\n統計解析,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,夏目一郎,,,\n,学科,情報システム学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,統計解析,0,0,\n統計解析,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,林五郎,,,\n,学科,情報システム学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,統計解析,1,0,\nオペレーションズ・リサーチ,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,夏目花子,,,\n,学科,情報システム学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,オペレーションズ・リサーチ1,0,0,\nオペレーションズ・リサーチ,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,夏目花子,,,\n,学科,情報システム学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,オペレーションズ・リサーチ2,0,0,\n応用線形代数,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,菅沼幸子,,,\n,学科,情報システム学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,環境・生物実験,1,0,\n応用線形代数,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,田中一郎,,,\n,学科,情報システム学科,,,\n,講義室,小講義室,,,\n,代替,中講義室,情報演習室２,ＬＬ教室,\n,同時,環境・生物実験,2,0,\nＵＮＩＸ,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,菅沼花子,,,\n,学科,情報システム学科,,,\n,講義室,情報演習室２,,,\n,代替,ＬＬ教室,情報演習室１,,\n,同時,ＵＮＩＸ,0,0,\nＵＮＩＸ,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,林五郎,,,\n,学科,情報システム学科,,,\n,講義室,情報演習室２,,,\n,代替,ＬＬ教室,情報演習室１,,\n,同時,ＵＮＩＸ,1,0,\n比較文化論,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,高柳次郎,,,\n,学科,情報システム学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,計算機ハードウェア1,1,0,\n国際コミュニケーション論,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,夏目五郎,,,\n,学科,情報システム学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,計算機ハードウェア2,1,0,\nマルチメディア論,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,菅沼一郎,,,\n,学科,情報システム学科,,,\n,講義室,501第1ＷＳ室,504第1情報演習室,,\n,代替,,,,\n,同時,環境・生物実験,1,1,\nＣＧ初級,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,石田四郎,,,\n,学科,情報システム学科,,,\n,講義室,情報演習室２,,,\n,代替,情報演習室１,,,\n,同時,オペレーションズ・リサーチ1,2,0,\nＣＧ初級,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,石田四郎,,,\n,学科,情報システム学科,,,\n,講義室,情報演習室２,,,\n,代替,情報演習室１,,,\n,同時,オペレーションズ・リサーチ2,2,0,\n感覚知覚,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,夏目幸子,,,\n,学科,情報システム学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,ＵＮＩＸ,2,0,\n学習と記憶,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,菅沼五郎,,,\n,学科,情報システム学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,学習と記憶,0,0,\n経営工学概論,,,,,\n,開講時期等,2,前期,選択,1\n,担当教員,高柳一郎,,,\n,学科,情報システム学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,,,\n,同時,学習と記憶,1,0,\nコンピュータシステム実験,,,,,\n,開講時期等,3,前期,選択,3,3,,\n,担当教員,菅沼幸子,田中五郎,田中次郎,田中一郎,田中四郎,林四郎,\n,学科,情報システム学科,,,,,,\n,講義室,501第1ＷＳ室,,,,,,\n,代替,,,,,,,\n,同時,コンピュータシステム実験,0,0,,,,\n生命・心理情報実験,,,,,,,,\n,開講時期等,3,前期,選択,3,3,,\n,担当教員,菅沼三郎,田中幸子,林五郎,夏目花子,田中三郎,菅沼五郎,夏目幸子\n,学科,情報システム学科,,,,,,\n,講義室,情報演習室２,,,,,,\n,代替,,,,,,,\n,同時,コンピュータシステム実験,1,0,,,,\n社会ネットワーク実験,,,,,,,,\n,開講時期等,3,前期,選択,3,3,,\n,担当教員,高柳一郎,菅沼一郎,菅沼花子,田中花子,夏目一郎,菅沼次郎,夏目次郎\n,学科,情報システム学科,,,\n,講義室,504第1情報演習室,509第3ＷＳ室,,\n,代替,,,,\n,同時,コンピュータシステム実験,2,0,\nＷｅｂデザイン,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,夏目次郎,,,\n,学科,情報システム学科,,,\n,講義室,情報演習室２,,,\n,代替,ＬＬ教室,情報演習室１,,\n,同時,,,,\nオブジェクト指向プログラミング,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,菅沼花子,,,\n,学科,情報システム学科,,,\n,講義室,情報演習室２,,,\n,代替,情報演習室１,,,\n,同時,,,,\nコンパイラ,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,菅沼花子,,,\n,学科,情報システム学科,,,\n,講義室,情報演習室２,,,\n,代替,情報演習室１,,,\n,同時,,,,\n数値解析及び演習,,,,,\n,開講時期等,3,前期,選択,2\n,担当教員,菅沼幸子,,,\n,学科,情報システム学科,,,\n,講義室,情報演習室２,,,\n,代替,情報演習室１,,,\n,同時,,,,\n符号･暗号理論及び演習,,,,,\n,開講時期等,3,前期,選択,2\n,担当教員,田中一郎,,,\n,学科,情報システム学科,,,\n,講義室,中講義室,,,\n,代替,情報演習室２,ＬＬ教室,,\n,同時,,,,\n脳と情報,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,菅沼三郎,,,\n,学科,情報システム学科,物質生命科学科,,\n,講義室,大講義室１,,,\n,代替,大講義室２,,,\n,同時,脳と情報,0,0,\n運動と行動,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,夏目三郎,菅沼五郎,,\n,学科,情報システム学科,,,\n,講義室,大講義室２,,,\n,代替,大講義室１,,,\n,同時,運動と行動,0,0,\n経営情報システム,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,高柳一郎,,,\n,学科,情報システム学科,,,\n,講義室,大講義室２,,,\n,代替,大講義室１,,,\n,同時,,,,\n情報処理資格試験対策講座２,,,,,\n,開講時期等,3,前期,選択,1\n,担当教員,林四郎,,,\n,学科,情報システム学科,,,\n,講義室,情報演習室２\n,代替,情報演習室１\n,同時,\n";

	String lecture_csv11 = "古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,松崎,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,松崎,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,松崎,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,松崎,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,松崎,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,松崎,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐竹,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐竹,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐竹,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐竹,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐竹,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐竹,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,雪江,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,雪江,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,雪江,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,雪江,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,雪江,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,雪江,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,雪江,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,雪江,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,雪江,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鈴利,佐二,,\n,学科,１の１,１の３,,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鈴利,佐二,,\n,学科,１の１,１の３,,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鈴利,佐二,,\n,学科,１の１,１の３,,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鈴利,佐二,,\n,学科,１の５,１の７,,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鈴利,佐二,,\n,学科,１の５,１の７,,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鈴利,佐二,,\n,学科,１の５,１の７,,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鈴利,佐二,高橋,\n,学科,１の２,１の４,１の６,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鈴利,佐二,高橋,\n,学科,１の２,１の４,１の６,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鈴利,佐二,高橋,\n,学科,１の２,１の４,１の６,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n音楽,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,細倉,,,\n,学科,１の１,,,\n,講義室,101音楽教室,,,\n,代替,,,,\n,同時,,,,\n音楽,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,細倉,,,\n,学科,１の１,,,\n,講義室,101音楽教室,,,\n,代替,,,,\n,同時,,,,\n音楽,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,細倉,,,\n,学科,１の２,,,\n,講義室,101音楽教室,,,\n,代替,,,,\n,同時,,,,\n音楽,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,細倉,,,\n,学科,１の２,,,\n,講義室,101音楽教室,,,\n,代替,,,,\n,同時,,,,\n音楽,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,細倉,,,\n,学科,１の３,,,\n,講義室,101音楽教室,,,\n,代替,,,,\n,同時,,,,\n音楽,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,細倉,,,\n,学科,１の３,,,\n,講義室,101音楽教室,,,\n,代替,,,,\n,同時,,,,\n音楽,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,細倉,,,\n,学科,１の４,,,\n,講義室,101音楽教室,,,\n,代替,,,,\n,同時,,,,\n音楽,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,細倉,,,\n,学科,１の４,,,\n,講義室,101音楽教室,,,\n,代替,,,,\n,同時,,,,\n音楽,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,細倉,,,\n,学科,１の５,,,\n,講義室,101音楽教室,,,\n,代替,,,,\n,同時,,,,\n音楽,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,細倉,,,\n,学科,１の５,,,\n,講義室,101音楽教室,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐藤浩,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐藤浩,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐藤浩,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐藤浩,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐藤浩,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐藤浩,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,針生,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,針生,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,針生,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,小林,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,小林,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n数学Ａ  ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,小林,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,小林,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,小林,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,小林,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,中鉢,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,中鉢,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,中鉢,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,中鉢,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,中鉢,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n数学Ａ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,中鉢,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,横山,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,横山,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,横山,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,横山,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,横山,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,横山,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,横山,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,横山,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,庄司,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,庄司,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,庄司,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,庄司,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鶴岡,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鶴岡,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鶴岡,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鶴岡,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鶴岡,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鶴岡,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鶴岡,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鶴岡,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,庄司,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,庄司,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,庄司,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,庄司,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,庄司,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,庄司,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,庄司,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n英語Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,庄司,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n現代社会,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,岩館,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n現代社会,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,岩館,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n現代社会,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,岩館,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n現代社会,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,岩館,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n現代社会,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,岩館,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n現代社会,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,岩館,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n現代社会,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,岩館,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n現代社会,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,岩館,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n現代社会,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,三浦,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n現代社会,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,三浦,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n現代社会,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,三浦,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n現代社会,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,三浦,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n現代社会,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,三浦,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n現代社会,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,三浦,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n理科総合,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,中村,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n理科総合,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,中村,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n理科総合,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,中村,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n理科総合,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,中村,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n理科総合,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,清水,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n理科総合,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,清水,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n理科総合,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,清水,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n理科総合,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,清水,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n理科総合,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,清水,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n理科総合,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,清水,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n理科総合,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,中村,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n理科総合,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,中村,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n理科総合,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,中村,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n理科総合,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,中村,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n家庭基礎,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,本田,,,\n,学科,１の１,,,\n,講義室,101家庭科室,,,\n,代替,,,,\n,同時,,,,\n家庭基礎,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,本田,,,\n,学科,１の１,,,\n,講義室,101家庭科室,,,\n,代替,,,,\n,同時,,,,\n家庭基礎,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,本田,,,\n,学科,１の２,,,\n,講義室,101家庭科室,,,\n,代替,,,,\n,同時,,,,\n家庭基礎,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,本田,,,\n,学科,１の２,,,\n,講義室,101家庭科室,,,\n,代替,,,,\n,同時,,,,\n家庭基礎,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,川村,,,\n,学科,１の３,,,\n,講義室,101家庭科室,,,\n,代替,,,,\n,同時,,,,\n家庭基礎,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,川村,,,\n,学科,１の３,,,\n,講義室,101家庭科室,,,\n,代替,,,,\n,同時,,,,\n家庭基礎,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,川村,,,\n,学科,１の４,,,\n,講義室,101家庭科室,,,\n,代替,,,,\n,同時,,,,\n家庭基礎,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,川村,,,\n,学科,１の４,,,\n,講義室,101家庭科室,,,\n,代替,,,,\n,同時,,,,\n家庭基礎,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,川村,,,\n,学科,１の５,,,\n,講義室,101家庭科室,,,\n,代替,,,,\n,同時,,,,\n家庭基礎,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,川村,,,\n,学科,１の５,,,\n,講義室,101家庭科室,,,\n,代替,,,,\n,同時,,,,\n家庭基礎,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,川村,,,\n,学科,１の６,,,\n,講義室,101家庭科室,,,\n,代替,,,,\n,同時,,,,\n家庭基礎,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,川村,,,\n,学科,１の６,,,\n,講義室,101家庭科室,,,\n,代替,,,,\n,同時,,,,\n家庭基礎,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,川村,,,\n,学科,１の７,,,\n,講義室,101家庭科室,,,\n,代替,,,,\n,同時,,,,\n家庭基礎,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,川村,,,\n,学科,１の７,,,\n,講義室,101家庭科室,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,小林,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,小林,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,小林,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,小林,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,小林,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,小林,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,小林,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,小林,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,小林,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐藤浩,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐藤浩,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐藤浩,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐藤浩,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐藤浩,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐藤浩,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,針生,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,針生,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,針生,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐藤浩,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐藤浩,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n数学Ⅰ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐藤浩,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n情報Ａ,,,,,\n,開講時期等,1,１学期,必修,2\n,担当教員,針生,,,\n,学科,１の１,,,\n,講義室,101情報教室,,,\n,代替,,,,\n,同時,情報Ａ１,0,0,\n情報Ｂ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,上杉,,,\n,学科,１の１,,,\n,講義室,ダミー教室１,,,\n,代替,,,,\n,同時,情報Ａ１,1,0,\n情報Ａ,,,,,\n,開講時期等,1,１学期,必修,2\n,担当教員,針生,,,\n,学科,１の２,,,\n,講義室,101情報教室,,,\n,代替,,,,\n,同時,情報Ａ２,0,0,\n情報Ｂ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,上杉,,,\n,学科,１の２,,,\n,講義室,ダミー教室１,,,\n,代替,,,,\n,同時,情報Ａ２,1,0,\n情報Ａ,,,,,\n,開講時期等,1,１学期,必修,2\n,担当教員,岩淵,,,\n,学科,１の３,,,\n,講義室,101情報教室,,,\n,代替,,,,\n,同時,情報Ａ３,0,0,\n情報Ｂ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,上杉,,,\n,学科,１の３,,,\n,講義室,ダミー教室１,,,\n,代替,,,,\n,同時,情報Ａ３,1,0,\n情報Ａ,,,,,\n,開講時期等,1,１学期,必修,2\n,担当教員,針生,,,\n,学科,１の４,,,\n,講義室,101情報教室,,,\n,代替,,,,\n,同時,情報Ａ４,0,0,\n情報Ｂ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,上杉,,,\n,学科,１の４,,,\n,講義室,ダミー教室１,,,\n,代替,,,,\n,同時,情報Ａ４,1,0,\n情報Ａ,,,,,\n,開講時期等,1,１学期,必修,2\n,担当教員,針生,,,\n,学科,１の５,,,\n,講義室,101情報教室,,,\n,代替,,,,\n,同時,情報Ａ５,0,0,\n情報Ｂ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,上杉,,,\n,学科,１の５,,,\n,講義室,ダミー教室１,,,\n,代替,,,,\n,同時,情報Ａ５,1,0,\n情報Ａ,,,,,\n,開講時期等,1,１学期,必修,2\n,担当教員,岩淵,,,\n,学科,１の６,,,\n,講義室,101情報教室,,,\n,代替,,,,\n,同時,情報Ａ６,0,0,\n情報Ｂ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,上杉,,,\n,学科,１の６,,,\n,講義室,ダミー教室１,,,\n,代替,,,,\n,同時,情報Ａ６,1,0,\n情報Ａ,,,,,\n,開講時期等,1,１学期,必修,2\n,担当教員,岩淵,,,\n,学科,１の７,,,\n,講義室,101情報教室,,,\n,代替,,,,\n,同時,情報Ａ７,0,0,\n情報Ｂ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,上杉,,,\n,学科,１の７,,,\n,講義室,ダミー教室１,,,\n,代替,,,,\n,同時,情報Ａ７,1,0,\n現代文,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐竹,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐竹,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐竹,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐竹,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,松崎,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,松崎,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,松崎,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,松崎,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,松崎,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,松崎,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,松崎,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,松崎,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐竹,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐竹,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鶴岡,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鶴岡,ａｉｋｏ,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,庄司,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,庄司,ａｉｋｏ,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,横山,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,横山,ａｉｋｏ,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,横山,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,横山,ａｉｋｏ,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,横山,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,横山,ａｉｋｏ,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鶴岡,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鶴岡,ａｉｋｏ,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鶴岡,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鶴岡,ａｉｋｏ,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n保健,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鈴利,,,\n,学科,１の１,,,\n,講義室,１の１,,,\n,代替,,,,\n,同時,,,,\n保健,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,鈴利,,,\n,学科,１の２,,,\n,講義室,１の２,,,\n,代替,,,,\n,同時,,,,\n保健,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐二,,,\n,学科,１の３,,,\n,講義室,１の３,,,\n,代替,,,,\n,同時,,,,\n保健,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,佐二,,,\n,学科,１の４,,,\n,講義室,１の４,,,\n,代替,,,,\n,同時,,,,\n保健,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,長谷川,,,\n,学科,１の５,,,\n,講義室,１の５,,,\n,代替,,,,\n,同時,,,,\n保健,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,長谷川,,,\n,学科,１の６,,,\n,講義室,１の６,,,\n,代替,,,,\n,同時,,,,\n保健,,,,,\n,開講時期等,1,１学期,必修,1\n,担当教員,長谷川,,,\n,学科,１の７,,,\n,講義室,１の７,,,\n,代替,,,,\n,同時,,,,\n美術,,,,,\n,開講時期等,1,１学期,必修,2,,,,\n,担当教員,嵯峨,,,,,,,\n,学科,１の６,,,,,,,\n,講義室,101美術教室,,,,,,,\n,代替,,,,,,,,\n,同時,,,,,,,,\n美術,,,,,,,,,\n,開講時期等,1,１学期,必修,2,,,,\n,担当教員,嵯峨,,,,,,,\n,学科,１の７,,,,,,,\n,講義室,101美術教室,,,,,,,\n,代替,,,,,,,,\n,同時,,,,,,,,\nＬＨＲ,,,,,,,,,\n,開講時期等,1,１学期,必修,1,,,,\n,担当教員,横山,松崎,清水,岩館,鶴岡,針生,庄司,ダミー教員HR１\n,学科,１の１,１の２,１の３,１の４,１の５,１の６,１の７\n,講義室,１の１,１の２,１の３,１の４,１の５,１の６,１の７\n,代替,,,,,,,\n,同時,,,,,,,\nダミー,,,,,,,,\n,開講時期等,1,１学期,必修,1,,,\n,担当教員,ダミー教員１,,,,,,\n,学科,１の１,１の２,１の３,１の４,１の５,１の６,１の７\n,講義室,ダミー教室１,,,,,,\n,代替,,,,,,,\n,同時,,,,,,,\nダミー,,,,,,,,\n,開講時期等,1,１学期,必修,1,,,\n,担当教員,ダミー教員１,,,,,,\n,学科,１の１,１の２,１の３,１の４,１の５,１の６,１の７\n,講義室,ダミー教室１,,,,,,\n,代替,,,,,,,\n,同時,,,,,,,\nダミー,,,,,,,,\n,開講時期等,1,１学期,必修,1,,,\n,担当教員,ダミー教員１,,,,,,\n,学科,１の１,１の２,１の３,１の４,１の５,１の６,１の７\n,講義室,ダミー教室１,,,,,,\n,代替,,,,,,,\n,同時,,,,,,,\n保健,,,,,,,,\n,開講時期等,2,１学期,必修,1,,,\n,担当教員,高橋,,,,,,\n,学科,２の１,,,,,,\n,講義室,２の１,,,,,,\n,代替,,,,,,,\n,同時,,,,,,,\n保健,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,高橋,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n保健,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,高橋,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n保健,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,鈴木秀,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n保健,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,鈴木秀,,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n保健,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,鈴木秀,,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n保健,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,鈴木秀,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,愛澤,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,愛澤,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,愛澤,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,神成,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,神成,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,神成,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,愛澤,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,愛澤,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,愛澤,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,神成,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,神成,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,神成,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,愛澤,,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,愛澤,,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,愛澤,,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,愛澤,,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,愛澤,,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,愛澤,,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,愛澤,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,愛澤,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,愛澤,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n世界史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,山形,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n世界史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,山形,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n世界史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,浅野,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n世界史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,浅野,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n世界史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,浅野,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n世界史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,浅野,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n世界史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,浅野,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n世界史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,浅野,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n世界史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,早坂,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n世界史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,早坂,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n化学Ⅰ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,村松,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n化学Ⅰ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,村松,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n化学Ⅰ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,村松,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n化学Ⅰ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,村松,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n化学Ⅰ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,村松,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n化学Ⅰ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,村松,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n化学Ⅰ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,村松,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n化学Ⅰ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,村松,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n化学Ⅰ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,村松,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n化学Ⅰ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,村松,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n化学Ⅰ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,村松,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n化学Ⅰ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,村松,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,竹内,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,竹内,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,竹内,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,竹内,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,竹内,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,竹内,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,竹内,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,竹内,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,竹内,,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,竹内,,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,竹内,,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,竹内,,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,竹内,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,竹内,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,神保,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,神保,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,神保,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,上杉,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,上杉,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,上杉,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐藤春,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐藤春,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐藤春,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,上杉,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,上杉,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,上杉,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,狩野,,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,狩野,,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,狩野,,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n";

	String lecture_csv12 = "数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐藤春,,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐藤春,,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐藤春,,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,狩野,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,狩野,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n数学Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,狩野,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,高橋,鈴木秀,,\n,学科,２の１,２の５,,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,高橋,鈴木秀,,\n,学科,２の１,２の５,,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,高橋,鈴木秀,長谷川,\n,学科,２の２,２の４,２の６,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,高橋,鈴木秀,長谷川,\n,学科,２の２,２の４,２の６,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,高橋,長谷川,,\n,学科,２の３,２の７,,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,高橋,長谷川,,\n,学科,２の３,２の７,,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n日本史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,早坂,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n日本史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,早坂,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n日本史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,早坂,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n日本史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,黒澤,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n日本史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,黒澤,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n日本史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,黒澤,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n日本史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,黒澤,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n日本史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,黒澤,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n日本史Ａ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,黒澤,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,黒澤,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,黒澤,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,黒澤,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,黒澤,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n物理Ⅰ；生物Ⅰ,,,,,\n,開講時期等,2,１学期,選択,1\n,担当教員,池田,横橋,,\n,学科,２の１,２の２,,\n,講義室,２の１,２の２,,\n,代替,,,,\n,同時,,,,\n物理Ⅰ；生物Ⅰ,,,,,\n,開講時期等,2,１学期,選択,1\n,担当教員,池田,横橋,,\n,学科,２の１,２の２,,\n,講義室,２の１,２の２,,\n,代替,,,,\n,同時,,,,\n物理Ⅰ；生物Ⅰ,,,,,\n,開講時期等,2,１学期,選択,1\n,担当教員,池田,横橋,,\n,学科,２の１,２の２,,\n,講義室,２の１,２の２,,\n,代替,,,,\n,同時,,,,\n物理Ⅰ；生物Ⅰ,,,,,\n,開講時期等,2,１学期,選択,1\n,担当教員,池田,富永,,\n,学科,２の３,２の４,,\n,講義室,２の３,２の４,,\n,代替,,,,\n,同時,,,,\n物理Ⅰ；生物Ⅰ,,,,,\n,開講時期等,2,１学期,選択,1\n,担当教員,池田,富永,,\n,学科,２の３,２の４,,\n,講義室,２の３,２の４,,\n,代替,,,,\n,同時,,,,\n物理Ⅰ；生物Ⅰ,,,,,\n,開講時期等,2,１学期,選択,1\n,担当教員,池田,富永,,\n,学科,２の３,２の４,,\n,講義室,２の３,２の４,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,青柳,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,青柳,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,青柳,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,青柳,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,齋藤,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,齋藤,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,齋藤,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,齋藤,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐々木,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐々木,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐々木,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐々木,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,齋藤,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,齋藤,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,齋藤,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,齋藤,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,青柳,,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,青柳,,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,青柳,,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,青柳,,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐々木,,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐々木,,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐々木,,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐々木,,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,齋藤,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,齋藤,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,齋藤,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n英語Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,齋藤,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐々木,村上,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐々木,村上,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,青柳,増田,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,青柳,増田,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,青柳,村上,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,青柳,村上,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,青柳,増田,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,青柳,増田,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐々木,村上,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐々木,村上,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,青柳,増田,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,青柳,増田,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐々木,村上,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐々木,村上,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐藤春,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐藤春,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐藤春,,,\n,学科,２の１,,,\n,講義室,２の１,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐藤春,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐藤春,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,佐藤春,,,\n,学科,２の２,,,\n,講義室,２の２,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,狩野,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,狩野,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,狩野,,,\n,学科,２の３,,,\n,講義室,２の３,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,狩野,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,狩野,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,狩野,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,神保,,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,神保,,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,神保,,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,狩野,,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,狩野,,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,狩野,,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,神保,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,神保,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n数学Ⅱ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,神保,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n地理A,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,三浦,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n地理A,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,三浦,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n地理A,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,三浦,,,\n,学科,２の４,,,\n,講義室,２の４,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,増田,ａｉｋｏ,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,増田,,,\n,学科,２の５,,,\n,講義室,２の５,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,齋藤,ａｉｋｏ,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,齋藤,,,\n,学科,２の６,,,\n,講義室,２の６,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,増田,ａｉｋｏ,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n英語ＯＣ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,増田,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n生物Ⅰ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,横橋,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n生物Ⅰ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,横橋,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n生物Ⅰ,,,,,\n,開講時期等,2,１学期,必修,1\n,担当教員,横橋,,,\n,学科,２の７,,,\n,講義室,２の７,,,\n,代替,,,,\n,同時,,,,\n日本史Ａ；地理Ａ；世界史A,,,,,\n,開講時期等,2,１学期,選択,1\n,担当教員,桂島,早坂,三浦,\n,学科,２の５,２の６,,\n,講義室,２の５,２の６,２の８,\n,代替,,,,\n,同時,,,,\n日本史Ａ；地理Ａ；世界史A,,,,,\n,開講時期等,2,１学期,選択,1\n,担当教員,桂島,早坂,三浦,\n,学科,２の５,２の６,,\n,講義室,２の５,２の６,２の８,\n,代替,,,,\n,同時,,,,\n化学Ⅰ；生物Ⅰ；地学Ⅰ,,,,,\n,開講時期等,2,１学期,選択,1\n,担当教員,清水,中村,富永,\n,学科,２の５,２の６,,\n,講義室,２の５,２の６,２の８,\n,代替,,,,\n,同時,,,,\n化学Ⅰ；生物Ⅰ；地学Ⅰ,,,,,\n,開講時期等,2,１学期,選択,1\n,担当教員,清水,中村,富永,\n,学科,２の５,２の６,,\n,講義室,２の５,２の６,２の８,\n,代替,,,,\n,同時,,,,\n化学Ⅰ；生物Ⅰ；地学Ⅰ,,,,,\n,開講時期等,2,１学期,選択,1\n,担当教員,清水,中村,富永,\n,学科,２の５,２の６,,\n,講義室,２の５,２の６,２の８,\n,代替,,,,\n,同時,,,,\n日本史B；世界史Ｂ,,,,,\n,開講時期等,2,１学期,選択,1\n,担当教員,黒澤,山形,,\n,学科,２の５,２の６,,\n,講義室,２の５,２の６,,\n,代替,,,,\n,同時,,,,\n日本史B；世界史Ｂ,,,,,\n,開講時期等,2,１学期,選択,1\n,担当教員,黒澤,山形,,\n,学科,２の５,２の６,,\n,講義室,２の５,２の６,,\n,代替,,,,\n,同時,,,,\n日本史B；世界史Ｂ,,,,,\n,開講時期等,2,１学期,選択,1\n,担当教員,黒澤,山形,,\n,学科,２の５,２の６,,\n,講義室,２の５,２の６,,\n,代替,,,,\n,同時,,,,\n日本史B；世界史Ｂ,,,,,,,,,\n,開講時期等,2,１学期,選択,1,,,,\n,担当教員,黒澤,山形,,,,,,\n,学科,２の５,２の６,,,,,,\n,講義室,２の５,２の６,,,,,,\n,代替,,,,,,,,\n,同時,,,,,,,,\nＬＨＲ,,,,,,,,,\n,開講時期等,2,１学期,必修,1,,,,\n,担当教員,愛澤,高橋,佐々木,上杉,山形,富永,黒澤,ダミー教員HR２\n,学科,２の１,２の２,２の３,２の４,２の５,２の６,２の７,\n,講義室,２の１,２の２,２の３,２の４,２の５,２の６,２の７,\n,代替,,,,,,,,\n,同時,,,,,,,,\nダミー,,,,,,,,,\n,開講時期等,2,１学期,必修,1,,,,\n,担当教員,ダミー教員２,,,,,,\n,学科,２の１,２の２,２の３,２の４,２の５,２の６,２の７\n,講義室,ダミー教室２,,,,,,\n,代替,,,,,,,\n,同時,,,,,,,\nダミー,,,,,,,,\n,開講時期等,2,１学期,必修,1,,,\n,担当教員,ダミー教員２,,,,,,\n,学科,２の１,２の２,２の３,２の４,２の５,２の６,２の７\n,講義室,ダミー教室２,,,,,,\n,代替,,,,,,,\n,同時,,,,,,,\nダミー,,,,,,,,\n,開講時期等,2,１学期,必修,1,,,\n,担当教員,ダミー教員２,,,,,,\n,学科,２の１,２の２,２の３,２の４,２の５,２の６,２の７\n,講義室,ダミー教室２,,,\n,代替,,,,\n,同時,,,,\n数学Ⅲ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,菅原,,,\n,学科,３の１,,,\n,講義室,３の１,,,\n,代替,,,,\n,同時,,,,\n数学Ⅲ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,菅原,,,\n,学科,３の１,,,\n,講義室,３の１,,,\n,代替,,,,\n,同時,,,,\n数学Ⅲ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,菅原,,,\n,学科,３の１,,,\n,講義室,３の１,,,\n,代替,,,,\n,同時,,,,\n数学Ⅲ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,菅原,,,\n,学科,３の１,,,\n,講義室,３の１,,,\n,代替,,,,\n,同時,,,,\n数学Ⅲ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,菅原,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n数学Ⅲ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,菅原,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n数学Ⅲ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,菅原,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n数学Ⅲ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,菅原,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n数学Ⅲ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,木村剛,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n数学Ⅲ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,木村剛,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n数学Ⅲ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,木村剛,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n数学Ⅲ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,木村剛,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n数学Ⅲ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,木村剛,,,\n,学科,３の４,,,\n,講義室,３の４,,,\n,代替,,,,\n,同時,,,,\n数学Ⅲ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,木村剛,,,\n,学科,３の４,,,\n,講義室,３の４,,,\n,代替,,,,\n,同時,,,,\n数学Ⅲ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,木村剛,,,\n,学科,３の４,,,\n,講義室,３の４,,,\n,代替,,,,\n,同時,,,,\n数学Ⅲ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,木村剛,,,\n,学科,３の４,,,\n,講義室,３の４,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤一,,,\n,学科,３の１,,,\n,講義室,３の１,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤一,,,\n,学科,３の１,,,\n,講義室,３の１,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤一,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤一,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤一,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤一,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤一,,,\n,学科,３の４,,,\n,講義室,３の４,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤一,,,\n,学科,３の４,,,\n,講義室,３の４,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,木村篤,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,木村篤,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,木村篤,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,木村篤,,,\n,学科,３の６,,,\n,講義室,３の６,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,木村篤,,,\n,学科,３の６,,,\n,講義室,３の６,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,木村篤,,,\n,学科,３の６,,,\n,講義室,３の６,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,川上,,,\n,学科,３の７,,,\n,講義室,３の７,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,川上,,,\n,学科,３の７,,,\n,講義室,３の７,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,川上,,,\n,学科,３の７,,,\n,講義室,３の７,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,川上,,,\n,学科,３の８,,,\n,講義室,３の８,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,川上,,,\n,学科,３の８,,,\n,講義室,３の８,,,\n,代替,,,,\n,同時,,,,\n現代文,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,川上,,,\n,学科,３の８,,,\n,講義室,３の８,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,鈴利,鈴木秀,高橋,\n,学科,３の１,３の４,３の７,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,鈴利,鈴木秀,高橋,\n,学科,３の１,３の４,３の７,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,鈴利,鈴木秀,佐二,\n,学科,３の２,３の５,３の８,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,鈴利,鈴木秀,佐二,\n,学科,３の２,３の５,３の８,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,鈴木秀,佐二,,\n,学科,３の３,３の６,,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n体育,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,鈴木秀,佐二,,\n,学科,３の３,３の６,,\n,講義室,グランド,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,奥山,,,\n,学科,３の１,,,\n,講義室,３の１,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,奥山,,,\n,学科,３の１,,,\n,講義室,３の１,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,奥山,,,\n,学科,３の１,,,\n,講義室,３の１,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,奥山,,,\n,学科,３の１,,,\n,講義室,３の１,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,奥山,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,奥山,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,奥山,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,奥山,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,村上,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,村上,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,村上,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,村上,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,宇都宮,,,\n,学科,３の４,,,\n,講義室,３の４,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,宇都宮,,,\n,学科,３の４,,,\n,講義室,３の４,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,宇都宮,,,\n,学科,３の４,,,\n,講義室,３の４,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,宇都宮,,,\n,学科,３の４,,,\n,講義室,３の４,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,富岡,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,富岡,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,富岡,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,富岡,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,宇都宮,,,\n,学科,３の６,,,\n,講義室,３の６,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,宇都宮,,,\n,学科,３の６,,,\n,講義室,３の６,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,宇都宮,,,\n,学科,３の６,,,\n,講義室,３の６,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,宇都宮,,,\n,学科,３の６,,,\n,講義室,３の６,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,宇都宮,,,\n,学科,３の７,,,\n,講義室,３の７,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,宇都宮,,,\n,学科,３の７,,,\n,講義室,３の７,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,宇都宮,,,\n,学科,３の７,,,\n,講義室,３の７,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,宇都宮,,,\n,学科,３の７,,,\n,講義室,３の７,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,富岡,,,\n,学科,３の８,,,\n,講義室,３の８,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,富岡,,,\n,学科,３の８,,,\n,講義室,３の８,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,富岡,,,\n,学科,３の８,,,\n,講義室,３の８,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,富岡,,,\n,学科,３の８,,,\n,講義室,３の８,,,\n,代替,,,,\n,同時,,,,\n英語Ｒ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,富岡,,,\n,学科,３の８,,,\n,講義室,３の８,,,\n,代替,,,,\n,同時,,,,\n物理Ⅱ；生物Ⅱ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,池田,富永,,\n,学科,３の１,３の３,,\n,講義室,３の１,３の３,,\n,代替,,,,\n,同時,,,,\n物理Ⅱ；生物Ⅱ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,池田,富永,,\n,学科,３の１,３の３,,\n,講義室,３の１,３の３,,\n,代替,,,,\n,同時,,,,\n物理Ⅱ；生物Ⅱ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,池田,富永,,\n,学科,３の１,３の３,,\n,講義室,３の１,３の３,,\n,代替,,,,\n,同時,,,,\n物理Ⅱ；生物Ⅱ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,池田,富永,,\n,学科,３の１,３の３,,\n,講義室,３の１,３の３,,\n,代替,,,,\n,同時,,,,\n物理Ⅱ；生物Ⅱ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,池田,遊佐,,\n,学科,３の２,３の４,,\n,講義室,３の２,３の４,,\n,代替,,,,\n,同時,,,,\n物理Ⅱ；生物Ⅱ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,池田,遊佐,,\n,学科,３の２,３の４,,\n,講義室,３の２,３の４,,\n,代替,,,,\n,同時,,,,\n物理Ⅱ；生物Ⅱ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,池田,遊佐,,\n,学科,３の２,３の４,,\n,講義室,３の２,３の４,,\n,代替,,,,\n,同時,,,,\n物理Ⅱ；生物Ⅱ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,池田,遊佐,,\n,学科,３の２,３の４,,\n,講義室,３の２,３の４,,\n,代替,,,,\n,同時,,,,\n数学Ｂ；数学Ｃ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,菅原,木村剛,,\n,学科,３の１,３の３,,\n,講義室,３の１,３の３,,\n,代替,,,,\n,同時,,,,\n数学Ｂ；数学Ｃ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,菅原,木村剛,,\n,学科,３の１,３の３,,\n,講義室,３の１,３の３,,\n,代替,,,,\n,同時,,,,\n数学Ｂ；数学Ｃ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,菅原,木村剛,,\n,学科,３の１,３の３,,\n,講義室,３の１,３の３,,\n,代替,,,,\n,同時,,,,\n数学Ｂ；数学Ｃ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,菅原,木村剛,,\n,学科,３の２,３の４,,\n,講義室,３の２,３の４,,\n,代替,,,,\n,同時,,,,\n数学Ｂ；数学Ｃ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,菅原,木村剛,,\n,学科,３の２,３の４,,\n,講義室,３の２,３の４,,\n,代替,,,,\n,同時,,,,\n数学Ｂ；数学Ｃ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,菅原,木村剛,,\n,学科,３の２,３の４,,\n,講義室,３の２,３の４,,\n,代替,,,,\n,同時,,,,\n化学Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,渡部,,,\n,学科,３の１,,,\n,講義室,３の１,,,\n,代替,,,,\n,同時,,,,\n化学Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,渡部,,,\n,学科,３の１,,,\n,講義室,３の１,,,\n,代替,,,,\n,同時,,,,\n化学Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,渡部,,,\n,学科,３の１,,,\n,講義室,３の１,,,\n,代替,,,,\n,同時,,,,\n化学Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,渡部,,,\n,学科,３の１,,,\n,講義室,３の１,,,\n,代替,,,,\n,同時,,,,\n化学Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,渡部,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n化学Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,渡部,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n化学Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,渡部,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n化学Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,渡部,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n化学Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,渡部,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n化学Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,渡部,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n化学Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,渡部,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n化学Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,渡部,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n化学Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,清水,,,\n,学科,３の４,,,\n,講義室,３の４,,,\n,代替,,,,\n,同時,,,,\n化学Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,清水,,,\n,学科,３の４,,,\n,講義室,３の４,,,\n,代替,,,,\n,同時,,,,\n化学Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,清水,,,\n,学科,３の４,,,\n,講義室,３の４,,,\n,代替,,,,\n,同時,,,,\n化学Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,清水,,,\n,学科,３の４,,,\n,講義室,３の４,,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,木村篤,川上,,\n,学科,３の１,３の２,,\n,講義室,３の１,３の２,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,木村篤,川上,,\n,学科,３の１,３の２,,\n,講義室,３の１,３の２,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,木村篤,川上,,\n,学科,３の３,３の４,,\n,講義室,３の３,３の４,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,木村篤,川上,,\n,学科,３の３,３の４,,\n,講義室,３の３,３の４,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,雪江,木村篤,川上,\n,学科,３の５,３の６,,\n,講義室,３の５,３の６,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,雪江,木村篤,川上,\n,学科,３の５,３の６,,\n,講義室,３の５,３の６,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,雪江,木村篤,川上,\n,学科,３の７,３の８,,\n,講義室,３の７,３の８,,\n,代替,,,,\n,同時,,,,\n古典,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,雪江,木村篤,川上,\n,学科,３の７,３の８,,\n,講義室,３の７,３の８,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ；政治経済Ｂ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,浅野,早坂,,\n,学科,３の１,３の４,,\n,講義室,３の１,３の４,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ；政治経済Ｂ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,浅野,早坂,,\n,学科,３の１,３の４,,\n,講義室,３の１,３の４,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ；政治経済Ｂ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,浅野,早坂,,\n,学科,３の１,３の４,,\n,講義室,３の１,３の４,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,村上,,,\n,学科,３の１,,,\n,講義室,３の１,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,村上,,,\n,学科,３の１,,,\n,講義室,３の１,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,富岡,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,富岡,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,富岡,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,富岡,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,富岡,,,\n,学科,３の４,,,\n,講義室,３の４,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,富岡,,,\n,学科,３の４,,,\n,講義室,３の４,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,奥山,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,奥山,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,奥山,,,\n,学科,３の６,,,\n,講義室,３の６,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,奥山,,,\n,学科,３の６,,,\n,講義室,３の６,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,奥山,,,\n,学科,３の７,,,\n,講義室,３の７,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,奥山,,,\n,学科,３の７,,,\n,講義室,３の７,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,宇都宮,,,\n,学科,３の８,,,\n,講義室,３の８,,,\n,代替,,,,\n,同時,,,,\n英語Ｗ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,宇都宮,,,\n,学科,３の８,,,\n,講義室,３の８,,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,早坂,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,早坂,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,早坂,,,\n,学科,３の２,,,\n,講義室,３の２,,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,桂島,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,桂島,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,桂島,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,桂島,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,桂島,,,\n,学科,３の６,,,\n,講義室,３の６,,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,桂島,,,\n,学科,３の６,,,\n,講義室,３の６,,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,桂島,,,\n,学科,３の６,,,\n,講義室,３の６,,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,桂島,,,\n,学科,３の６,,,\n,講義室,３の６,,,\n,代替,,,,\n,同時,,,,\n地理Ｂ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,三浦,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n地理Ｂ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,三浦,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n地理Ｂ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,三浦,,,\n,学科,３の３,,,\n,講義室,３の３,,,\n,代替,,,,\n,同時,,,,\n世界史Ｂ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,山形,,,\n,学科,３の７,,,\n,講義室,３の７,,,\n,代替,,,,\n,同時,,,,\n世界史Ｂ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,山形,,,\n,学科,３の７,,,\n,講義室,３の７,,,\n,代替,,,,\n,同時,,,,\n世界史Ｂ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,山形,,,\n,学科,３の７,,,\n,講義室,３の７,,,\n,代替,,,,\n,同時,,,,\n世界史Ｂ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,山形,,,\n,学科,３の７,,,\n,講義室,３の７,,,\n,代替,,,,\n,同時,,,,\n政治経済,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,浅野,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n政治経済,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,浅野,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n政治経済,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,浅野,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n政治経済,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,浅野,,,\n,学科,３の６,,,\n,講義室,３の６,,,\n,代替,,,,\n,同時,,,,\n政治経済,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,浅野,,,\n,学科,３の６,,,\n,講義室,３の６,,,\n,代替,,,,\n,同時,,,,\n政治経済,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,浅野,,,\n,学科,３の６,,,\n,講義室,３の６,,,\n,代替,,,,\n,同時,,,,\n政治経済,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,岩館,,,\n,学科,３の７,,,\n,講義室,３の７,,,\n,代替,,,,\n,同時,,,,\n政治経済,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,岩館,,,\n,学科,３の７,,,\n,講義室,３の７,,,\n,代替,,,,\n,同時,,,,\n政治経済,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,岩館,,,\n,学科,３の７,,,\n,講義室,３の７,,,\n,代替,,,,\n,同時,,,,\n政治経済,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,岩館,,,\n,学科,３の８,,,\n,講義室,３の８,,,\n,代替,,,,\n,同時,,,,\n政治経済,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,岩館,,,\n,学科,３の８,,,\n,講義室,３の８,,,\n,代替,,,,\n,同時,,,,\n政治経済,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,岩館,,,\n,学科,３の８,,,\n,講義室,３の８,,,\n,代替,,,,\n,同時,,,,\n古典講読,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤一,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n古典講読,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤一,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n古典講読,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤一,,,\n,学科,３の６,,,\n,講義室,３の６,,,\n,代替,,,,\n,同時,,,,\n古典講読,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤一,,,\n,学科,３の６,,,\n,講義室,３の６,,,\n,代替,,,,\n,同時,,,,\n古典講読,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤一,,,\n,学科,３の７,,,\n,講義室,３の７,,,\n,代替,,,,\n,同時,,,,\n古典講読,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤一,,,\n,学科,３の７,,,\n,講義室,３の７,,,\n,代替,,,,\n,同時,,,,\n古典講読,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤一,,,\n,学科,３の８,,,\n,講義室,３の８,,,\n,代替,,,,\n,同時,,,,\n古典講読,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤一,,,\n,学科,３の８,,,\n,講義室,３の８,,,\n,代替,,,,\n,同時,,,,\n生物Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,遊佐,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n生物Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,遊佐,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n生物Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,遊佐,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n生物Ⅱ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,遊佐,,,\n,学科,３の５,,,\n,講義室,３の５,,,\n,代替,,,,\n,同時,,,,\n数学,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤春,中鉢,岩淵,\n,学科,３の５,３の６,,\n,講義室,３の５,３の６,,\n,代替,,,,\n,同時,,,,\n数学,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤春,中鉢,岩淵,\n,学科,３の５,３の６,,\n,講義室,３の５,３の６,,\n,代替,,,,\n,同時,,,,\n数学,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤春,中鉢,岩淵,\n,学科,３の５,３の６,,\n,講義室,３の５,３の６,,\n,代替,,,,\n,同時,,,,\n数学,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,佐藤春,中鉢,岩淵,\n,学科,３の５,３の６,,\n,講義室,３の５,３の６,,\n,代替,,,,\n,同時,,,,\n数学,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,神保,中鉢,岩淵,川村\n,学科,３の７,３の８,,\n,講義室,３の７,３の８,,\n,代替,,,,\n,同時,,,,\n数学,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,神保,中鉢,岩淵,川村\n,学科,３の７,３の８,,\n,講義室,３の７,３の８,,\n,代替,,,,\n,同時,,,,\n数学,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,神保,中鉢,岩淵,川村\n,学科,３の７,３の８,,\n,講義室,３の７,３の８,,\n,代替,,,,\n,同時,,,,\n数学,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,神保,中鉢,岩淵,川村\n,学科,３の７,３の８,,\n,講義室,３の７,３の８,,\n,代替,,,,\n,同時,,,,\n化学；生物；地学；音楽,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,清水,中村,富永,細倉\n,学科,３の６,３の７,３の８,\n,講義室,３の６,３の７,３の８,101音楽教室\n,代替,,,,\n,同時,,,,\n化学；生物；地学；音楽,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,清水,中村,富永,細倉\n,学科,３の６,３の７,３の８,\n,講義室,３の６,３の７,３の８,101音楽教室\n,代替,,,,\n,同時,,,,\n化学；生物；地学；音楽,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,清水,中村,富永,細倉\n,学科,３の６,３の７,３の８,\n,講義室,３の６,３の７,３の８,101音楽教室\n,代替,,,,\n,同時,,,,\n化学；生物；地学；音楽,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,清水,中村,富永,細倉\n,学科,３の６,３の７,３の８,\n,講義室,３の６,３の７,３の８,101音楽教室\n,代替,,,,\n,同時,,,,\n日本史Ｂ；世界史Ｂ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,山形,桂島,,\n,学科,３の８,,,\n,講義室,３の８,３の９,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ；世界史Ｂ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,山形,桂島,,\n,学科,３の８,,,\n,講義室,３の８,３の９,,\n,代替,,,,\n,同時,,,,\n日本史Ｂ；世界史Ｂ,,,,,\n,開講時期等,3,１学期,選択,1\n,担当教員,山形,桂島,,\n,学科,３の８,,,\n,講義室,３の８,３の９,,\n,代替,,,,\n,同時,,,,\nＬＨＲ,,,,,\n,開講時期等,3,１学期,必修,1\n,担当教員,菅原,奥山,池田,木村剛,木村篤,宇都宮,鈴木秀,富岡,ダミー教員HR３\n,学科,３の１,３の２,３の３,３の４,３の５,３の６,３の７,３の８,\n,講義室,３の１,３の２,３の３,３の４,３の５,３の６,３の７,３の８,\n,代替,,,,,,,,,\n,同時,,,,,,,,,\n総合,,,,,,,,,,\n,開講時期等,3,１学期,必修,1,,,,,\n,担当教員,菅原,奥山,池田,木村剛,木村篤,宇都宮,鈴木秀,富岡,ダミー教員HR３\n,学科,３の１,３の２,３の３,３の４,３の５,３の６,３の７,３の８,\n,講義室,３の１,３の２,３の３,３の４,３の５,３の６,３の７,３の８,\n,代替,,,,,,,,,\n,同時,,,,,,,,,\nダミー,,,,,,,,,,\n,開講時期等,3,１学期,必修,1,,,,,\n,担当教員,ダミー教員３,,,,,,,,\n,学科,３の１,３の２,３の３,３の４,３の５,３の６,３の７,３の８,\n,講義室,ダミー教室３,,,,,,,\n,代替,,,,,,,,\n,同時,,,,,,,,\nダミー,,,,,,,,,\n,開講時期等,3,１学期,必修,1,,,,\n,担当教員,ダミー教員３,,,,,,,\n,学科,３の１,３の２,３の３,３の４,３の５,３の６,３の７,３の８\n,講義室,ダミー教室３,,,,,,,\n,代替,,,,,,,,\n,同時,,,,,,,,\nダミー,,,,,,,,,\n,開講時期等,3,１学期,必修,1,,,,\n,担当教員,ダミー教員３,,,,,,,\n,学科,３の１,３の２,３の３,３の４,３の５,３の６,３の７,３の８\n,講義室,ダミー教室３,,,,,,,\n,代替,,,,,,,,\n,同時\n";

	/******************/
	/* コンストラクタ */
	/******************/
	Data_f(Data_set DS_i, Data_g DG_i)
	{
		DS  = DS_i;
		DG  = DG_i;
					// レイアウト
		setLayout(new FlowLayout(FlowLayout.CENTER));
					// 切り替えボタン
		add(new Label("　　　　　"));
		bt = new Button("大学用");
		bt.setBackground(Color.green);
		bt.addActionListener(this);
		add(bt);
		add(new Label("（クリックによって，「大学用」と「高校用」の切り替え）"));
		add(new Label("　　　　　"));
					// 講義室データ，教員データ
		add(new Label("講義室データ（"));
		room_bt = new Button("クリア");
		room_bt.setBackground(Color.yellow);
		room_bt.addActionListener(this);
		add(room_bt);
		add(new Label("）　　　　　　　　　　"));

		add(new Label("教員データ（"));
		teacher_bt = new Button("クリア");
		teacher_bt.setBackground(Color.yellow);
		teacher_bt.addActionListener(this);
		add(teacher_bt);
		add(new Label("）"));

		DS.room_data = new TextArea(5, 40);
		DS.room_data.setText(room_csv0);
		add(DS.room_data);

		DS.teacher_data = new TextArea(5, 40);
		DS.teacher_data.setText(teacher_csv0);
		add(DS.teacher_data);
					// 科目データ
		add(new Label("科目データ（"));
		lecture_bt = new Button("クリア");
		lecture_bt.setBackground(Color.yellow);
		lecture_bt.addActionListener(this);
		add(lecture_bt);
		add(new Label("）"));

		DS.lecture_data = new TextArea(10, 80);
		DS.lecture_data.setText(lecture_csv0);
		add(DS.lecture_data);
	}

	/******************************/
	/* ボタンが押されたときの処理 */
	/******************************/
	public void actionPerformed(ActionEvent e)
	{
					// 大学，高校切り替えボタン
		if (e.getSource() == bt) {
			if (DS.univ == 0) {
				DS.univ = 1;
				bt.setLabel("高校用");
				bt.setBackground(Color.pink);
				DG.lb[13].setText("同日同講義");
				DG.lb[14].setText("****");
				DG.tx[0].setText("100");
				DG.tx[1].setText("5");
				DG.tx[2].setText("123");
				DG.tx[3].setText("4");
				DG.tx[4].setText("5");
				DG.tx[5].setText("7");
				DG.tx[6].setText("10");
				DG.tx[7].setText("10");
				DG.tx[8].setText("10");
				DG.tx[9].setText("10");
				DG.tx[10].setText("7");
				DG.tx[11].setText("5");
				DG.tx[12].setText("3");
				DG.tx[13].setText("10");
				DG.tx[14].setText("0");
				DS.max_tri   = 100;
				DS.o_lvl     = 5;
				DS.seed      = 123;
				DS.mor       = 4;
				DS.week      = 5;
				DS.day       = 7;
				DS.weight[0] = 10;
				DS.weight[1] = 10;
				DS.weight[2] = 10;
				DS.weight[3] = 10;
				DS.weight[4] = 7;
				DS.weight[5] = 5;
				DS.weight[6] = 3;
				DS.weight[7] = 10;
				DS.weight[8] = 0;
				DS.room_data.setText(room_csv1);
				DS.teacher_data.setText(teacher_csv1);
				DS.lecture_data.setText(lecture_csv11);
				DS.lecture_data.append(lecture_csv12);
			}
			else {
				DS.univ = 0;
				bt.setLabel("大学用");
				bt.setBackground(Color.green);
				DG.lb[13].setText("空き　　　");
				DG.lb[14].setText("必修");
				DG.tx[0].setText("50");
				DG.tx[1].setText("5");
				DG.tx[2].setText("1234");
				DG.tx[3].setText("2");
				DG.tx[4].setText("5");
				DG.tx[5].setText("5");
				DG.tx[6].setText("10");
				DG.tx[7].setText("10");
				DG.tx[8].setText("10");
				DG.tx[9].setText("10");
				DG.tx[10].setText("7");
				DG.tx[11].setText("5");
				DG.tx[12].setText("3");
				DG.tx[13].setText("2");
				DG.tx[14].setText("1");
				DS.max_tri   = 50;
				DS.o_lvl     = 5;
				DS.seed      = 1234;
				DS.mor       = 2;
				DS.week      = 5;
				DS.day       = 5;
				DS.weight[0] = 10;
				DS.weight[1] = 10;
				DS.weight[2] = 10;
				DS.weight[3] = 10;
				DS.weight[4] = 7;
				DS.weight[5] = 5;
				DS.weight[6] = 3;
				DS.weight[7] = 2;
				DS.weight[8] = 1;
				DS.room_data.setText(room_csv0);
				DS.teacher_data.setText(teacher_csv0);
				DS.lecture_data.setText(lecture_csv0);
			}
			DS.Sch.EX.bt1.setEnabled(true);
			DS.Sch.EX.bt2.setEnabled(false);
			DS.Sch.EX.bt3.setEnabled(false);
			DS.Sch.EX.bt4.setEnabled(false);
		}
					// クリアボタン
		else if (e.getSource() == room_bt)
			DS.room_data.setText("");
		else if (e.getSource() == teacher_bt)
			DS.teacher_data.setText("");
		else if (e.getSource() == lecture_bt)
			DS.lecture_data.setText("");
	}
}

/**************/
/* 一般データ */
/**************/
class Data_g extends Panel implements TextListener {
	Data_set DS;
	TextField tx[];
	Label lb[];

	/******************/
	/* コンストラクタ */
	/******************/
	Data_g(Data_set DS_i)
	{
		DS = DS_i;
		tx = new TextField[15];
		lb = new Label[15];
					// レイアウト
		setLayout(new GridLayout(5, 6, 5, 5));
		Font f = new Font("TimesRoman", Font.BOLD, 20);
		setFont(f);
					// ラベルとテキストフィールドの追加
		String name[]  = {"最大試行回数", "出力レベル", "乱数初期値", "午前中コマ数",
		                  "講義開講日／週", "コマ数／日", "講義時間", "講義室", "教員",
		                  "教員都合", "連続", "実験（中間）", "実験（午前中）", "空き", "必修"};
		String value[] = {"50", "5", "1234", "2", "5", "5", "10", "10", "10", "10", "7",
		                  "5", "3", "2", "1"};
		if (DS.univ == 1) {
			value[0]  = "100";
			value[2]  = "123";
			value[3]  = "4";
			value[5]  = "7";
			value[13] = "10";
			value[14] = "0";
			name[13]  = "同日同講義";
			name[14]  = "***";
		}
		for (int i1 = 0; i1 < 15; i1++) {
			lb[i1] = new Label(name[i1]);
			add(lb[i1]);
			tx[i1] = new TextField(value[i1]);
			tx[i1].setBackground(Color.white);
			tx[i1].addTextListener(this);
			add(tx[i1]);
		}
					// 一般データの設定
		DS.max_tri   = (DS.univ == 0) ? 50 : 100;
		DS.o_lvl     = 5;
		DS.seed      = (DS.univ == 0) ? 1234 : 123;
		DS.mor       = (DS.univ == 0) ? 2 : 4;
		DS.week      = 5;
		DS.day       = (DS.univ == 0) ? 5 : 7;
		DS.weight[0] = 10;
		DS.weight[1] = 10;
		DS.weight[2] = 10;
		DS.weight[3] = 10;
		DS.weight[4] = 7;
		DS.weight[5] = 5;
		DS.weight[6] = 3;
		DS.weight[7] = (DS.univ == 0) ? 2 : 10;
		DS.weight[8] = (DS.univ == 0) ? 1 : 0;
	}

	/*****************************************/
	/* TextFieldの内容が変更されたときの処理 */
	/*****************************************/
	public void textValueChanged(TextEvent e)
	{
		try {
			if (e.getSource() == tx[0])
				DS.max_tri = Integer.parseInt(tx[0].getText());
			else if (e.getSource() == tx[1])
				DS.o_lvl = Integer.parseInt(tx[1].getText());
			else if (e.getSource() == tx[2])
				DS.seed = Integer.parseInt(tx[2].getText());
			else if (e.getSource() == tx[3])
				DS.mor = Integer.parseInt(tx[3].getText());
			else if (e.getSource() == tx[4])
				DS.week = Integer.parseInt(tx[4].getText());
			else if (e.getSource() == tx[5])
				DS.day = Integer.parseInt(tx[5].getText());
			else if (e.getSource() == tx[6])
				DS.weight[0] = Integer.parseInt(tx[6].getText());
			else if (e.getSource() == tx[7])
				DS.weight[1] = Integer.parseInt(tx[7].getText());
			else if (e.getSource() == tx[8])
				DS.weight[2] = Integer.parseInt(tx[8].getText());
			else if (e.getSource() == tx[9])
				DS.weight[3] = Integer.parseInt(tx[9].getText());
			else if (e.getSource() == tx[10])
				DS.weight[4] = Integer.parseInt(tx[10].getText());
			else if (e.getSource() == tx[11])
				DS.weight[5] = Integer.parseInt(tx[11].getText());
			else if (e.getSource() == tx[12])
				DS.weight[6] = Integer.parseInt(tx[12].getText());
			else if (e.getSource() == tx[13])
				DS.weight[7] = Integer.parseInt(tx[13].getText());
			else if (e.getSource() == tx[14])
				DS.weight[8] = Integer.parseInt(tx[14].getText());
		}
		catch (NumberFormatException em) {}
	}
}
